#coding=utf-8

# import logging
# logging.basicConfig(filename='logging.log',
#                     format='%(asctime)s %(message)s',
#                     filemode="w", level=logging.DEBUG)

# 更新：
# 1、可配置抓取的字段：f1.f2..fxxx
# 2、可配置一次抓取的数量：'pz': 2000,
# 3、可导出到Excel：spider.py
# 4、剩余页码可配置是否开启 break
# 5、可以设置分时数据是否开启，以及过滤条件 'ft': 1（全部，大于100手等）,
# 6、除中国股市外，其他地区无法获取分时数据
# 7、无法解析详情的包括：首页、自选股、特色行情、英股市场、期货市场
# 8、正常解析的包括：科创板、沪深个股、沪深板块、沪深指数、新三板、沪深港通、港股市场、
#   美股市场、全球指数、基金市场、债券市场、外汇市场、期权市场、黄金市场
# 9、大部分逻辑集中在crawList(self, tList)函数中，后面考虑拆分出来。
# 10、基本信息一栏加入了股吧的资讯和评论
# 11、只抓取分时数据的话约1.5个小时，但是record报错：pymongo.errors.DocumentTooLarge: 'update' command document too large
# 12、requests_get()函数加入了缓存池的设计
#20200222:
#AB股比价,AH股比价字段解析错误，期权字段解析错误；
#全球指数有一个最新行情时间的字段没有解析，（所有行情公用一种表结构）
#
#




loginParam={
    'com': {
        'pn': 1,
        'pz': 5000,
        'po': 1,
        'np': 1,
        'fltt': 2,
        'invt': 2,
        'fid': 'f3',
        'fs' :'m:1+t:23',
        'fields' :'f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f11,f12,f13,f14,f15,f16,f17,f18,f19,f20,f21,f22,f23,f24,f25,f26,f27,f28,f29,f30,f31,f32,f33,f34,f35,f36,f37,f38,f39,f40,f41,f42,f43,f44,f45,f46,f47,f48,f49,f50,f62,f128,f136,f115,f152',     #无限延伸？
    },
    'fs': {
        'pageindex': 1,
        'pagesize': 5000,  #最大300
        'sort': 1,
        'ft': 1,            #过滤条件>=？手
        'code': 688159,
        'market': 1,
        'dpt': 'wzfscj',
        'ut': '7eea3edcaed734bea9cbfc24409ed989',
    },
    'trends2': {
        'iscr': 0,
        'ndays': 1,
        'fields1': 'f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f11,f12,f13',
        'fields2': 'f51,f52,f53,f54,f55,f56,f57,f58',
        'secid': '1.600789',
    },
    'kline': {
        'fqt': 0,
        'end': '20500101',
        'klt': 0,
        'lmt': 120,
        'fields1': 'f1,f2,f3,f4,f5',
        'fields2': 'f51,f52,f53,f54,f55,f56,f57,f58',
        'secid': '1.600789',
    },
    'fflow': {
        'lmt': 100,
        'klt': 101,
        'fields1': 'f1,f2,f3,f7',
        'fields2': 'f51,f52,f53,f54,f55,f56,f57,f58,f59,f60,f61,f62,f63,f64,f65',
        'secid': '1.600789',
    },
    'info': {
        'fltt': 2,
        'invt': 2,
        'volt': 2,
        'fields': 'f43,f57,f58,f169,f170,f46,f44,f51,f168,f47,f164,f163,f116,f60,f45,f52,f50,f48,f167,f117,f71,f161,f49,f530,f135,f136,f137,f138,f139,f141,f142,f144,f145,f147,f148,f140,f143,f146,f149,f55,f62,f162,f92,f173,f104,f105,f84,f85,f183,f184,f185,f186,f187,f188,f189,f190,f191,f192,f107,f111,f86,f177,f78,f110,f262,f263,f264,f267,f268,f250,f251,f252,f253,f254,f255,f256,f257,f258,f266,f269,f270,f271,f273,f274,f275,f127,f199,f128,f198,f259,f260,f261,f171,f277,f278,f279,f288',
        'secid': '1.600789',
    },
    'guba': {
        'ps': 36,
        'sorttype': 1,
        'version': 200,
        'code': 688159,
        'product': 'Guba',
        'plat': 'Web',
    },
}

loginUrls =  {
    'proxyWeb': 'https://www.xicidaili.com/nn/',
    'proxies': {
        'http': 'http://104.224.154.185:8118',
        'https': 'https://104.224.154.185:8118',
    },
    'url':'http://17.push2.eastmoney.com/api/qt/clist/get?',
    'base':'http://quote.eastmoney.com',
    'fs':'http://push2ex.eastmoney.com/getStockFenShi?',
    'trends2':'http://push2his.eastmoney.com/api/qt/stock/trends2/get?',
    'kline':'http://74.push2his.eastmoney.com/api/qt/stock/kline/get?',
    'fflow':'http://push2.eastmoney.com/api/qt/stock/fflow/kline/get?',
    'daykline':'http://push2his.eastmoney.com/api/qt/stock/fflow/daykline/get?',
    'info':'http://push2.eastmoney.com/api/qt/stock/get?',
    'guba':'http://gbapi.eastmoney.com/webarticlelist/api/Article/Articlelist?',
}
loginHeaders = {
    'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.86 Safari/537.36',
    'Host': '17.push2.eastmoney.com',
    'Accept-Encoding': 'gzip, deflate',
    'Accept-Language': 'zh-CN,zh;q=0.8',
    'Connection':'keep-alive'
}
loginCookie=''

mainjs='''/*! QuoteCenter version @2.2.0 Copyright Eastmoney */!function(e){var t={};function r(f){if(t[f])return t[f].exports;var o=t[f]={i:f,l:!1,exports:{}};return e[f].call(o.exports,o,o.exports,r),o.l=!0,o.exports}r.m=e,r.c=t,r.d=function(e,t,f){r.o(e,t)||Object.defineProperty(e,t,{enumerable:!0,get:f})},r.r=function(e){"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})},r.t=function(e,t){if(1&t&&(e=r(e)),8&t)return e;if(4&t&&"object"==typeof e&&e&&e.__esModule)return e;var f=Object.create(null);if(r.r(f),Object.defineProperty(f,"default",{enumerable:!0,value:e}),2&t&&"string"!=typeof e)for(var o in e)r.d(f,o,function(t){return e[t]}.bind(null,o));return f},r.n=function(e){var t=e&&e.__esModule?function(){return e["default"]}:function(){return e};return r.d(t,"a",t),t},r.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},r.p="//hqres.eastmoney.com/EMQuote_Center3.0/",r(r.s=101)}([,,,,,,,function(e,t){e.exports=function r(e,t,f){e=e||{};var o,n=typeof t,a=1;"undefined"!==n&&"boolean"!==n||(f="boolean"===n&&t,t=e,e=this);"object"!=typeof t&&"[object Function]"!==Object.prototype.toString.call(t)&&(t={});for(;a<=2;){if(null!=(o=1===a?e:t))for(var i in o){var s=e[i],l=o[i];e!==l&&(f&&l&&"object"==typeof l&&!l.nodeType?e[i]=r(s||(null!=l.length?[]:{}),l,f):l!==undefined&&(e[i]=l))}a++}return e}},,,,function(e,t){e.exports=jQuery},,,,,,,,function(e,t,r){var f=r(7),o=r(20);function n(e,t,r){"string"!=typeof r&&(r="...");var f=0,o=0;str_cut=new String;for(var n=0;n<e.length;n++)a=e.charAt(n),f++,escape(a).length>4&&f++,f<=t&&o++;return f<=t?e.toString():e.substr(0,o).concat(r)}function i(e,t,r){if(t=t||"yyyy-MM-dd HH:mm:ss","string"==typeof e&&(e=new Date(e.replace(/-/g,"/").replace("T"," ").split("+")[0])),isNaN(e.getTime()))return r||"";var f={"M+":e.getMonth()+1,"d+":e.getDate(),"h+":e.getHours()%12==0?12:e.getHours()%12,"H+":e.getHours(),"m+":e.getMinutes(),"s+":e.getSeconds(),"q+":Math.floor((e.getMonth()+3)/3),S:e.getMilliseconds()};for(var o in/(y+)/.test(t)&&(t=t.replace(RegExp.$1,(e.getFullYear()+"").substr(4-RegExp.$1.length))),/(E+)/.test(t)&&(t=t.replace(RegExp.$1,(RegExp.$1.length>1?RegExp.$1.length>2?"星期":"周":"")+{0:"日",1:"一",2:"二",3:"三",4:"四",5:"五",6:"六"}[e.getDay()+""])),f)new RegExp("("+o+")").test(t)&&(t=t.replace(RegExp.$1,1==RegExp.$1.length?f[o]:("00"+f[o]).substr((""+f[o]).length)));return t}function s(e){return"object"==typeof HTMLElement?e instanceof HTMLElement:e&&"object"==typeof e&&1===e.nodeType&&"string"==typeof e.nodeName}function l(e){var t=parseFloat(e);if(!isNaN(t)){var r=t<0?-1:t>0?1:0;return t<0&&(t*=-1),t>0&&t<1e4||t<0&&t>-1e4?(t*r).toString():t>0&&t<1e6||t<0&&t>-1e6?(t/=1e4).toFixed(2)*r+"万":t>0&&t<1e7||t<0&&t>-1e7?(t/=1e4).toFixed(1)*r+"万":t>0&&t<1e8||t<0&&t>-1e8?(t/=1e4).toFixed(0)*r+"万":t>0&&t<1e10||t<0&&t>-1e10?(t/=1e8).toFixed(2)*r+"亿":t>0&&t<1e11||t<0&&t>-1e11?(t/=1e8).toFixed(1)*r+"亿":t>0&&t<1e12||t<0&&t>-1e12?(t/=1e8).toFixed(0)*r+"亿":t>0&&t<1e14||t<0&&t>-1e14?(t/=1e12).toFixed(2)+"万亿":t>0&&t<1e15||t<0&&t>-1e15?(t/=1e12).toFixed(1)*r+"万亿":t>0&&t<1e16||t<0&&t>-1e16?(t/=1e12).toFixed(0)*r+"万亿":t}return"-"}e.exports={extend:f,isDOM:s,ObjectCache:o,formatDate:i,getQueryString:function(e){var t=new RegExp("(^|&)"+e+"=([^&]*)(&|$)","i"),r=window.location.search.substr(1).match(t);if(null!=r)return unescape(r[2]);return null},cutstr:n,getMarketCode:function(e){var t=sc.substring(0,1),r=sc.substring(0,3);return"5"==t||"6"==t||"9"==t?"1":"009"==r||"126"==r||"110"==r?"1":"2"},getStockStatus:function(e){switch(parseInt(e)){case-2:return"额度不可用";case-1:return"已停牌";case 0:return"额度可用";case 1:return"已收盘";case 2:return"午盘";case 3:return"休市";case 4:return"早盘清空";case 5:return"限制买入";case 6:return"限制卖出";case 7:return"暂停交易";case 8:return"上涨熔断5%";case 9:return"上涨熔断7%";case 10:return"下跌熔断5%";case 11:return"下跌熔断7%";default:return"不存在/额度不可用"}},getColor:function(){var e=0;arguments[1]?e=parseFloat(arguments[0])-parseFloat(arguments[1]):arguments[0]&&(e=parseFloat(arguments[0]));return e>0?"red":e<0?"green":""},fixMarket:function(e){var t=e.substr(0,1),r=e.substr(0,3);return"5"==t||"6"==t||"9"==t?"1":"009"==r||"126"==r||"110"==r||"201"==r||"202"==r||"203"==r||"204"==r?"1":"2"},numbericFormat:l,blinker:function(e){var t,r=f({doms:[],color:{up:["#FFDDDD","#FFEEEE",""],down:["#b4f7af","#ccffcc",""],others:["#b2c3ea","#cedaf5",""]},interval:300,blinktime:150,circle:2},e),o=this;o.raise=!1,o.loop=0;for(var n=[],a=0;a<r.doms.length;a++){var i=r.doms[a];s(i)?n.push(i):"string"==typeof r.doms[a]&&(i=mini(r.doms[a]))&&n.push(i)}t=setInterval(function(){if(o.raise){for(var e=o.comparer>0?r.color.up:o.comparer<0?r.color.down:r.color.others,t=0;t<e.length*r.circle;t++)setTimeout(function(){for(var t=0;t<n.length;t++)n[t].style["background-color"]=e[o.loop];o.loop++,o.loop=o.loop%e.length},r.blinktime*t);o.raise=!1}},r.interval),this.stop=function(){clearInterval(t)}},toFixedFun:function(e,t){var r=parseFloat(e),f="-",o=t||2;(r>=0||r<=0)&&(f=r.toFixed(o));return f},addPercent:function(e){var t,r=parseFloat(e);t=0==r?r.toFixed(2)+"%":r?r.toFixed(2)+"%":e;return t}},Number.prototype.toFixedFit=function(e){var t=this.toPrecision(e+1);return t.substr(0,t.indexOf(".")+e)},String.prototype.cutstr=function(e,t){return n(this,e,t)},String.prototype.isPositive=function(){var e=this;if("string"==typeof e.toLowerCase())return e=e.replace("%",""),new RegExp("^([\\-\\+]?\\d+(\\.\\d+)?)$").test(e)?!new RegExp("^-").test(e):Number.NaN},String.prototype.numbericFormat=function(){return l(this.toString())},Date.prototype.pattern=function(e){return i(this,e)}},function(e,t,r){var f=r(7);function o(e){e&&f(this,e||{},!1),this.getOrAdd=function(e,t){return"undefined"==typeof this[e]&&(this[e]=t),this[e]},this.set=function(e,t){return void 0!==t&&(this[e]=t),this[e]},this.remove=function(e){var t=this[e];if("function"==typeof t)return t;try{delete this[e]}catch(r){this[e]=undefined}return t},this.clear=function(){for(var e in this)this.hasOwnProperty(e)&&this.remove(e);return this}}e.exports=o,o["default"]=new o},,,,,,,,,,,,,,,,,,,,,function(module,exports){var define=!1,toString,isArray,escMap,escFunc,escRE;window.JSON||(window.JSON={parse:function(sJSON){return eval("("+sJSON+")")},stringify:(toString=Object.prototype.toString,isArray=Array.isArray||function(e){return"[object Array]"===toString.call(e)},escMap={'"':'\\"',"\\":"\\\\","\b":"\\b","\f":"\\f","\n":"\\n","\r":"\\r","\t":"\\t"},escFunc=function(e){return escMap[e]||"\\u"+(e.charCodeAt(0)+65536).toString(16).substr(1)},escRE=/[\\"\u0000-\u001F\u2028\u2029]/g,function e(t){if(null==t)return"null";if("number"==typeof t)return isFinite(t)?t.toString():"null";if("boolean"==typeof t)return t.toString();if("object"==typeof t){if("function"==typeof t.toJSON)return e(t.toJSON());if(isArray(t)){for(var r="[",f=0;f<t.length;f++)r+=(f?", ":"")+e(t[f]);return r+"]"}if("[object Object]"===toString.call(t)){var o=[];for(var n in t)t.hasOwnProperty(n)&&o.push(e(n)+": "+e(t[n]));return"{"+o.join(", ")+"}"}}return'"'+t.toString().replace(escRE,escFunc)+'"'})}),module.exports=window.JSON},,,,,,,,,,,,,,,function(e,t,r){
/*!
 * jQuery hashchange event - v1.3 - 7/21/2010
 * http://benalman.com/projects/jquery-hashchange-plugin/
 * 
 * Copyright (c) 2010 "Cowboy" Ben Alman
 * Dual licensed under the MIT and GPL licenses.
 * http://benalman.com/about/license/
 */
e.exports=function(e,t){var r,f="hashchange",o=document,n=e.event.special,a=o.documentMode,i="on"+f in t&&(a===undefined||a>7);function s(e){return"#"+(e=e||location.href).replace(/^[^#]*#?(.*)$/,"$1")}e.fn[f]=function(e){return e?this.on(f,e):this.trigger(f)},e.fn[f].delay=50,n[f]=e.extend(n[f],{setup:function(){if(i)return!1;e(r.start)},teardown:function(){if(i)return!1;e(r.stop)}}),r=function(){var r,n,a,l={},u=s(),c=function(e){return e},d=c,m=c;function h(){var o=s(),n=m(u);o!==u?(d(u=o,n),e(t).trigger(f)):n!==u&&(location.href=location.href.replace(/#.*/,"")+n),r=setTimeout(h,e.fn[f].delay)}return l.start=function(){r||h()},l.stop=function(){r&&clearTimeout(r),r=undefined},!i&&(l.start=function(){n||(a=(a=e.fn[f].src)&&a+s(),n=e('<iframe tabindex="-1" title="empty"/>').hide().one("load",function(){a||d(s()),h()}).attr("src",a||"javascript:0").insertAfter("body")[0].contentWindow,o.onpropertychange=function(){try{"title"===event.propertyName&&(n.document.title=o.title)}catch(e){}})},l.stop=c,m=function(){return s(n.location.href)},d=function(t,r){var a=n.document,i=e.fn[f].domain;t!==r&&(a.title=o.title,a.open(),i&&a.write('<script>document.domain="'+i+'"<\/script>'),a.close(),n.location.hash=t)}),l}()}(r(11),window)},,,,,,,,,,,,,function(e,t,r){(function(t){r(41),r(70);r(72),r(73);var f=r(74),o=r(77),n=r(78),a=r(81),i=r(82);function l(e,r){this.config=n[e.type],this.mdName=r||"";var f=this.config.head;this.tableHead=f;var a={container:"",orderDur:!1,index:1,pagesize:this.config.sumcount};this.ops=t.extend(a,e),this.page=new o,this.codearr=[],this.mycontent="",this.myfs="",this._myFavor_list=null}r(85),l.prototype.Bankuai=function(e,r,f){this.fs=r,this.getBankuai(e,r,f),0!=this.ops.thclick&&(t(".dataTable thead th").css("cursor","default"),this.addEvent(e,r,f)),this.addEventSelect(e,r,f),this.add(e),this.del(e)},l.prototype.pageClick=function(e,t,r,f){var o=this;o.page.onPage=function(n){o.ops.index=n,n>r&&(o.ops.index=r),o.getDataBank(e,t,f)}},l.prototype.hoverFn=function(){t("#digest-industry").show(),t("#digest-concept").hide(),t("#digest-region").hide(),t("#digest-industry").hover(function(){t("#digest-industry").show(),t("#digest-concept").hide(),t("#digest-region").hide()}),t("#digest-concept").hover(function(){t("#digest-industry").hide(),t("#digest-concept").show(),t("#digest-region").hide()}),t("#digest-region").hover(function(){t("#digest-industry").hide(),t("#digest-concept").hide(),t("#digest-region").show()})},l.prototype.getBankuai=function(e,t,r){0!=this.getParam("sr")&&1!=this.getParam("sr")||(this.ops.orderDur=!0),-1==this.getParam("sr")&&(this.ops.orderDur=!1),this.getParam("st")&&(this.ops.order=a[this.getParam("st")]);var f=window.location.href.split("#")[1];if("region_board"==f||"concept_board"==f||"industry_board"==f)0==this.ops.orderDur&&(this.tableHead[10].title="领涨股票",this.tableHead[10].key="f128",this.tableHead[11].key="f136",this.tableHead[11].color="f136",this.createHead(e,t),this.getDataBank(e,t,r)),1==this.ops.orderDur&&(this.tableHead[10].title="领跌股票",this.tableHead[10].key="f128",this.tableHead[11].key="f136",this.tableHead[11].color="f222",this.createHead(e,t),this.getDataBank(e,t,r));else{var o={PB:"市净率",MarketValue:"总市值",FlowCapitalValue:"流通市值",FlowCapitalValue:"流通市值",ChangePercent60Day:"60日涨跌幅",ChangePercent360Day:"年初至今涨跌幅",Speed:"涨速",FiveMinuteChangePercent:"5分钟涨跌",VolumeRate:"量比"};if(this.getParam("st")){for(var n=0;n<this.tableHead.length;n++){var i=this.tableHead[n].title;"总市值"!=i&&"流通市值"!=i&&"60日涨跌幅"!=i&&"年初至今涨跌幅"!=i&&"涨速"!=i&&"5分钟涨跌"!=i&&"量比"!=i||(this.tableHead[n].show=!1),i==o[this.getParam("st")]&&(this.tableHead[n].show=!0)}this.createHead(e,t),this.getDataBank(e,t,r)}else this.createHead(e,t),this.getDataBank(e,t,r)}},l.prototype.createHead=function(e,r){for(var f=this.tableHead,o=t('<tr role="row"></tr>'),n=0;n<f.length;n++){var a=f[n];if(a&&1==a.show){if("序号"==a.title||"加自选"==a.title||0==a.order)var i=t('<th style="" class="listview-col-'+a.name+' sorting_disabled" rowspan="1" colspan="1" aria-label="'+a.title+'"><span style="color:#333">'+a.title+'</span><b class="icon"></b></th>');else if(a.key==this.ops.order)if(1==this.ops.orderDur)if("zgValue"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting_asc" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="转股价值=正股价/转股价*100" class="tooltip-f">转股价值<em class="help-icon"></em></span></span><b class="icon"></b></th>');else if("zgYjb"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting_asc" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="转股溢价率 = （转债最新价 – 转股价值）/ 转股价值" class="tooltip-f">转股溢价率<em class="help-icon"></em></span></span><b class="icon"></b></th>');else if("czYjl"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting_asc" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="纯债溢价率 = （转债最新价 – 纯债价值）/ 纯债价值" class="tooltip-f">纯债溢价率<em class="help-icon"></em></span></span><b class="icon"></b></th>');else if("hsCfj"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting_asc" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="满足回售触发条件时，可转债持有人有权将其持有的可转债全部或部分按债券面值加上当期应计利息的价格回售给公司" class="tooltip-f">回售触发价<em class="help-icon"></em></span></span><b class="icon"></b></th>');else if("qsCfj"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting_asc" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="满足赎回触发条件时，公司有权按照债券面值加当期应计利息的价格赎回全部或部分未转股的可转债" class="tooltip-f">强赎触发价<em class="help-icon"></em></span></span><b class="icon"></b></th>');else if("dqShj"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting_asc" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="公司有权以债券发行说明书中规定的到期赎回价买回其发行在外债券" class="tooltip-f">到期赎回价<em class="help-icon"></em></span></span><b class="icon"></b></th>');else i=t('<th style="" class="listview-col-'+a.name+' sorting_asc" rowspan="1" colspan="1" aria-label="'+a.title+'"><span>'+a.title+'</span><b class="icon"></b></th>');else if("zgValue"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting_desc" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="转股价值=正股价/转股价*100" class="tooltip-f">转股价值<em class="help-icon"></em></span></span><b class="icon"></b></th>');else if("zgYjb"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting_desc" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="转股溢价率 = （转债最新价 – 转股价值）/ 转股价值" class="tooltip-f">转股溢价率<em class="help-icon"></em></span></span><b class="icon"></b></th>');else if("czYjl"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting_desc" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="纯债溢价率 = （转债最新价 – 纯债价值）/ 纯债价值" class="tooltip-f">纯债溢价率<em class="help-icon"></em></span></span><b class="icon"></b></th>');else if("hsCfj"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting_desc" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="满足回售触发条件时，可转债持有人有权将其持有的可转债全部或部分按债券面值加上当期应计利息的价格回售给公司" class="tooltip-f">回售触发价<em class="help-icon"></em></span></span><b class="icon"></b></th>');else if("qsCfj"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting_desc" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="满足赎回触发条件时，公司有权按照债券面值加当期应计利息的价格赎回全部或部分未转股的可转债" class="tooltip-f">强赎触发价<em class="help-icon"></em></span></span><b class="icon"></b></th>');else if("dqShj"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting_desc" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="公司有权以债券发行说明书中规定的到期赎回价买回其发行在外债券" class="tooltip-f">到期赎回价<em class="help-icon"></em></span></span><b class="icon"></b></th>');else i=t('<th style="" class="listview-col-'+a.name+' sorting_desc" rowspan="1" colspan="1" aria-label="'+a.title+'"><span>'+a.title+'</span><b class="icon"></b></th>');else if("zgValue"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="转股价值=正股价/转股价*100" class="tooltip-f">转股价值<em class="help-icon"></em></span></span><b class="icon"></b></th>');else if("zgYjb"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="转股溢价率 = （转债最新价 – 转股价值）/ 转股价值" class="tooltip-f">转股溢价率<em class="help-icon"></em></span></span><b class="icon"></b></th>');else if("czYjl"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="纯债溢价率 = （转债最新价 – 纯债价值）/ 纯债价值" class="tooltip-f">纯债溢价率<em class="help-icon"></em></span></span><b class="icon"></b></th>');else if("hsCfj"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="满足回售触发条件时，可转债持有人有权将其持有的可转债全部或部分按债券面值加上当期应计利息的价格回售给公司" class="tooltip-f">回售触发价<em class="help-icon"></em></span></span><b class="icon"></b></th>');else if("qsCfj"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="满足赎回触发条件时，公司有权按照债券面值加当期应计利息的价格赎回全部或部分未转股的可转债" class="tooltip-f">强赎触发价<em class="help-icon"></em></span></span><b class="icon"></b></th>');else if("dqShj"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="公司有权以债券发行说明书中规定的到期赎回价买回其发行在外债券" class="tooltip-f">到期赎回价<em class="help-icon"></em></span></span><b class="icon"></b></th>');else i=t('<th style="" class="listview-col-'+a.name+' sorting" rowspan="1" colspan="1" aria-label="'+a.title+'"><span>'+a.title+'</span><b class="icon"></b></th>');i.attr("data-key",a.key),o.append(i)}}t(e).find("table thead").html(""),t(e).find("table thead").append(o)},l.prototype.getDataBank=function(e,r,o){var n=this,a=this.ops,i=this.config,s={fid:a.order,po:a.orderDur?"0":"1",pn:a.index,pz:i.sumcount,fs:r,fields:i.fields};f(s,function(f){var i=f.data;if(i){var s=i.diff,l=i.total,u=Math.ceil(l/a.pagesize);if(a.sumPage=u,u>1)n.page.setOps({index:a.index,sumPage:a.sumPage}),n.pageClick(e,r,u,o),t(".dataTables_paginate").show();else t(".dataTables_paginate").hide();n.setBody(e,s,o)}else s=[],t(".dataTables_paginate").hide(),n.setBody(e,s,o)})},l.prototype.addEvent=function(e,r,f){var o=this;t(e).find("thead").off(),t(e).find("thead").on("click","th",function(){var n=t(this).attr("data-key");if(n&&"addzixuan"!=n){n==o.ops.order?o.ops.orderDur=!o.ops.orderDur:(o.ops.order=n,o.ops.orderDur=!0);var a=window.location.href.split("#")[1];"region_board"==a||"concept_board"==a||"industry_board"==a?(0==o.ops.orderDur&&(o.tableHead[10].title="领涨股票",o.tableHead[10].key="f128",o.tableHead[11].key="f136",o.tableHead[11].color="f136",o.createHead(e,r),o.getDataBank(e,r,f)),1==o.ops.orderDur&&(o.tableHead[10].title="领跌股票",o.tableHead[10].key="f207",o.tableHead[11].key="f222",o.tableHead[11].color="f222",o.createHead(e,r),o.getDataBank(e,r,f))):(o.createHead(e,r),o.getDataBank(e,r,f))}})},l.prototype.addEventSelect=function(e,r){var f=this;t("#custom-fields").change(function(){for(var o=t(this).val(),n={PB:"市净率",MarketValue:"总市值",FlowCapitalValue:"流通市值",ChangePercent60Day:"60日涨跌幅",ChangePercent360Day:"年初至今涨跌幅",Speed:"涨速",FiveMinuteChangePercent:"5分钟涨跌",VolumeRate:"量比"},a=0;a<f.tableHead.length;a++){var i=f.tableHead[a].title;"市净率"!=i&&"总市值"!=i&&"流通市值"!=i&&"60日涨跌幅"!=i&&"年初至今涨跌幅"!=i&&"涨速"!=i&&"5分钟涨跌"!=i&&"量比"!=i||(f.tableHead[a].show=!1),i==n[o]&&(f.tableHead[a].show=!0)}f.createHead(e,r),f.createBody(e,r)})},l.prototype.setBody=function(e,t,r){var f=this;if(f.body=t,1==f.ops.zixuan){if(r)o(r);else i.getDefaultStocks().then(function(e){o(e)});function o(t){if(t){f.zixuanList=t.split(",");for(var r=0;r<f.body.length;r++){var o=f.body[r],n=o.f13+"."+o.f12,a=!1;a=!!f.in_array(n,f.zixuanList),o.isZisuan=a}f.createBody(e)}}}f.createBody(e)},l.prototype.add=function(e){t(e+"-table").on("click",".addzx",function(){var e=t(this),r=t(this).attr("data-myscode");i.add(r).then(function(t){1==t&&(e.addClass("hide"),e.removeClass("show"),e.siblings(".delzx").addClass("show"),e.siblings(".delzx").removeClass("hide"))})}),t("#optional-blocks-wrapper").off(),t("#optional-blocks-wrapper").on("click",".addzx",function(e){var r=t(this),f=t(this).attr("data-myscode");i.add(f).then(function(e){1==e&&(r.addClass("hide"),r.removeClass("show"),r.siblings(".delzx").addClass("show"),r.siblings(".delzx").removeClass("hide"))}),e.stopPropagation()})},l.prototype.del=function(e){t(e+"-table").on("click",".delzx",function(){var e=t(this),r=t(this).attr("data-myscode");i.del(r).then(function(t){e.addClass("hide"),e.removeClass("show"),e.siblings(".addzx").addClass("show"),e.siblings(".addzx").removeClass("hide")})}),t("#optional-blocks-wrapper").on("click",".delzx",function(){var e=t(this),r=t(this).attr("data-myscode");i.del(r).then(function(t){e.addClass("hide"),e.removeClass("show"),e.siblings(".addzx").addClass("show"),e.siblings(".addzx").removeClass("hide")})})},l.prototype.getKcbHQData=function(e){var r={secids:e,pz:20,pi:0,ut:"bd1d9ddb04089700cf9c27f6f7426281",po:1,fields:"f2,f3,f4,f5,f6,f12",fltt:2,invt:2,np:1};return t.ajax({type:"get",data:r,url:"http://push2.eastmoney.com/api/qt/ulist/get?",dataType:"jsonp",jsonp:"cb"})},l.prototype.getParam=function(e){var t=location.search,r={};if(""!=t)for(var f,o,n=(t=t.substring(1,t.length)).split("&"),a=0;a<n.length;a++)f=n[a].substring(0,n[a].indexOf("=")),o=n[a].substring(n[a].indexOf("=")+1,n[a].length),r[f]=o;return"undefined"!=typeof r[e]?r[e]:null},l.prototype.formatData=function(){for(var e=this.body,t=["f2","f4","f15","f16","f17","f18","f28","f31","f32"].join(",")+",",r=["f3","f7","f8","f9","f10","f11","f22","f23","f24","f25","f33"].join(",")+",",f=["f115"].join(",")+",",o=0,n=e.length;o<n;o++){var a=e[o],i=Math.pow(10,a.f1);for(var s in a)if(t.indexOf(s+",")>-1&&(a[s]=(a[s]/i).toFixed(a.f1)),r.indexOf(s+",")>-1&&(a[s]=(a[s]/100).toFixed(2)),f.indexOf(s+",")>-1){var l=Math.pow(10,a.f152);a[s]=(a[s]/l).toFixed(a.f152)}}},l.prototype.createBody=function(e){var r=t(e+"-table").find("tbody");0==r.length&&(r=t(e).find("tbody"));var f=t(r);f.html("");for(var o=this.body,n=this.tableHead,a=0;a<o.length;a++){var i=o[a],s=t("<tr></tr>");a%2==0?s.addClass("odd"):s.addClass("even");for(var l=0;l<n.length;l++){var u=n[l];if(u&&1==u.show){var c="",d=t("<td></td>");if("名称"==u.title||"领涨股"==u.title||"领跌股"==u.title||"主力流入最大股"==u.title)d=t("<td class='mywidth'></td>");if("板块名称"==u.title||"领涨股票"==u.title||"领跌股票"==u.title)d=t("<td class='mywidth3'></td>");if("名称"==u.title&&"usindex_name"==u.name)if(5==i.f107)d=t("<td class='mywidth' style='text-align:left;padding-left:5px;'><em class='circle' title='已收盘'>●</em></td>");else if(3==i.f107)d=t("<td class='mywidth' style='text-align:left;padding-left:5px;'><em class='circle' title='盘中休息'>●</em></td>");else d=t("<td class='mywidth' style='text-align:left;padding-left:5px;'><em class='trading' title='交易中'>●</em></td>");if("最新价"==u.title||"涨跌幅"==u.title)d=t("<td class='mywidth2'></td>");if("相关链接"==u.title&&"Links"==u.name)d=t('<td class=" listview-col-Links"><a href="http://guba.eastmoney.com/list,'+i.f12+'.html">股吧</a>&nbsp;<a href="http://data.eastmoney.com/zjlx/'+i.f12+'.html">资金流</a>&nbsp;<a href="http://data.eastmoney.com/stockdata/'+i.f12+'.html">数据</a></td>');if("相关链接"==u.title&&"Links_abgu"==u.name)d=t('<td class=" listview-col-Links"><a href="http://guba.eastmoney.com/list,'+i.f201+'.html">股吧</a>&nbsp;<a href="http://data.eastmoney.com/zjlx/'+i.f201+'.html">资金流</a>&nbsp;<a href="http://data.eastmoney.com/stockdata/'+i.f201+'.html">数据</a></td>');if("相关链接"==u.title&&"neeq_stocks"==u.name)d=t('<td class=" listview-col-neeq_stocks"><a href="http://guba.eastmoney.com/list,'+i.f12+'.html">股吧</a>&nbsp;<a href="http://so.eastmoney.com/Web/s?keyword='+i.f14+'">资讯</a></td>');if("相关链接"==u.title&&"hk_stocks"==u.name)if(3==i.f19||4==i.f19)d=t('<td class=" listview-col-Links"><a href="http://guba.eastmoney.com/list,hk'+i.f12+'.html">股吧</a>&nbsp;<a href="http://so.eastmoney.com/Web/s?keyword='+i.f14+'">资讯</a>&nbsp;<a href="http://emweb.securities.eastmoney.com/PC_HKF10/CoreReading/index?type=web&code='+i.f12+'&color=b">档案</a></td>');else d=t('<td class=" listview-col-Links">&nbsp;<a href="http://so.eastmoney.com/Web/s?keyword='+i.f14+'">资讯</a>&nbsp;</td>');if("相关链接"==u.title&&"concept_board"==u.name)d=t('<td class=" listview-col-Links"><a href="http://guba.eastmoney.com/list,'+i.f12+'.html">股吧</a>&nbsp;<a href="http://data.eastmoney.com/bkzj/'+i.f12+'.html">资金流</a>&nbsp;<a href="http://data.eastmoney.com/report/'+i.f12.substr(3,3)+'yb.html">研报</a></td>');if("相关链接"==u.title&&"fullscreen_Links"==u.name)d=t('<td class=" listview-col-Links"><a href="http://guba.eastmoney.com/list,'+i.f12+'.html">股吧</a>&nbsp;<a href="http://data.eastmoney.com/kzz/detail/'+i.f12+'.html">详细</a>&nbsp;</td>');if("相关链接"==u.title&&"fundcloseend_Links"==u.name)d=t('<td class=" listview-col-Links"><a href="http://fund.eastmoney.com/'+i.f12+'.html">估算图</a>&nbsp;<a href="http://guba.eastmoney.com/list,of'+i.f12+'.html">基金吧</a>&nbsp;<a href="http://fund.eastmoney.com/f10/'+i.f12+'.html">档案</a></td>');if("涨跌家数"==u.title&&"zhangdiejia"==u.name)d=t('<td><span style="color: red;">'+i.f104+'</span>/<span style="color: green;">'+i.f105+"</span></td>");if("买量"==u.title&&"buycount"==u.name)d=t('<td style="color: red;"></td>');if("上涨家数"==u.title)d=t('<td style="color: red;"></td>');if("下跌家数"==u.title)d=t('<td style="color: green;"></td>');if("卖量"==u.title&&"sellcount"==u.name)d=t('<td style="color: green;"></td>');if("港股吧"==u.title)d=t('<td class=" listview-col-Links"><a href="http://guba.eastmoney.com/list,hk'+i.f12+'.html">港股吧</a></td>');if("A股吧"==u.title)d=t('<td class=" listview-col-Links"><a href="http://guba.eastmoney.com/topic,'+i.f191+'.html">A股吧</a></td>');if("名称"==u.title&&"mgsc_name"==u.name)d=t("<td class='text_overflow' title='"+i.f14+"'></td>");var m=i.f13+"."+i.f12;if("加自选"==u.title)if(0==i.isZisuan)d=t('<td class=" listview-col-add"><a class="addzx show" target="_self" onclick="return false;" href="javascript:void(0);" data-myscode='+m+'></a><a class="delzx hide" target="_self" onclick="return false;" href="javascript:void(0);" data-myscode='+m+"></a></td>");else if(1==i.isZisuan)d=t('<td class=" listview-col-add"><a class="addzx hide" target="_self" onclick="return false;" href="javascript:void(0);" data-myscode='+m+'></a><a class="delzx show" target="_self" onclick="return false;" href="javascript:void(0);" data-myscode='+m+"></a></td>");else d=t('<td class=" listview-col-add"><a class="addzx show" target="_self" onclick="return false;" href="javascript:void(0);" data-myscode='+m+'></a><a class="delzx hide" target="_self" onclick="return false;" href="javascript:void(0);" data-myscode='+m+"></a></td>");if(u.type)"seq"==u.type&&d.text(a+1+this.ops.pagesize*(this.ops.index-1));else{var h="";if(u.key&&(h=i[u.key]),u.cb&&(h=u.cb(i[u.key],i)),u.newcb&&(h=u.newcb(i[u.key],i[u.fixedkey])),u.suffix&&(h+=u.suffix),u.color!==undefined){c=t("<span></span>");var b,y,w=u.color;"number"==typeof w?(b=i[u.key],y=w):0==w.indexOf("_")?(b=i[u.key],y=i[w.substr(1)]):(b=i[w],y=0);var k=b-y;k>0?c.addClass("red"):k<0?c.addClass("green"):c.addClass("fair")}if(u.href){for(var p=u.data,g=u.href,x=0;x<p.length;x++){var N=RegExp("\\{\\{"+x+"\\}\\}"),_=i[p[x]];"128"==_&&(_="116"),g=g.replace(N,_)}c=t(g)}c?(c.text(h),d.append(c),u.wenhaoFlag&&"欧洲斯托克50"==i[u.key]&&d.append(t(u.wenhaoFlag))):d.text(h)}s.append(d)}}f.append(s)}},l.prototype.in_array=function(e,t){for(s=0;s<t.length;s++)if(thisEntry=t[s].toString(),thisEntry==e)return!0;return!1},e.exports=l}).call(this,r(11))},function(e,t,r){var f=r(11);r(71),e.exports=function(e){function t(t){var r=e.data(t,"tooltip");r.showTimer&&(clearTimeout(r.showTimer),r.showTimer=null),r.hideTimer&&(clearTimeout(r.hideTimer),r.hideTimer=null)}function r(t,r){var f=e.data(t,"tooltip"),o=f.options;if(r&&(o.content=r),f.tip){var n="function"==typeof o.content?o.content.call(t):o.content;f.tip.children(".tooltip-content").html(n),o.onUpdate.call(t,n)}}e.fn.tooltip=function(t,f){return"string"==typeof t?e.fn.tooltip.methods[t](this,f):(t=t||{},this.each(function(){var f,o,n=e.data(this,"tooltip");n?e.extend(n.options,t):(e.data(this,"tooltip",{options:e.extend({},e.fn.tooltip.defaults,e.fn.tooltip.parseOptions(this),t)}),e(this).addClass("tooltip-f")),f=this,o=e.data(f,"tooltip").options,e(f).unbind(".tooltip").bind(o.showEvent+".tooltip",function(t){e(f).tooltip("show",t)}).bind(o.hideEvent+".tooltip",function(t){e(f).tooltip("hide",t)}).bind("mousemove.tooltip",function(t){o.trackMouse&&(o.trackMouseX=t.pageX,o.trackMouseY=t.pageY,e(f).tooltip("reposition"))}),r(this)}))},e.fn.tooltip.methods={options:function(t){return e.data(t[0],"tooltip").options},tip:function(t){return e.data(t[0],"tooltip").tip},arrow:function(e){return e.tooltip("tip").children(".tooltip-arrow-outer,.tooltip-arrow")},show:function(f,o){return f.each(function(){!function(f,o){var n=e.data(f,"tooltip"),a=n.options,i=n.tip;i||(i=e('<div tabindex="-1" class="tooltip"><div class="tooltip-content"></div><div class="tooltip-arrow-outer"></div><div class="tooltip-arrow"></div></div>').appendTo("body"),n.tip=i,r(f)),t(f),n.showTimer=setTimeout(function(){e(f).tooltip("reposition"),i.show(),a.onShow.call(f,o);var t=i.children(".tooltip-arrow-outer"),r=i.children(".tooltip-arrow"),n="border-"+a.position+"-color";t.add(r).css({borderTopColor:"",borderBottomColor:"",borderLeftColor:"",borderRightColor:""}),t.css(n,i.css(n)),r.css(n,i.css("backgroundColor"))},a.showDelay)}(this,o)})},hide:function(r,f){return r.each(function(){!function(r,f){var o=e.data(r,"tooltip");o&&o.tip&&(t(r),o.hideTimer=setTimeout(function(){o.tip.hide(),o.options.onHide.call(r,f)},o.options.hideDelay))}(this,f)})},update:function(e,t){return e.each(function(){r(this,t)})},reposition:function(t){return t.each(function(){!function(t){var r=e.data(t,"tooltip");if(r&&r.tip){var f=r.options,o=r.tip,n={left:-1e5,top:-1e5};if(e(t).is(":visible"))if(n=i(f.position),"top"==f.position&&n.top<0?n=i("bottom"):"bottom"==f.position&&n.top+o._outerHeight()>e(window)._outerHeight()+e(document).scrollTop()&&(n=i("top")),n.left<0)"left"==f.position?n=i("right"):(e(t).tooltip("arrow").css("left",o._outerWidth()/2+n.left),n.left=0);else if(n.left+o._outerWidth()>e(window)._outerWidth()+e(document)._scrollLeft())if("right"==f.position)n=i("left");else{var a=n.left;n.left=e(window)._outerWidth()+e(document)._scrollLeft()-o._outerWidth(),e(t).tooltip("arrow").css("left",o._outerWidth()/2-(n.left-a))}o.css({left:n.left,top:n.top,zIndex:f.zIndex!=undefined?f.zIndex:e.fn.window?e.fn.window.defaults.zIndex++:""}),f.onPosition.call(t,n.left,n.top)}function i(r){var n,a;f.position=r||"bottom",o.removeClass("tooltip-top tooltip-bottom tooltip-left tooltip-right").addClass("tooltip-"+f.position);var i=e.isFunction(f.deltaX)?f.deltaX.call(t,f.position):f.deltaX,s=e.isFunction(f.deltaY)?f.deltaY.call(t,f.position):f.deltaY;if(f.trackMouse)l=e(),n=f.trackMouseX+i,a=f.trackMouseY+s;else{var l=e(t);n=l.offset().left+i,a=l.offset().top+s}switch(f.position){case"right":n+=l._outerWidth()+12+(f.trackMouse?12:0),a-=(o._outerHeight()-l._outerHeight())/2;break;case"left":n-=o._outerWidth()+12+(f.trackMouse?12:0),a-=(o._outerHeight()-l._outerHeight())/2;break;case"top":n-=(o._outerWidth()-l._outerWidth())/2,a-=o._outerHeight()+12+(f.trackMouse?12:0);break;case"bottom":n-=(o._outerWidth()-l._outerWidth())/2,a+=l._outerHeight()+12+(f.trackMouse?12:0)}return{left:n,top:a}}}(this)})},destroy:function(r){return r.each(function(){!function(r){var f=e.data(r,"tooltip");if(f){t(r);var o=f.options;f.tip&&f.tip.remove(),o._title&&e(r).attr("title",o._title),e.removeData(r,"tooltip"),e(r).unbind(".tooltip").removeClass("tooltip-f"),o.onDestroy.call(r)}}(this)})}},e.fn.tooltip.parseOptions=function(t){var r=e(t),f=e.extend({},e.parser.parseOptions(t,["position","showEvent","hideEvent","content",{trackMouse:"boolean",deltaX:"number",deltaY:"number",showDelay:"number",hideDelay:"number"}]),{_title:r.attr("title")});return r.attr("title",""),f.content||(f.content=f._title),f},e.fn.tooltip.defaults={position:"bottom",content:null,trackMouse:!1,deltaX:0,deltaY:0,showEvent:"mouseenter",hideEvent:"mouseleave",showDelay:200,hideDelay:100,onShow:function(e){},onHide:function(e){},onUpdate:function(e){},onPosition:function(e,t){},onDestroy:function(){}}}(f)},function(e,t,r){(function(t){var r;e.exports=((r=t).easyui={indexOfArray:function(e,t,r){for(var f=0,o=e.length;f<o;f++)if(r==undefined){if(e[f]==t)return f}else if(e[f][t]==r)return f;return-1},removeArrayItem:function(e,t,r){if("string"==typeof t){for(var f=0,o=e.length;f<o;f++)if(e[f][t]==r)return void e.splice(f,1)}else{var n=this.indexOfArray(e,t);-1!=n&&e.splice(n,1)}},addArrayItem:function(e,t,r){var f=this.indexOfArray(e,t,r?r[t]:undefined);-1==f?e.push(r||t):e[f]=r||t},getArrayItem:function(e,t,r){var f=this.indexOfArray(e,t,r);return-1==f?null:e[f]},forEach:function(e,t,r){for(var f=[],o=0;o<e.length;o++)f.push(e[o]);for(;f.length;){var n=f.shift();if(0==r(n))return;if(t&&n.children)for(o=n.children.length-1;o>=0;o--)f.unshift(n.children[o])}}},r.parser={auto:!0,onComplete:function(e){},plugins:["draggable","droppable","resizable","pagination","tooltip","linkbutton","menu","menubutton","splitbutton","switchbutton","progressbar","tree","textbox","passwordbox","filebox","combo","combobox","combotree","combogrid","combotreegrid","tagbox","numberbox","validatebox","searchbox","spinner","numberspinner","timespinner","datetimespinner","calendar","datebox","datetimebox","slider","layout","panel","datagrid","propertygrid","treegrid","datalist","tabs","accordion","window","dialog","form"],parse:function(e){for(var t=[],f=0;f<r.parser.plugins.length;f++){var o=r.parser.plugins[f],n=r(".easyui-"+o,e);n.length&&(n[o]?n.each(function(){r(this)[o](r.data(this,"options")||{})}):t.push({name:o,jq:n}))}if(t.length&&window.easyloader){var a=[];for(f=0;f<t.length;f++)a.push(t[f].name);easyloader.load(a,function(){for(var f=0;f<t.length;f++){var o=t[f].name;t[f].jq.each(function(){r(this)[o](r.data(this,"options")||{})})}r.parser.onComplete.call(r.parser,e)})}else r.parser.onComplete.call(r.parser,e)},parseValue:function(e,t,f,o){o=o||0;var n=r.trim(String(t||""));return"%"==n.substr(n.length-1,1)?(n=parseFloat(n.substr(0,n.length-1)),n=e.toLowerCase().indexOf("width")>=0?Math.floor((f.width()-o)*n/100):Math.floor((f.height()-o)*n/100)):n=parseInt(n)||undefined,n},parseOptions:function(e,t){var f=r(e),o={},n=r.trim(f.attr("data-options"));if(n&&("{"!=n.substring(0,1)&&(n="{"+n+"}"),o=new Function("return "+n)()),r.map(["width","height","left","top","minWidth","maxWidth","minHeight","maxHeight"],function(t){var f=r.trim(e.style[t]||"");f&&(-1==f.indexOf("%")&&(f=parseInt(f),isNaN(f)&&(f=undefined)),o[t]=f)}),t){for(var a={},i=0;i<t.length;i++){var s=t[i];if("string"==typeof s)a[s]=f.attr(s);else for(var l in s){var u=s[l];"boolean"==u?a[l]=f.attr(l)?"true"==f.attr(l):undefined:"number"==u&&(a[l]="0"==f.attr(l)?0:parseFloat(f.attr(l))||undefined)}}r.extend(o,a)}return o}},r(function(){var e=r('<div style="position:absolute;top:-1000px;width:100px;height:100px;padding:5px"></div>').appendTo("body");r._boxModel=100!=e.outerWidth(),e.remove(),e=r('<div style="position:fixed"></div>').appendTo("body"),r._positionFixed="fixed"==e.css("position"),e.remove(),!window.easyloader&&r.parser.auto&&r.parser.parse()}),r.fn._outerWidth=function(e){return e==undefined?this[0]==window?this.width()||document.body.clientWidth:this.outerWidth()||0:this._size("width",e)},r.fn._outerHeight=function(e){return e==undefined?this[0]==window?this.height()||document.body.clientHeight:this.outerHeight()||0:this._size("height",e)},r.fn._scrollLeft=function(e){return e==undefined?this.scrollLeft():this.each(function(){r(this).scrollLeft(e)})},r.fn._propAttr=r.fn.prop||r.fn.attr,void(r.fn._size=function(e,t){return"string"==typeof e?"clear"==e?this.each(function(){r(this).css({width:"",minWidth:"",maxWidth:"",height:"",minHeight:"",maxHeight:""})}):"fit"==e?this.each(function(){f(this,"BODY"==this.tagName?r("body"):r(this).parent(),!0)}):"unfit"==e?this.each(function(){f(this,r(this).parent(),!1)}):t==undefined?n(this[0],e):this.each(function(){n(this,e,t)}):this.each(function(){t=t||r(this).parent(),r.extend(e,f(this,t,e.fit)||{});var n=o(this,"width",t,e),a=o(this,"height",t,e);n||a?r(this).addClass("easyui-fluid"):r(this).removeClass("easyui-fluid")});function f(e,t,f){if(!t.length)return!1;var o=r(e)[0],n=t[0],a=n.fcount||0;return f?(o.fitted||(o.fitted=!0,n.fcount=a+1,r(n).addClass("panel-noscroll"),"BODY"==n.tagName&&r("html").addClass("panel-fit")),{width:r(n).width()||1,height:r(n).height()||1}):(o.fitted&&(o.fitted=!1,n.fcount=a-1,0==n.fcount&&(r(n).removeClass("panel-noscroll"),"BODY"==n.tagName&&r("html").removeClass("panel-fit"))),!1)}function o(e,t,f,o){var n=r(e),a=t,i=a.substr(0,1).toUpperCase()+a.substr(1),s=r.parser.parseValue("min"+i,o["min"+i],f),l=r.parser.parseValue("max"+i,o["max"+i],f),u=r.parser.parseValue(a,o[a],f),c=String(o[a]||"").indexOf("%")>=0;if(isNaN(u))n._size(a,""),n._size("min"+i,s),n._size("max"+i,l);else{var d=Math.min(Math.max(u,s||0),l||99999);c||(o[a]=d),n._size("min"+i,""),n._size("max"+i,""),n._size(a,d)}return c||o.fit}function n(e,t,f){var o=r(e);if(f==undefined)return f=parseInt(e.style[t]),isNaN(f)?undefined:(r._boxModel&&(f+=n()),f);function n(){return t.toLowerCase().indexOf("width")>=0?o.outerWidth()-o.width():o.outerHeight()-o.height()}""===f?o.css(t,""):(r._boxModel&&(f-=n())<0&&(f=0),o.css(t,f+"px"))}}))}).call(this,r(11))},function(e,t){e.exports=function(){return Math.floor(100*Math.random()+1)}},function(e,t){e.exports=function(e){if(0==e)return e;if(e==undefined||""==e||isNaN(e))return"";var t="";if(e>=1e8||e<=-1e8)e/=1e8,t="亿";else{if(!(e>=1e4||e<=-1e4))return e;e/=1e4,t="万"}return e.toFixed(2).toString()+t}},function(e,t,r){(function(t){var f=r(75),o=r(76);e.exports=function(e,r){(n=window.location.href).split("#")[1];var n=o.getEnvPath("tsApi")+"api/qt/clist/get",a={pn:0,pz:20,po:1,np:1,ut:"bd1d9ddb04089700cf9c27f6f7426281",fltt:2,invt:2};a=t.extend(a,e),t.ajax({url:n,method:"GET",data:f.objToPars(a),dataType:"jsonp",jsonp:"cb",success:function(e){r(e)},error:function(e){}})}}).call(this,r(11))},function(e,t){e.exports={objToPars:function(e){var t=[];for(var r in e)t.push(r+"="+e[r]);return t.join("&")}}},function(e,t,r){r(19);e.exports={development:{commonApi:"//push2.eastmoney.com/",tsApi:"//"+(Math.floor(99*Math.random())+1)+".push2.eastmoney.com/"},production:{commonApi:"//push2.eastmoney.com/",tsApi:"//"+(Math.floor(99*Math.random())+1)+".push2.eastmoney.com/"},test:{commonApi:"http://61.129.249.233:18665/",tsApi:"http://61.129.249.233:18665/"},getEnvPath:function(e,t){if(t)return t;if(!this.production[e])return this.production.commonApi;var r=function(e){try{for(var t=window.location.search.substring(1).split("&"),r=0;r<t.length;r++){var f=t[r].split("=");if(f[0]==e)return f[1]}return!1}catch(o){return!1}}("hq-env");return r&&("development"===r||"production"===r||"test"===r)?this[r][e]:this.production[e]||""}}},function(e,t,r){(function(t){function r(e){this.ops={container:".dataTables_paginate",sumPage:20,index:10},this.ops=t.extend(this.ops,e),this.box=t(this.ops.container),this.onPage=function(){},this.addEvn()}r.prototype.init=function(){this.box.html("");for(var e=this.ops.index,t=[{title:e,index:e,cls:"current"}],r=e,f=e-3;--r>f;)r>0&&t.unshift({title:r,index:r});r>=2&&t.unshift({title:"…",index:""}),r>=1&&t.unshift({title:1,index:1}),t.unshift({title:"上一页",index:e-1>0?e-1:1});var o=this.ops.sumPage,n=e;for(f=e+3,n>o&&(n=o);++n<f;)n<=o&&t.push({title:n,index:n});n<=o-1&&t.push({title:"…",index:""}),n<=o&&t.push({title:o,index:o}),t.push({title:"下一页",index:e+1>o?o:e+1}),this.btns=t},r.prototype.setOps=function(e){this.ops=t.extend(this.ops,e),this.ops.sumPage>1&&(this.init(),this.create())},r.prototype.addEvn=function(){var e=this;this.box.off(),this.box.on("click",".paginate_button",function(){var r=t(this).attr("data-index");return r&&e.onPage(r/1),!1}),this.box.on("click",".paginte_go",function(){var r=t(".paginate_input").val();r&&e.onPage(r/1)})},r.prototype.create=function(){var e=this.box;e.html("");for(var r,f=this.btns,o=0,n=f.length;o<n;o++){var a=f[o];if(0==o){var i=t('<a class="previous paginate_button">上一页</a>');i.attr("data-index",a.index),1==a.index&&i.addClass("disabled"),e.append(i)}else if(o==n-1){var s=t('<a class="next paginate_button">下一页</a>');s.attr("data-index",a.index),this.ops.index===this.ops.sumPage&&s.addClass("disabled"),e.append(s)}else{r||(r=t("<span></span>").addClass("paginate_page"),e.append(r));var l=t('<a class="paginate_button"></a>');l.text(a.title),l.attr("data-index",a.index),a.cls&&l.addClass(a.cls),"…"==a.title&&l.addClass("disabled"),r.append(l)}}var u=t('<span class="paginate_of">  转到</span><input class="paginate_input" type="text"><a class="paginte_go">GO</a>');e.append(u),e.find("input").val(this.ops.index)},e.exports=r}).call(this,r(11))},function(e,t,r){var f=r(79);e.exports={futures:f.futures,stocks:f.stocks,bankuai:f.bankuai,zijinliu:f.zijinliu,zijinliuGegu:f.zijinliuGegu,hushenAStock:f.hushenAStock,hushenStockKcb:f.hushenStockKcb,shhkBoard:f.shhkBoard,staqnetBoard:f.staqnetBoard,indexsh:f.indexsh,neeqstocks:f.neeqstocks,hkstocks:f.hkstocks,hkshstocks:f.hkshstocks,abgu:f.abgu,ahgu:f.ahgu,ahgu2:f.ahgu2,ahgu3:f.ahgu3,hkindex:f.hkindex,usstocks:f.usstocks,usindex:f.usindex,globalamerica:f.globalamerica,globalamerica2:f.globalamerica2,globalamericaOz:f.globalamericaOz,globalamerica3:f.globalamerica3,globalamerica4:f.globalamerica4,conceptboard:f.conceptboard,conceptboardDatil:f.conceptboardDatil,hsgt:f.hsgt,qhsc_jq:f.qhsc_jq,fundcloseend:f.fundcloseend,fundcloseend2:f.fundcloseend2,bond:f.bond,bondnew:f.bondnew,forex:f.forex,forex2:f.forex2,qqsc:f.qqsc,gold:f.gold,gold2:f.gold2,hsbk:f.hsbk,hsbkd:f.hsbkd,hsbklz:f.hsbklz,hszs:f.hszs,hszs2:f.hszs2,mgsc:f.mgsc,mgsc3:f.mgsc3,bondmine:f.bondmine,indexqh:f.indexqh,indexqhNew:f.indexqhNew,zjs:f.zjs,gjqh:f.gjqh,hjqh:f.hjqh,whpj:f.whpj,ggsc:f.ggsc,Zqzqzs:f.Zqzqzs,opsnewgu:f.opsnewgu,hkadr:f.hkadr,hkstocks_cp_asc:f.hkstocks_cp_asc,sh_a_cp_desc:f.sh_a_cp_desc,AB5MinChangePercent:f.AB5MinChangePercent,ABTurnoverRate:f.ABTurnoverRate,ABVolumeRate:f.ABVolumeRate,ABAmplitude:f.ABAmplitude,ABAmount:f.ABAmount,ABPE:f.ABPE,ABPB:f.ABPB,ABFlowCapitalValue:f.ABFlowCapitalValue,ABMarketValue:f.ABMarketValue,AB60DayChangePercent:f.AB60DayChangePercent,AB360DayChangePercent:f.AB360DayChangePercent,ABSpeed:f.ABSpeed,BoardsCPAsc:f.BoardsCPAsc,BoardsCPAscd:f.BoardsCPAscd,BoardsTurnoverRate:f.BoardsTurnoverRate,BoardsSpeed:f.BoardsSpeed,BoardsAmount:f.BoardsAmount,CommonVolume:f.CommonVolume,CommonAmount:f.CommonAmount,BoardsPosition:f.BoardsPosition,MainCaptialFlow:f.MainCaptialFlow,FFRanking:f.FFRanking,BoardsCaptialFlow:f.BoardsCaptialFlow,fullscreenlist:f.fullscreenlist}},function(e,t,r){var f=r(80);e.exports={bankuai:{fields:"f1,f2,f3,f14,f12,f13,f62,f128,f136,f152",head:[{title:"名称",key:"f14",order:!1,href:"<a href='//quote.eastmoney.com/center/boardlist.html#boards-{{0}}1' title='{{1}}'></a>",data:["f12","f14"],show:!0,newcb:function(e){return f.txtPoint(e)}},{title:"涨跌幅",key:"f3",color:"f3",order:!1,fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},show:!0},{title:"主力净流入",key:"f62",color:"f62",order:!1,cb:function(e,t){return f.formatNumberIndex(e)},show:!0},{title:"领涨股",key:"f128",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}' title='{{2}}'></a>",data:["f141","f140","f128"],show:!0,newcb:function(e){return f.txtPoint(e)}},{title:"涨跌幅",key:"f136",color:"f136",order:!1,fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},show:!0}],sumcount:5},zijinliu:{fields:"f1,f2,f3,f14,f12,f13,f62,f128,f136,f152,f184",head:[{title:"名称",key:"f14",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}' title='{{2}}'></a>",data:["f13","f12","f14"],show:!0,newcb:function(e){return f.txtPoint(e)}},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f3",order:!1,show:!0},{title:"涨跌幅",key:"f3",color:"f3",order:!1,fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},show:!0},{title:"主力净流入",key:"f62",color:"f62",order:!1,cb:function(e,t){return f.formatNumberIndex(e)},show:!0},{title:"主力净占比",key:"f184",color:"f184",order:!1,cb:function(e,t){return f.formatNumber4(e)},show:!0}],sumcount:5},hushenAStock:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f22,f11,f62,f128,f136,f115,f152",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"f12",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Name"},{title:"相关链接",key:"",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Links"},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Close"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"涨跌额",key:"f4",fixedkey:"f1",color:"f4",order:!0,show:!0,name:"Change",newcb:function(e,t){return f.formatNumberFlag(e,t)}},{title:"成交量(手)",key:"f5",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Volume"},{title:"成交额",key:"f6",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Amount"},{title:"振幅",key:"f7",order:!0,cb:function(e,t){return f.formatNumber2(e)},show:!0,name:"Amplitude"},{title:"最高",key:"f15",fixedkey:"f1",color:"_f18",order:!0,newcb:function(e,t){return f.formatNumberFlag(e,t)},show:!0,name:"Hign"},{title:"最低",key:"f16",fixedkey:"f1",color:"_f18",order:!0,newcb:function(e,t){return f.formatNumberFlag(e,t)},show:!0,name:"Low"},{title:"今开",key:"f17",fixedkey:"f1",color:"_f18",order:!0,newcb:function(e,t){return f.formatNumberFlag(e,t)},show:!0,name:"Open"},{title:"昨收",key:"f18",fixedkey:"f1",order:!0,newcb:function(e,t){return f.formatNumberFlag(e,t)},show:!0,name:"PreviousClose"},{title:"量比",key:"f10",order:!0,cb:function(e,t){return f.formatNumberHSGGLB(e)},show:!0,name:"VolumeRate"},{title:"换手率",key:"f8",order:!0,cb:function(e,t){return f.formatNumber2(e)},show:!0,name:"TurnoverRate"},{title:"市盈率(动态)",key:"f9",order:!0,show:!0,cb:function(e,t){return f.formatNumberSyl(e)},name:"PERation"},{title:"市净率",key:"f23",order:!0,show:!0,cb:function(e,t){return f.formatNumberSyl(e)},name:"PB"},{title:"总市值",key:"f20",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!1},{title:"流通市值",key:"f21",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!1},{title:"60日涨跌幅",key:"f24",order:!0,fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f24",show:!1},{title:"年初至今涨跌幅",key:"f25",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f25",order:!0,show:!1},{title:"涨速",key:"f22",color:"f22",order:!0,cb:function(e,t){return f.formatNumber2(e)},show:!1},{title:"5分钟涨跌",key:"f11",color:"f11",order:!0,cb:function(e,t){return f.formatNumber2(e)},show:!1},{title:"加自选",key:"addzixuan",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Links"}],sumcount:20},hushenStockKcb:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f22,f11,f62,f128,f136,f115,f152",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"f12",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Name"},{title:"相关链接",key:"",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Links"},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Close"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"涨跌额",key:"f4",fixedkey:"f1",color:"f4",order:!0,show:!0,name:"Change",newcb:function(e,t){return f.formatNumberFlag(e,t)}},{title:"成交量(手)",key:"f5",order:!0,cb:function(e,t){return f.kcbMyformatNum(e)},show:!0,name:"Volume"},{title:"成交额",key:"f6",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Amount"},{title:"振幅",key:"f7",order:!0,cb:function(e,t){return f.formatNumber2(e)},show:!0,name:"Amplitude"},{title:"最高",key:"f15",fixedkey:"f1",color:"_f18",order:!0,newcb:function(e,t){return f.formatNumberFlag(e,t)},show:!0,name:"Hign"},{title:"最低",key:"f16",fixedkey:"f1",color:"_f18",order:!0,newcb:function(e,t){return f.formatNumberFlag(e,t)},show:!0,name:"Low"},{title:"今开",key:"f17",fixedkey:"f1",color:"_f18",order:!0,newcb:function(e,t){return f.formatNumberFlag(e,t)},show:!0,name:"Open"},{title:"昨收",key:"f18",fixedkey:"f1",order:!0,newcb:function(e,t){return f.formatNumberFlag(e,t)},show:!0,name:"PreviousClose"},{title:"量比",key:"f10",order:!0,cb:function(e,t){return f.formatNumberHSGGLB(e)},show:!0,name:"VolumeRate"},{title:"换手率",key:"f8",order:!0,cb:function(e,t){return f.formatNumber2(e)},show:!0,name:"TurnoverRate"},{title:"市盈率(动态)",key:"f9",order:!0,show:!0,cb:function(e,t){return f.formatNumberSyl(e)},name:"PERation"},{title:"市净率",key:"f23",order:!0,show:!0,cb:function(e,t){return f.formatNumberSyl(e)},name:"PB"},{title:"总市值",key:"f20",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!1},{title:"流通市值",key:"f21",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!1},{title:"60日涨跌幅",key:"f24",order:!0,fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f24",show:!1},{title:"年初至今涨跌幅",key:"f25",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f25",order:!0,show:!1},{title:"涨速",key:"f22",color:"f22",order:!0,cb:function(e,t){return f.formatNumber2(e)},show:!1},{title:"5分钟涨跌",key:"f11",color:"f11",order:!0,cb:function(e,t){return f.formatNumber2(e)},show:!1},{title:"加自选",key:"addzixuan",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Links"}],sumcount:20},opsnewgu:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f11,f62,f128,f136,f115,f152",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"f12",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Name"},{title:"相关链接",key:"",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Links"},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Close"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"涨跌额",key:"f4",fixedkey:"f1",color:"f4",order:!0,show:!0,name:"Change",newcb:function(e,t){return f.formatNumberFlag(e,t)}},{title:"成交量(手)",key:"f5",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Volume"},{title:"成交额",key:"f6",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Amount"},{title:"振幅",key:"f7",order:!0,cb:function(e,t){return f.formatNumber2(e)},show:!0,name:"Amplitude"},{title:"最高",key:"f15",fixedkey:"f1",color:"_f18",order:!0,newcb:function(e,t){return f.formatNumberFlag(e,t)},show:!0,name:"Hign"},{title:"最低",key:"f16",fixedkey:"f1",color:"_f18",order:!0,newcb:function(e,t){return f.formatNumberFlag(e,t)},show:!0,name:"Low"},{title:"今开",key:"f17",fixedkey:"f1",color:"_f18",order:!0,newcb:function(e,t){return f.formatNumberFlag(e,t)},show:!0,name:"Open"},{title:"昨收",key:"f18",fixedkey:"f1",order:!0,newcb:function(e,t){return f.formatNumberFlag(e,t)},show:!0,name:"PreviousClose"},{title:"换手率",key:"f8",order:!0,cb:function(e,t){return f.formatNumber2(e)},show:!0,name:"TurnoverRate"},{title:"市盈率(动态)",key:"f9",order:!0,show:!0,cb:function(e,t){return f.formatNumberSyl(e)},name:"PERation"},{title:"市净率",key:"f23",order:!0,show:!0,cb:function(e,t){return f.formatNumberSyl(e)},name:"PB"},{title:"上市时间",key:"f26",order:!0,show:!0,name:"shtime",cb:function(e,t){return f.formatNumber3(e)}},{title:"总市值",key:"f20",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!1},{title:"流通市值",key:"f21",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!1},{title:"60日涨跌幅",key:"f24",order:!0,fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f24",show:!1},{title:"年初至今涨跌幅",key:"f25",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f25",order:!0,show:!1},{title:"涨速",key:"f22",color:"f22",order:!0,cb:function(e,t){return f.formatNumber2(e)},show:!1},{title:"5分钟涨跌",key:"f11",color:"f11",order:!0,cb:function(e,t){return f.formatNumber2(e)},show:!1},{title:"量比",key:"f10",order:!0,cb:function(e,t){return f.formatNumberHSGGLB(e)},show:!1,name:"VolumeRate"},{title:"加自选",key:"addzixuan",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Links"}],sumcount:20},abgu:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f22,f11,f62,f128,f136,f115,f152,f201,f202,f203,f196,f197,f199,f195,f200",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"B股代码",key:"f201",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f202","f201"],show:!0,name:"Code"},{title:"名称",key:"f203",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f202","f201"],show:!0,name:"Name"},{title:"相关链接",key:"",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f202","f201"],show:!0,name:"Links_abgu"},{title:"最新价",key:"f196",fixedkey:"f200",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f195",order:!0,show:!0,name:"Close"},{title:"涨跌幅",key:"f197",color:"f197",order:!0,fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},show:!0,name:"ChangePercent"},{title:"A股代码",key:"f12",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Name"},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f3",order:!0,show:!0,name:"Close"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"比价（A/B）",key:"f199",color:"",order:!0,cb:function(e,t){return f.formatNumber4(e)},show:!0,name:"ChangePercent"}],sumcount:20},ahgu:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f22,f11,f62,f128,f136,f115,f152,f191,f192,f193,f186,f185,f187,f189,f188",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"名称",key:"f193",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f192","f191"],show:!0,name:"Name"},{title:"H股代码",key:"f12",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"最新价(HKD)",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f3",order:!1,show:!0,name:"Close"},{title:"涨跌幅",key:"f3",color:"f3",order:!1,fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},show:!0,name:"ChangePercent"},{title:"港股吧",key:"",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'>A股吧</a>",data:["f13","f12"],show:!0,name:""},{title:"A股代码",key:"f191",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f192","f191"],show:!0,name:"Code"},{title:"最新价(RMB)",key:"f186",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f185",order:!1,show:!0,name:"Close"},{title:"涨跌幅",key:"f187",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f187",order:!1,show:!0,name:"ChangePercent"},{title:"A股吧",key:"",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'>A股吧</a>",data:["f192","f191"],show:!0,name:"gangguba"},{title:"比价（A/H）",key:"f189",color:"",order:!1,cb:function(e,t){return f.formatNumber4(e)},show:!0,name:"ChangePercent"},{title:"溢价（A/H）%",key:"f188",color:"",order:!1,cb:function(e,t){return f.formatNumber4(e)},show:!0,name:"ChangePercent"}],sumcount:5},ahgu2:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f22,f11,f62,f128,f136,f115,f152,f191,f192,f193,f186,f185,f187,f189,f188",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"名称",key:"f193",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f192","f191"],show:!0,name:"Name"},{title:"H股代码",key:"f12",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"最新价(HKD)",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f3",order:!0,show:!0,name:"Close"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"港股吧",key:"",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'>A股吧</a>",data:["f13","f12"],show:!0,name:""},{title:"A股代码",key:"f191",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f192","f191"],show:!0,name:"Code"},{title:"最新价(RMB)",key:"f186",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f185",order:!0,show:!0,name:"Close"},{title:"涨跌幅",key:"f187",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f187",order:!0,show:!0,name:"ChangePercent"},{title:"A股吧",key:"",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'>A股吧</a>",data:["f192","f191"],show:!0,name:"gangguba"},{title:"比价（A/H）",key:"f189",color:"",order:!0,cb:function(e,t){return f.formatNumber4(e)},show:!0,name:"ChangePercent"},{title:"溢价（A/H）%",key:"f188",color:"f188",order:!0,cb:function(e,t){return f.formatNumber4(e)},show:!0,name:"ChangePercent"}],sumcount:20},ahgu3:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f22,f11,f62,f128,f136,f115,f152,f191,f192,f193,f186,f185,f187,f189,f188",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"名称",key:"f193",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f192","f191"],show:!0,name:"Name"},{title:"H股代码",key:"f12",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"最新价(HKD)",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f3",order:!1,show:!0,name:"Close"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!1,show:!0,name:"ChangePercent"},{title:"港股吧",key:"",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'>A股吧</a>",data:["f13","f12"],show:!0,name:""},{title:"A股代码",key:"f191",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f192","f191"],show:!0,name:"Code"},{title:"最新价(RMB)",key:"f186",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f185",order:!1,show:!0,name:"Close"},{title:"涨跌幅",key:"f187",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f187",order:!1,show:!0,name:"ChangePercent"},{title:"A股吧",key:"",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'>A股吧</a>",data:["f192","f191"],show:!0,name:"gangguba"},{title:"比价（A/H）",key:"f189",color:"",order:!1,cb:function(e,t){return f.formatNumber4(e)},show:!0,name:"ChangePercent"},{title:"溢价（A/H）%",key:"f188",color:"",order:!1,cb:function(e,t){return f.formatNumber4(e)},show:!0,name:"ChangePercent"},{title:"加自选",key:"addzixuan",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Links"}],sumcount:5},shhkBoard:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f11,f62,f128,f136,f115,f152",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"f12",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Name"},{title:"相关链接",key:"",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Links"},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Close"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!0,show:!0,name:"Change"},{title:"成交量(手)",key:"f5",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Volume"},{title:"成交额",key:"f6",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Amount"},{title:"振幅",key:"f7",order:!0,cb:function(e,t){return f.formatNumber2(e)},show:!0,name:"Amplitude"},{title:"最高",key:"f15",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Hign"},{title:"最低",key:"f16",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Low"},{title:"今开",key:"f17",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Open"},{title:"昨收",key:"f18",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},order:!0,show:!0,name:"PreviousClose"},{title:"换手率",key:"f8",order:!0,cb:function(e,t){return f.formatNumber2(e)},show:!0,name:"TurnoverRate"},{title:"市盈率(动态)",key:"f9",order:!0,show:!0,cb:function(e,t){return f.formatNumberSyl(e)},name:"PERation"},{title:"市净率",key:"f23",order:!0,show:!0,cb:function(e,t){return f.formatNumberSyl(e)},name:"PB"},{title:"上市时间",key:"f26",order:!0,show:!0,name:"shtime",cb:function(e,t){return f.formatNumber3(e)}},{title:"总市值",key:"f20",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!1},{title:"流通市值",key:"f21",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!1},{title:"60日涨跌幅",key:"f24",order:!0,fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f4",show:!1},{title:"年初至今涨跌幅",key:"f25",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f4",order:!0,show:!1},{title:"涨速",key:"f22",color:"f22",order:!0,cb:function(e,t){return f.formatNumber2(e)},show:!1},{title:"5分钟涨跌",key:"f11",color:"f11",order:!0,cb:function(e,t){return f.formatNumber2(e)},show:!1},{title:"加自选",key:"addzixuan",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Links"}],sumcount:20},staqnetBoard:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f33,f11,f62,f128,f136,f115,f152",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"f12",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Name"},{title:"相关链接",key:"",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"neeq_stocks"},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f3",order:!0,show:!0,name:"Close"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!0,show:!0,name:"Change"},{title:"成交量(手)",key:"f5",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Volume"},{title:"成交额",key:"f6",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Amount"},{title:"昨收",key:"f18",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},order:!0,show:!0,name:"PreviousClose"},{title:"今开",key:"f17",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Open"},{title:"最高",key:"f15",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Hign"},{title:"最低",key:"f16",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Low"},{title:"委比",key:"f33",fixedkey:"f152",newcb:function(e,t){return f.formatNumberFlag2(e,t)},order:!0,show:!0,name:"weibi"}],sumcount:20},indexsh:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f33,f11,f62,f128,f136,f115,f152",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"f12",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Name"},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f3",order:!0,show:!0,name:"Close"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!0,show:!0,name:"Change"},{title:"成交量(手)",key:"f5",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Volume"},{title:"成交额",key:"f6",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Amount"},{title:"振幅",key:"f7",order:!0,cb:function(e,t){return f.formatNumber2(e)},show:!0,name:"Amplitude"},{title:"最高",key:"f15",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Hign"},{title:"最低",key:"f16",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Low"},{title:"今开",key:"f17",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Open"},{title:"昨收",key:"f18",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},order:!0,show:!0,name:"PreviousClose"},{title:"量比",key:"f10",order:!0,cb:function(e,t){return f.formatNumber4(e)},show:!0,name:"VolumeRate"}],sumcount:20},neeqstocks:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f33,f11,f62,f128,f136,f115,f152",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"f12",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Name"},{title:"相关链接",key:"",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"neeq_stocks"},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Close"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!0,show:!0,name:"Change"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"成交量",key:"f5",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Volume"},{title:"成交额",key:"f6",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Amount"},{title:"昨收",key:"f18",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},order:!0,show:!0,name:"PreviousClose"},{title:"今开",key:"f17",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Open"},{title:"最高",key:"f15",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Hign"},{title:"最低",key:"f16",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Low"},{title:"委比",key:"f33",fixedkey:"f152",newcb:function(e,t){return f.formatNumberFlag2(e,t)},color:"f33",order:!0,show:!0,name:"weibi"}],sumcount:20},hkshstocks:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f11,f62,f128,f136,f115,f152",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"f12",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Name"},{title:"相关链接",key:"",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"hk_stocks"},{title:"最新价(HKD)",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Close"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!0,show:!0,name:"Change"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"今开",key:"f17",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Open"},{title:"最高",key:"f15",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Hign"},{title:"最低",key:"f16",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Low"},{title:"昨收",key:"f18",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},order:!0,show:!0,name:"PreviousClose"},{title:"成交量(股)",key:"f5",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Volume"},{title:"成交额(港元)",key:"f6",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Amount"},{title:"加自选",key:"addzixuan",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Links"}],sumcount:20},hkstocks:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f19,f20,f21,f23,f24,f25,f26,f22,f33,f11,f62,f128,f136,f115,f152",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"f12",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Name"},{title:"相关链接",key:"",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"hk_stocks"},{title:"最新价(HKD)",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Close"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!0,show:!0,name:"Change"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"今开",key:"f17",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Open"},{title:"最高",key:"f15",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Hign"},{title:"最低",key:"f16",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Low"},{title:"昨收",key:"f18",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},order:!0,show:!0,name:"PreviousClose"},{title:"成交量(股)",key:"f5",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Volume"},{title:"成交额(港元)",key:"f6",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Amount"},{title:"加自选",key:"addzixuan",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Links"}],sumcount:20},hkindex:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f33,f11,f62,f128,f136,f115,f152",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"f12",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Name"},{title:"最新价(HKD)",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Close"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!0,show:!0,name:"Change"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"今开",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},key:"f17",color:"_f18",order:!0,show:!0,name:"Open"},{title:"最高",key:"f15",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Hign"},{title:"最低",key:"f16",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Low"},{title:"昨收",key:"f18",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},order:!0,show:!0,name:"PreviousClose"},{title:"成交量(股)",key:"f5",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Volume"},{title:"成交额(港元)",key:"f6",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Amount"}],sumcount:20},usstocks:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f33,f11,f62,f128,f136,f115,f152",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Name"},{title:"最新价(美元)",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Close"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!0,show:!0,name:"Change"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"开盘价",key:"f17",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Open"},{title:"最高价",key:"f15",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Hign"},{title:"最低价",key:"f16",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Low"},{title:"昨收价",key:"f18",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},order:!0,show:!0,name:"PreviousClose"},{title:"总市值(美元)",key:"f20",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0},{title:"市盈率",key:"f115",order:!0,cb:function(e,t){return f.formatNumberSyl(e)},show:!0}],sumcount:20},usindex:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f33,f11,f62,f128,f136,f115,f152,f124,f107",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"名称",key:"f14",order:!0,href:'<a href="//quote.eastmoney.com/unify/r/{{0}}.{{1}}"></a>',data:["f13","f12"],show:!0,name:"usindex_name"},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Close"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!0,show:!0,name:"Change"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"开盘价",key:"f17",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Open"},{title:"最高价",key:"f15",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Hign"},{title:"最低价",key:"f16",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Low"},{title:"昨收价",key:"f18",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},order:!0,show:!0,name:"PreviousClose"},{title:"振幅",key:"f7",order:!0,cb:function(e,t){return f.formatNumber2(e)},show:!0,name:"zhenfu"},{title:"最新行情时间",key:"f124",order:!0,show:!0,cb:function(e,t){return f.formatNumberTime(e)},name:"newtime"}],sumcount:20},globalamerica:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f33,f11,f62,f128,f136,f115,f152,f124,f107",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"名称",key:"f14",order:!0,href:'<a href="//quote.eastmoney.com/unify/r/{{0}}.{{1}}"></a>',data:["f13","f12"],show:!0,name:"usindex_name"},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Close"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!0,show:!0,name:"Change"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"开盘价",key:"f17",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Open"},{title:"最高价",key:"f15",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Hign"},{title:"最低价",key:"f16",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Low"},{title:"昨收价",key:"f18",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},order:!0,show:!0,name:"PreviousClose"},{title:"振幅",key:"f7",order:!0,cb:function(e,t){return f.formatNumber2(e)},show:!0,name:"zhenfu"},{title:"最新行情时间",key:"f124",order:!0,show:!0,cb:function(e,t){return f.formatNumberTime(e)},name:"newtime"}],sumcount:20},globalamerica2:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f33,f11,f62,f128,f136,f115,f152,f124,f107",head:[{title:"名称",key:"f14",order:!1,href:'<a href="//quote.eastmoney.com/unify/r/{{0}}.{{1}}"></a>',data:["f13","f12"],show:!0,name:"usindex_name"},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!1,show:!0,name:"Close"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!1,show:!0,name:"Change"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!1,show:!0,name:"ChangePercent"}],sumcount:21},globalamericaOz:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f33,f11,f62,f128,f136,f115,f152,f124,f107",head:[{title:"名称",key:"f14",order:!1,href:'<a href="//quote.eastmoney.com/unify/r/{{0}}.{{1}}"></a>',data:["f13","f12"],show:!0,name:"usindex_name",wenhaoFlag:'<span id="GDR_title3" style="background: url(http://hqres.eastmoney.com/EMQuote_Center3.0/images/ying_wen.png) no-repeat;display:inline-block;width:15px;height:14px;position:relative;top:2px;left: 4px;" title="" class="tooltip-f"></span>'},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!1,show:!0,name:"Close"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!1,show:!0,name:"Change"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!1,show:!0,name:"ChangePercent"}],sumcount:23},globalamerica3:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f33,f11,f62,f128,f136,f115,f152,f124,f107",head:[{title:"名称",key:"f14",order:!1,href:'<a href="//quote.eastmoney.com/unify/r/{{0}}.{{1}}"></a>',data:["f13","f12"],show:!0,name:"usindex_name"},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!1,show:!0,name:"Close"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!1,show:!0,name:"Change"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!1,show:!0,name:"ChangePercent"}],sumcount:6},globalamerica4:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f33,f11,f62,f128,f136,f115,f152,f124,f107",head:[{title:"名称",key:"f14",order:!1,href:'<a href="//quote.eastmoney.com/unify/r/{{0}}.{{1}}"></a>',data:["f13","f12"],show:!0,name:"usindex_name"},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!1,show:!0,name:"Close"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!1,show:!0,name:"Change"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!1,show:!0,name:"ChangePercent"}],sumcount:3},conceptboard:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f33,f11,f62,f128,f136,f115,f152,f124,f107,f104,f105,f140,f141,f207,f222",head:[{title:"排名",type:"seq",show:!0,name:"number"},{title:"板块名称",key:"f14",order:!0,href:'<a href="//quote.eastmoney.com/unify/r/{{0}}.{{1}}"></a>',data:["f13","f12"],show:!0,name:"name"},{title:"相关链接",key:"",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"concept_board"},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Close"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!0,show:!0,name:"Change"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"总市值",key:"f20",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0},{title:"换手率",key:"f8",order:!0,cb:function(e,t){return f.formatNumber2(e)},show:!0},{title:"上涨家数",key:"f104",color:"red",order:!0,show:!0},{title:"下跌家数",key:"f105",color:"green",order:!0,show:!0},{title:"领涨股票",key:"f128",order:!0,href:'<a href="//quote.eastmoney.com/unify/r/{{0}}.{{1}}"></a>',data:["f141","f140"],show:!0,name:"name",cb:function(e,t){return f.formatNumber3(e)}},{title:"涨跌幅",key:"f136",color:"f136",order:!0,fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},show:!0,name:"ChangePercent"}],sumcount:20},conceptboardDatil:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f22,f11,f62,f128,f136,f115,f152",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"f12",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Name"},{title:"相关链接",key:"",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Links"},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Close"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!0,show:!0,name:"Change"},{title:"成交量(手)",key:"f5",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Volume"},{title:"成交额",key:"f6",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Amount"},{title:"振幅",key:"f7",order:!0,cb:function(e,t){return f.formatNumber2(e)},show:!0,name:"Amplitude"},{title:"最高",key:"f15",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Hign"},{title:"最低",key:"f16",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Low"},{title:"今开",key:"f17",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Open"},{title:"昨收",key:"f18",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},order:!0,show:!0,name:"PreviousClose"},{title:"量比",key:"f10",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"VolumeRate"},{title:"换手率",key:"f8",order:!0,cb:function(e,t){return f.formatNumber2(e)},show:!0,name:"TurnoverRate"},{title:"市盈率(动态)",key:"f9",order:!0,show:!0,cb:function(e,t){return f.formatNumberSyl(e)},name:"PERation"},{title:"加自选",key:"addzixuan",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Links"}],sumcount:20},hsgt:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f22,f11,f62,f128,f136,f115,f152",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"f12",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"名称",key:"f14",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!1,show:!0,name:"Close"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!1,show:!0,name:"Change"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!1,show:!0,name:"ChangePercent"},{title:"成交量(手)",key:"f5",order:!1,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Volume"},{title:"加自选",key:"addzixuan",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Links"}],sumcount:5},qhsc_jq:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f22,f11,f62,f128,f136,f115,f152",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"f12",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"名称",key:"f14",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f3",order:!1,show:!0,name:"Close"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!1,show:!0,name:"Change"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!1,show:!0,name:"ChangePercent"},{title:"所属交易所",key:"f13",order:!1,data:["f13"],newcb:function(e){return f.formatNumberQhsc(e)},show:!0}],sumcount:5},ggsc:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f22,f11,f62,f128,f136,f115,f152",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"f12",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"名称",key:"f14",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!1,show:!0,name:"Close"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!1,show:!0,name:"Change"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!1,show:!0,name:"ChangePercent"},{title:"成交量(手)",key:"f5",order:!1,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Volume"},{title:"加自选",key:"addzixuan",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Links"}],sumcount:5},hkadr:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f22,f11,f62,f128,f136,f115,f152,f213,f214,f220,f219,f217,f218",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"港股名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0},{title:"港股代码",key:"f12",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"ADR代码",key:"f213",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f214","f213"],show:!0,name:"Code"},{title:"ADR收市价(USD)",key:"f219",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f217",order:!0,show:!0,name:"Close"},{title:"涨跌额",key:"f217",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f217",order:!0,show:!0,name:"Change"},{title:"涨跌幅",key:"f218",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f218",order:!0,show:!0,name:"ChangePercent"},{title:"折合每股港元",key:"f220",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},order:!0,show:!0,name:"Close"}],sumcount:20},fundcloseend:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f22,f11,f62,f128,f136,f115,f152",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"f12",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0},{title:"相关链接",key:"",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"fundcloseend_Links"},{title:"最新价",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},key:"f2",color:"_f18",order:!0,show:!0,name:"Close"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!0,show:!0,name:"Change"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"成交量",key:"f5",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Volume"},{title:"成交额",key:"f6",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Amount"},{title:"开盘价",key:"f17",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Open"},{title:"最高价",key:"f15",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Hign"},{title:"最低价",key:"f16",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Low"},{title:"昨收",key:"f18",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},order:!0,show:!0,name:"PreviousClose"}],sumcount:20},fundcloseend2:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f22,f11,f62,f128,f136,f115,f152",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"f12",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"名称",key:"f14",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0},{title:"相关链接",key:"",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"fundcloseend_Links"},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!1,show:!0,name:"Close"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!1,show:!0,name:"Change"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!1,show:!0,name:"ChangePercent"},{title:"成交量",key:"f5",order:!1,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Volume"},{title:"成交额",key:"f6",order:!1,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Amount"},{title:"开盘价",key:"f17",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!1,show:!0,name:"Open"},{title:"最高价",key:"f15",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!1,show:!0,name:"Hign"},{title:"最低价",key:"f16",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!1,show:!0,name:"Low"},{title:"昨收",key:"f18",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},order:!1,show:!0,name:"PreviousClose"}],sumcount:5},Zqzqzs:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f22,f11,f62,f128,f136,f115,f152",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"f12",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"名称",key:"f14",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0},{title:"最新",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!1,show:!0,name:"Close"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!1,show:!0,name:"Change"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!1,show:!0,name:"ChangePercent"},{title:"今开",key:"f17",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!1,show:!0,name:"Open"},{title:"最高",key:"f15",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!1,show:!0,name:"Hign"},{title:"最低",key:"f16",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!1,show:!0,name:"Low"},{title:"昨收",key:"f18",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},order:!1,show:!0,name:"PreviousClose"},{title:"成交量",key:"f5",order:!1,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Volume"},{title:"成交额",key:"f6",order:!1,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Amount"}],sumcount:5},bond:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f33,f11,f62,f128,f136,f115,f152",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"f12",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Name"},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f3",order:!0,show:!0,name:"Close"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!0,show:!0,name:"Change"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"今开",key:"f17",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Open"},{title:"最高",key:"f15",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Hign"},{title:"最低",key:"f16",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Low"},{title:"昨收",key:"f18",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},order:!0,show:!0,name:"PreviousClose"},{title:"成交量(手)",key:"f5",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Volume"},{title:"成交额",key:"f6",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Amount"}],sumcount:20},bondnew:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f33,f11,f62,f128,f136,f115,f152",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"f12",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Name"},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f3",order:!0,show:!0,name:"Close"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!0,show:!0,name:"Change"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"今开",key:"f17",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Open"},{title:"最高",key:"f15",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Hign"},{title:"最低",key:"f16",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Low"},{title:"昨收",key:"f18",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},order:!0,show:!0,name:"PreviousClose"},{title:"成交量(手)",key:"f5",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Volume"},{title:"成交额",key:"f6",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Amount"}],sumcount:20},bondmine:{fields:"f1,f2,f3,f4,f14,f12,f13,f62,f128,f136,f152,f184",head:[{title:"名称",key:"f14",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f3",order:!1,show:!0},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!1,show:!0,name:"Change"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!1,show:!0,name:"ChangePercent"}],sumcount:5},forex:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f22,f11,f62,f128,f136,f115,f152",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"f12",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Close"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!0,show:!0,name:"Change"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"今开",key:"f17",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Open"},{title:"最高",key:"f15",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Hign"},{title:"最低",key:"f16",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Low"},{title:"昨收",key:"f18",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},order:!0,show:!0,name:"PreviousClose"}],sumcount:20},whpj:{fields:"f1,f12,f13,f14,f31,f32,f142,f143,f124",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"f12",order:!0,show:!0,name:"Code"},{title:"名称",key:"f14",order:!0,show:!0},{title:"现汇买入价",key:"f31",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"",order:!0,show:!0,name:"Close"},{title:"现钞买入价",key:"f142",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"",order:!0,show:!0,name:"Close"},{title:"现汇卖出价",key:"f32",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"",order:!0,show:!0,name:"Close"},{title:"现钞卖出价",key:"f143",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"",order:!0,show:!0,name:"Close"},{title:"更新时间",key:"f124",order:!0,cb:function(e,t){return f.formatNumberTime(e)},show:!0,name:"PreviousClose"}],sumcount:20},forex2:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f22,f11,f62,f128,f136,f115,f152",head:[{title:"代码",key:"f12",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"名称",key:"f14",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!1,show:!0,name:"Close"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!1,show:!0,name:"Change"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!1,show:!0,name:"ChangePercent"},{title:"开盘",key:"f17",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!1,show:!0,name:"Open"},{title:"最高",key:"f15",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!1,show:!0,name:"Hign"},{title:"最低",key:"f16",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!1,show:!0,name:"Low"},{title:"昨收",key:"f18",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},order:!1,show:!0,name:"PreviousClose"}],sumcount:5},qqsc:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f22,f28,f11,f62,f128,f136,f115,f152,f133,f108,f163,f161,f162",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"f12",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f28",order:!0,show:!0,name:"Close"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!0,show:!0,name:"Change"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"成交量",key:"f5",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Volume"},{title:"成交额",key:"f6",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Amount"},{title:"持仓量",key:"f108",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Amount"},{title:"行权价",key:"f161",order:!0,cb:function(e,t){return f.formatNumber4(e)},show:!0,name:"Amount"},{title:"剩余日",key:"f162",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Amount"},{title:"日增",key:"f163",order:!0,color:"f163",cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Amount"},{title:"昨结",key:"f28",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},order:!0,show:!0,name:"PreviousClose"},{title:"今开",key:"f17",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f28",order:!0,show:!0,name:"Open"}],sumcount:20},gold:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f22,f28,f11,f62,f128,f136,f115,f152,f133,f124",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"f12",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"品种",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f28",order:!0,show:!0,name:"Close"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!0,show:!0,name:"Change"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"今开",key:"f17",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f28",order:!0,show:!0,name:"Open"},{title:"最高",key:"f15",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f28",order:!0,show:!0,name:"Hign"},{title:"最低",key:"f16",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f28",order:!0,show:!0,name:"Low"},{title:"昨结",key:"f28",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},order:!0,show:!0,name:"PreviousClose"},{title:"更新时间",key:"f124",order:!0,cb:function(e,t){return f.formatNumberTime(e)},show:!0,name:"PreviousClose"}],sumcount:20},gold2:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f22,f28,f11,f62,f128,f136,f115,f152,f133,f124",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"f12",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"品种",key:"f14",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f3",order:!1,show:!0,name:"Close"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!1,show:!0,name:"Change"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!1,show:!0,name:"ChangePercent"},{title:"今开",key:"f17",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f28",order:!1,show:!0,name:"Open"},{title:"最高",key:"f15",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f28",order:!1,show:!0,name:"Hign"},{title:"最低",key:"f16",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f28",order:!1,show:!0,name:"Low"},{title:"昨结",key:"f28",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},order:!1,show:!0,name:"PreviousClose"},{title:"更新时间",key:"f124",order:!1,cb:function(e,t){return f.formatNumberTime(e)},show:!0,name:"PreviousClose"}],sumcount:5},hsbk:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f22,f11,f62,f128,f136,f115,f152,f133,f104,f105",head:[{title:"排名",type:"seq",show:!0,order:!1,name:"number"},{title:"板块名称",key:"f14",order:!1,href:'<a href="//quote.eastmoney.com/unify/r/{{0}}.{{1}}" title="{{2}}"></a>',data:["f13","f12","f14"],show:!0,name:"name"},{title:"相关链接",key:"",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"concept_board"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!1,show:!0,name:"ChangePercent"},{title:"换手率",key:"f8",order:!1,cb:function(e,t){return f.formatNumber2(e)},show:!0,name:"TurnoverRate"},{title:"涨跌家数",key:"",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"zhangdiejia"},{title:"领涨股票",key:"f128",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}' title='{{2}}'></a>",data:["f141","f140","f128"],show:!0,cb:function(e,t){return f.formatNumber3(e)}},{title:"涨跌幅",key:"f136",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f136",order:!1,show:!0}],sumcount:10},hsbkd:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f22,f11,f62,f128,f136,f115,f152,f133,f104,f105,f128,f136,f207,f208,f209,f222",head:[{title:"排名",type:"seq",show:!0,order:!1,name:"number"},{title:"板块名称",key:"f14",order:!1,href:'<a href="//quote.eastmoney.com/unify/r/{{0}}.{{1}}" title="{{2}}"></a>',data:["f13","f12","f14"],show:!0,name:"name"},{title:"相关链接",key:"",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"concept_board"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!1,show:!0,name:"ChangePercent"},{title:"换手率",key:"f8",order:!1,cb:function(e,t){return f.formatNumber2(e)},show:!0,name:"TurnoverRate"},{title:"涨跌家数",key:"",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"zhangdiejia"},{title:"领跌股票",key:"f207",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}' title='{{2}}'></a>",data:["f209","f208","f207"],show:!0,cb:function(e,t){return f.formatNumber3(e)}},{title:"涨跌幅",key:"f222",color:"f222",order:!1,fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},show:!0}],sumcount:10},hsbklz:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f22,f11,f62,f128,f136,f115,f152,f133,f104,f105",head:[{title:"板块名称",key:"f14",order:!1,href:"<a href='//quote.eastmoney.com/center/boardlist.html#boards-{{0}}1' title='{{1}}'></a>",data:["f12","f14"],show:!0},{title:"涨跌幅",key:"f3",color:"f3",order:!1,fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},show:!0},{title:"领涨股票",key:"f128",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}' title='{{2}}'></a>",data:["f141","f140","f128"],show:!0,cb:function(e,t){return f.formatNumber3(e)}},{title:"涨跌幅",key:"f136",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f136",order:!1,show:!0}],sumcount:5},hszs:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f11,f62,f128,f136,f115,f152",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"f12",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"名称",key:"f14",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Name"},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!1,show:!0,name:"Close"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!1,show:!0,name:"Change"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!1,show:!0,name:"ChangePercent"},{title:"成交量",key:"f5",order:!1,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Volume"},{title:"成交额",key:"f6",order:!1,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Amount"},{title:"昨收",key:"f18",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},order:!1,show:!0,name:"PreviousClose"},{title:"今开",key:"f17",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!1,show:!0,name:"Open"},{title:"最高",key:"f15",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!1,show:!0,name:"Hign"},{title:"最低",key:"f16",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!1,show:!0,name:"Low"}],sumcount:5},hszs2:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f11,f62,f128,f136,f115,f152",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"f12",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"名称",key:"f14",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Name"},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!1,show:!0,name:"Close"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!1,show:!0,name:"Change"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!1,show:!0,name:"ChangePercent"},{title:"成交量",key:"f5",order:!1,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Volume"},{title:"成交额",key:"f6",order:!1,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Amount"},{title:"昨收",key:"f18",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},order:!1,show:!0,name:"PreviousClose"},{title:"今开",key:"f17",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!1,show:!0,name:"Open"},{title:"最高",key:"f15",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!1,show:!0,name:"Hign"},{title:"最低",key:"f16",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!1,show:!0,name:"Low"}],sumcount:12},mgsc:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f11,f62,f128,f136,f115,f152",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"f12",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"名称",key:"f14",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"mgsc_name"},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!1,show:!0,name:"Close"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!1,show:!0,name:"Change"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!1,show:!0,name:"ChangePercent"},{title:"成交量",key:"f5",order:!1,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Volume"}],sumcount:5},mgsc3:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f11,f62,f128,f136,f115,f152",head:[{title:"名称",key:"f14",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"mgsc_name"},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!1,show:!0,name:"Close"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!1,show:!0,name:"ChangePercent"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!1,show:!0,name:"Change"}],sumcount:5},indexqh:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f28,f11,f62,f128,f136,f115,f152,f31,f32,f108,f163,f211,f212,f5,f30",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"f12",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f28",order:!0,show:!0},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!0,show:!0,name:"Change"},{title:"买入价",key:"f31",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f28",order:!0,show:!0,name:"Change"},{title:"卖出价",key:"f32",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f28",order:!0,show:!0,name:"Change"},{title:"买量",key:"f211",color:"red",order:!0,show:!0,name:"buycount",cb:function(e,t){return f.formatNumber(e)}},{title:"卖量",key:"f212",color:"green",order:!0,show:!0,name:"sellcount",cb:function(e,t){return f.formatNumber(e)}},{title:"总量",key:"f5",color:"",order:!0,show:!0,name:"Change",cb:function(e,t){return f.formatNumber(e)}},{title:"现量",key:"f30",color:"",order:!0,show:!0,name:"Change",cb:function(e,t){return f.formatNumber(e)}},{title:"持仓量",key:"f108",show:!0,order:!0,cb:function(e,t){return f.formatNumber(e)}},{title:"日增",key:"f163",order:!0,color:"f163",cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Amount"},{title:"昨结算",key:"f28",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},order:!0,show:!0,name:"PreviousClose"}],sumcount:20},indexqhNew:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f28,f11,f62,f128,f136,f115,f152,f31,f32,f108,f163,f211,f212,f5,f30",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"f12",order:!0,show:!0,name:"Code"},{title:"名称",key:"f14",order:!0,show:!0},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f28",order:!0,show:!0},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!0,show:!0,name:"Change"},{title:"买入价",key:"f31",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f28",order:!0,show:!0,name:"Change"},{title:"卖出价",key:"f32",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f28",order:!0,show:!0,name:"Change"},{title:"买量",key:"f211",color:"red",order:!0,show:!0,name:"buycount",cb:function(e,t){return f.formatNumber(e)}},{title:"卖量",key:"f212",color:"green",order:!0,show:!0,name:"sellcount",cb:function(e,t){return f.formatNumber(e)}},{title:"总量",key:"f5",color:"",order:!0,show:!0,name:"Change",cb:function(e,t){return f.formatNumber(e)}},{title:"现量",key:"f30",color:"",order:!0,show:!0,name:"Change",cb:function(e,t){return f.formatNumber(e)}},{title:"持仓量",key:"f108",show:!0,order:!0,cb:function(e,t){return f.formatNumber(e)}},{title:"日增",key:"f163",order:!0,color:"f163",cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Amount"},{title:"昨结算",key:"f28",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},order:!0,show:!0,name:"PreviousClose"}],sumcount:20},zjs:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f28,f22,f11,f62,f128,f136,f115,f152,f34,f35,f108",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"f12",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Name"},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f28",order:!0,show:!0,name:"Close"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!0,show:!0,name:"Change"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"今开",key:"f17",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f28",order:!0,show:!0,name:"Open"},{title:"最高",key:"f15",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f28",order:!0,show:!0,name:"Hign"},{title:"最低",key:"f16",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f28",order:!0,show:!0,name:"Low"},{title:"昨结",key:"f28",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},order:!0,show:!0,name:"PreviousClose"},{title:"成交量",key:"f5",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Volume"},{title:"成交额",key:"f6",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Amount"},{title:"买盘(外盘)",key:"f34",show:!0,order:!0},{title:"卖盘(内盘)",key:"f35",show:!0,order:!0},{title:"持仓量",key:"f108",show:!0,order:!0}],sumcount:20},gjqh:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f28,f11,f62,f128,f136,f115,f152,f34,f35,f108",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"f12",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Name"},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Close"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!0,show:!0,name:"Change"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"今开",key:"f17",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Open"},{title:"最高",key:"f15",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Hign"},{title:"最低",key:"f16",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Low"},{title:"昨结",key:"f28",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},order:!0,show:!0,name:"PreviousClose"},{title:"成交量",key:"f5",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Volume"},{title:"买盘(外盘)",key:"f34",show:!0,order:!0},{title:"卖盘(内盘)",key:"f35",show:!0,order:!0},{title:"持仓量",key:"f108",show:!0,order:!0}],sumcount:20},hjqh:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f28,f11,f62,f128,f136,f115,f152,f34,f35,f108,f211,f212",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"f12",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"名称",key:"f14",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Name"},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f3",order:!1,show:!0,name:"Close"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!1,show:!0,name:"Change"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!1,show:!0,name:"ChangePercent"},{title:"今开",key:"f17",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!1,show:!0,name:"Open"},{title:"最高",key:"f15",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!1,show:!0,name:"Hign"},{title:"最低",key:"f16",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!1,show:!0,name:"Low"},{title:"昨结",key:"f28",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},order:!1,show:!0,name:"PreviousClose"},{title:"成交量(手)",key:"f5",order:!1,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Volume"},{title:"买量(手)",key:"f211",color:"red",order:!1,show:!0,name:"buycount",cb:function(e,t){return f.formatNumber(e)}},{title:"卖量(手)",key:"f212",color:"green",order:!1,show:!0,name:"sellcount",cb:function(e,t){return f.formatNumber(e)}},{title:"持仓(手)",key:"f108",show:!0,order:!1}],sumcount:5},hkstocks_cp_asc:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f28,f11,f62,f128,f136,f115,f152,f34,f35,f108",head:[{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}' title='{{2}}'></a>",data:["f13","f12","f14"],show:!0,name:"Name",newcb:function(e){return f.txtPoint(e)}},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Close"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!0,show:!0,name:"Change"}],sumcount:5},CommonVolume:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f28,f11,f62,f128,f136,f115,f152,f34,f35,f108",head:[{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}' title='{{2}}'></a>",data:["f13","f12","f14"],show:!0,name:"Name",newcb:function(e){return f.txtPoint(e)}},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Close"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"成交量",key:"f5",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Volume"}],sumcount:5},CommonAmount:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f28,f11,f62,f128,f136,f115,f152,f34,f35,f108",head:[{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}' title='{{2}}'></a>",data:["f13","f12","f14"],show:!0,name:"Name",newcb:function(e){return f.txtPoint(e)}},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Close"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"成交额",key:"f6",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Amount"}],sumcount:5},sh_a_cp_desc:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f28,f11,f62,f128,f136,f115,f152,f34,f35,f108",head:[{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}' title='{{2}}'></a>",data:["f13","f12","f14"],show:!0,name:"Name",newcb:function(e){return f.txtPoint(e)}},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Close"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"涨跌额",key:"f4",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f4",order:!0,show:!0,name:"Change"},{title:"加自选",key:"addzixuan",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Links"}],sumcount:5},AB5MinChangePercent:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f28,f11,f62,f128,f136,f115,f152,f34,f35,f108",head:[{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}' title='{{2}}'></a>",data:["f13","f12","f14"],show:!0,name:"Name",newcb:function(e){return f.txtPoint(e)}},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Close"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"五分钟涨跌幅",key:"f11",color:"f11",order:!0,fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},show:!0},{title:"加自选",key:"addzixuan",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Links"}],sumcount:5},ABTurnoverRate:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f28,f11,f62,f128,f136,f115,f152,f34,f35,f108",head:[{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}' title='{{2}}'></a>",data:["f13","f12","f14"],show:!0,name:"Name",newcb:function(e){return f.txtPoint(e)}},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Close"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"换手率",key:"f8",order:!0,cb:function(e,t){return f.formatNumber2(e)},show:!0,name:"TurnoverRate"},{title:"加自选",key:"addzixuan",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Links"}],sumcount:5},ABVolumeRate:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f28,f11,f62,f128,f136,f115,f152,f34,f35,f108",head:[{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}' title='{{2}}'></a>",data:["f13","f12","f14"],show:!0,name:"Name",newcb:function(e){return f.txtPoint(e)}},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Close"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"量比",key:"f10",order:!0,cb:function(e,t){return f.formatNumber4(e)},show:!0,name:"TurnoverRate"},{title:"加自选",key:"addzixuan",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Links"}],sumcount:5},ABAmplitude:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f28,f11,f62,f128,f136,f115,f152,f34,f35,f108",head:[{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}' title='{{2}}'></a>",data:["f13","f12","f14"],show:!0,name:"Name",newcb:function(e){return f.txtPoint(e)}},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Close"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"振幅",key:"f7",order:!0,cb:function(e,t){return f.formatNumber2(e)},show:!0,name:"Amplitude"},{title:"加自选",key:"addzixuan",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Links"}],sumcount:5},ABAmount:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f28,f11,f62,f128,f136,f115,f152,f34,f35,f108",head:[{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}' title='{{2}}'></a>",data:["f13","f12","f14"],show:!0,name:"Name",newcb:function(e){return f.txtPoint(e)}},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Close"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"成交额",key:"f6",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Amount"},{title:"加自选",key:"addzixuan",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Links"}],sumcount:5},ABPE:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f28,f11,f62,f128,f136,f115,f152,f34,f35,f108",head:[{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}' title='{{2}}'></a>",data:["f13","f12","f14"],show:!0,name:"Name",newcb:function(e){return f.txtPoint(e)}},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Close"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"市盈率",key:"f9",order:!0,show:!0,cb:function(e,t){return f.formatNumberSyl(e)},name:"PERation"},{title:"加自选",key:"addzixuan",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Links"}],sumcount:5},ABPB:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f28,f11,f62,f128,f136,f115,f152,f34,f35,f108",head:[{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}' title='{{2}}'></a>",data:["f13","f12","f14"],show:!0,name:"Name",newcb:function(e){return f.txtPoint(e)}},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Close"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"市净率",key:"f23",order:!0,show:!0,cb:function(e,t){return f.formatNumberSyl(e)},name:"PB"},{title:"加自选",key:"addzixuan",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Links"}],sumcount:5},ABFlowCapitalValue:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f28,f11,f62,f128,f136,f115,f152,f34,f35,f108",head:[{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}' title='{{2}}'></a>",data:["f13","f12","f14"],show:!0,name:"Name",newcb:function(e){return f.txtPoint(e)}},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Close"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"流通市值",key:"f21",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0},{title:"加自选",key:"addzixuan",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Links"}],sumcount:5},ABMarketValue:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f28,f11,f62,f128,f136,f115,f152,f34,f35,f108",head:[{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}' title='{{2}}'></a>",data:["f13","f12","f14"],show:!0,name:"Name",newcb:function(e){return f.txtPoint(e)}},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Close"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"总市值",key:"f20",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0},{title:"加自选",key:"addzixuan",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Links"}],sumcount:5},AB60DayChangePercent:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f28,f11,f62,f128,f136,f115,f152,f34,f35,f108",head:[{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}' title='{{2}}'></a>",data:["f13","f12","f14"],show:!0,name:"Name",newcb:function(e){return f.txtPoint(e)}},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Close"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"60日涨跌幅",key:"f24",order:!0,fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f24",show:!0},{title:"加自选",key:"addzixuan",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Links"}],sumcount:5},AB360DayChangePercent:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f28,f11,f62,f128,f136,f115,f152,f34,f35,f108",head:[{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}' title='{{2}}'></a>",data:["f13","f12","f14"],show:!0,name:"Name",newcb:function(e){return f.txtPoint(e)}},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Close"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"年初至今涨跌幅",key:"f25",order:!0,suffix:"%",color:"f25",show:!0},{title:"加自选",key:"addzixuan",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Links"}],sumcount:5},ABSpeed:{fields:"f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f12,f13,f14,f15,f16,f17,f18,f20,f21,f23,f24,f25,f26,f22,f28,f11,f62,f128,f136,f115,f152,f34,f35,f108",head:[{title:"名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}' title='{{2}}'></a>",data:["f13","f12","f14"],show:!0,name:"Name",newcb:function(e){return f.txtPoint(e)}},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_f18",order:!0,show:!0,name:"Close"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"涨速",key:"f22",order:!0,suffix:"%",color:"f22",show:!0},{title:"加自选",key:"addzixuan",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Links"}],sumcount:5},BoardsCPAsc:{fields:"f1,f2,f3,f14,f12,f13,f62,f128,f136,f152",head:[{title:"名称",key:"f14",order:!1,href:"<a href='//quote.eastmoney.com/center/boardlist.html#boards-{{0}}1' title='{{1}}'></a>",data:["f12","f14"],show:!0,newcb:function(e){return f.txtPoint(e)}},{title:"涨跌幅",key:"f3",color:"f3",order:!1,fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},show:!0},{title:"主力净流入",key:"f62",color:"f62",order:!1,cb:function(e,t){return f.formatNumberIndex(e)},show:!0},{title:"领涨股",key:"f128",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}' title='{{2}}'></a>",data:["f141","f140","f128"],show:!0,newcb:function(e){return f.txtPoint(e)}},{title:"涨跌幅",key:"f136",color:"f136",order:!1,fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},show:!0}],sumcount:5},BoardsCPAscd:{fields:"f1,f2,f3,f14,f12,f13,f62,f128,f136,f152,f207,f208,f209,f222",head:[{title:"名称",key:"f14",order:!1,href:"<a href='//quote.eastmoney.com/center/boardlist.html#boards-{{0}}1' title='{{1}}'></a>",data:["f12","f14"],show:!0,newcb:function(e){return f.txtPoint(e)}},{title:"涨跌幅",key:"f3",color:"f3",order:!1,fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},show:!0},{title:"主力净流入",key:"f62",color:"f62",order:!1,cb:function(e,t){return f.formatNumberIndex(e)},show:!0},{title:"领跌股",key:"f207",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}' title='{{2}}'></a>",data:["f209","f208","f207"],show:!0,newcb:function(e){return f.txtPoint(e)}},{title:"涨跌幅",key:"f222",color:"f222",order:!1,fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},show:!0}],sumcount:5},BoardsTurnoverRate:{fields:"f1,f2,f3,f8,f14,f12,f13,f62,f128,f136,f152",head:[{title:"名称",key:"f14",order:!1,href:"<a href='//quote.eastmoney.com/center/boardlist.html#boards-{{0}}1' title='{{1}}'></a>",data:["f12","f14"],show:!0,newcb:function(e){return f.txtPoint(e)}},{title:"涨跌幅",key:"f3",color:"f3",order:!1,fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},show:!0},{title:"换手率",key:"f8",order:!0,cb:function(e,t){return f.formatNumber2(e)},show:!0,name:"TurnoverRate"},{title:"领涨股",key:"f128",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}' title='{{2}}'></a>",data:["f141","f140","f128"],show:!0,newcb:function(e){return f.txtPoint(e)}},{title:"涨跌幅",key:"f136",color:"f136",order:!1,fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},show:!0}],sumcount:5},BoardsSpeed:{fields:"f1,f2,f3,f8,f14,f12,f13,f22,f62,f128,f136,f152",head:[{title:"名称",key:"f14",order:!1,href:"<a href='//quote.eastmoney.com/center/boardlist.html#boards-{{0}}1' title='{{1}}'></a>",data:["f12","f14"],show:!0,newcb:function(e){return f.txtPoint(e)}},{title:"涨跌幅",key:"f3",color:"f3",order:!1,fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},show:!0},{title:"涨速",key:"f22",color:"f22",order:!0,cb:function(e,t){return f.formatNumber2(e)},show:!0,name:"TurnoverRate"},{title:"领涨股",key:"f128",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}' title='{{2}}'></a>",data:["f141","f140","f128"],show:!0,newcb:function(e){return f.txtPoint(e)}},{title:"涨跌幅",key:"f136",color:"f136",order:!1,fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},show:!0}],sumcount:6},BoardsAmount:{fields:"f1,f2,f3,f6,f8,f14,f12,f13,f22,f62,f128,f136,f152",head:[{title:"名称",key:"f14",order:!1,href:"<a href='//quote.eastmoney.com/center/boardlist.html#boards-{{0}}1' title='{{1}}'></a>",data:["f12","f14"],show:!0,newcb:function(e){return f.txtPoint(e)}},{title:"涨跌幅",key:"f3",color:"f3",order:!1,fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},show:!0},{title:"成交额",key:"f6",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Amount"},{title:"领涨股",key:"f128",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}' title='{{2}}'></a>",data:["f141","f140","f128"],show:!0,newcb:function(e){return f.txtPoint(e)}},{title:"涨跌幅",key:"f136",color:"f136",order:!1,fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},show:!0}],sumcount:6},BoardsPosition:{fields:"f1,f2,f3,f6,f8,f14,f12,f13,f22,f62,f128,f136,f152,f184,f225,f226",head:[{title:"名称",key:"f14",order:!1,href:"<a href='//quote.eastmoney.com/center/boardlist.html#boards-{{0}}1' title='{{1}}'></a>",data:["f12","f14"],show:!0,newcb:function(e){return f.txtPoint(e)}},{title:"涨跌幅",key:"f3",color:"f3",order:!1,fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},show:!0},{title:"增仓占比",key:"f184",color:"f184",order:!0,cb:function(e,t){return f.formatNumberZCZB(e)},show:!0,name:"zczb"},{title:"排名",key:"f225",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"paim"},{title:"排行变化",key:"f226",color:"f226",order:!0,cb:function(e,t){return f.formatPaiming(e)},show:!0,name:"pmchange"}],sumcount:6},MainCaptialFlow:{fields:"f1,f2,f3,f14,f12,f13,f62,f128,f136,f152,f184",head:[{title:"名称",key:"f14",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}' title='{{2}}'></a>",data:["f13","f12","f14"],show:!0,newcb:function(e){return f.txtPoint(e)}},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f3",order:!1,show:!0},{title:"涨跌幅",key:"f3",color:"f3",order:!1,fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},show:!0},{title:"主力净流入",key:"f62",color:"f62",order:!1,cb:function(e,t){return f.formatNumberIndex(e)},show:!0},{title:"净占比",key:"f184",color:"f184",order:!1,cb:function(e,t){return f.formatNumberJZB(e)},show:!0}],sumcount:5},FFRanking:{fields:"f1,f2,f3,f14,f12,f13,f62,f128,f136,f152,f184,f223",head:[{title:"名称",key:"f14",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}' title='{{2}}'></a>",data:["f13","f12","f14"],show:!0,newcb:function(e){return f.txtPoint(e)}},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f3",order:!1,show:!0},{title:"净占比",key:"f184",color:"f184",order:!1,cb:function(e,t){return f.formatNumberJZB(e)},show:!0},{title:"排名",key:"f223",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"paim"},{title:"涨跌幅",key:"f3",color:"f3",order:!1,fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},show:!0}],sumcount:5},BoardsCaptialFlow:{fields:"f1,f2,f3,f6,f8,f14,f12,f13,f22,f62,f128,f136,f152,f204,f184",head:[{title:"名称",key:"f14",order:!1,href:"<a href='//quote.eastmoney.com/center/boardlist.html#boards-{{0}}1' title='{{1}}'></a>",data:["f12","f14"],show:!0,newcb:function(e){return f.txtPoint(e)}},{title:"涨跌幅",key:"f3",color:"f3",order:!1,fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},show:!0},{title:"主力净流入",key:"f62",color:"f62",order:!1,cb:function(e,t){return f.formatNumberIndex(e)},show:!0},{title:"净占比",key:"f184",color:"f184",order:!1,cb:function(e,t){return f.formatNumberJZB(e)},show:!0},{title:"主力流入最大股",key:"f204",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}' title='{{2}}'></a>",data:["f206","f205","f204"],show:!0,newcb:function(e){return f.txtPoint(e)}}],sumcount:5},zijinliuGegu:{fields:"f1,f2,f3,f14,f12,f13,f62,f128,f136,f152,f184",head:[{title:"名称",key:"f14",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}' title='{{2}}'></a>",data:["f13","f12","f14"],show:!0,newcb:function(e){return f.txtPoint(e)}},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f3",order:!1,show:!0},{title:"涨跌幅",key:"f3",color:"f3",order:!1,fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},show:!0},{title:"主力净流入",key:"f62",color:"f62",order:!1,cb:function(e,t){return f.formatNumberIndex(e)},show:!0},{title:"净占比",key:"f184",color:"f184",order:!1,cb:function(e,t){return f.formatNumberJZB(e)},show:!0}],sumcount:5},fullscreenlist:{fields:"f1,f152,f2,f3,f12,f13,f14,f227,f228,f229,f230,f231,f232,f233,f234,f235,f236,f237,f238,f239,f240,f241,f242,f26,f243",head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"转债代码",key:"f12",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Code"},{title:"转债名称",key:"f14",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"Name"},{title:"最新价",key:"f2",fixedkey:"f1",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"f3",order:!0,show:!0,name:"Close"},{title:"涨跌幅",key:"f3",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f3",order:!0,show:!0,name:"ChangePercent"},{title:"相关链接",key:"",order:!1,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f13","f12"],show:!0,name:"fullscreen_Links"},{title:"正股代码",key:"f232",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f233","f232"],show:!0,name:"Code"},{title:"正股名称",key:"f234",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["f233","f232"],show:!0,name:"Name"},{title:"最新价",key:"f229",fixedkey:"f1",cb:function(e,t){return f.formatNumberJiaZ(e,2)},color:"f230",order:!0,show:!0,name:"Close"},{title:"涨跌幅",key:"f230",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},color:"f230",order:!0,show:!0,name:"ChangePercent"},{title:"转股价",key:"f235",order:!0,cb:function(e,t){return f.formatNumberSyl(e)},show:!0,name:"Volume"},{title:"转股价值",key:"f236",order:!0,cb:function(e,t){return f.formatNumberJiaZ(e,4)},show:!0,name:"zgValue"},{title:"转股溢价率",key:"f237",order:!0,color:"f237",fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},show:!0,name:"zgYjb"},{title:"纯债溢价率",key:"f238",color:"f238",order:!0,fixedkey:"f152",newcb:function(e,t){return f.formatNumberIndexZdf(e,t)},show:!0,name:"czYjl"},{title:"回售触发价",key:"f239",order:!0,cb:function(e,t){return f.formatNumberSyl(e)},show:!0,name:"hsCfj"},{title:"强赎触发价",key:"f240",order:!0,cb:function(e,t){return f.formatNumberSyl(e)},show:!0,name:"qsCfj"},{title:"到期赎回价",key:"f241",order:!0,cb:function(e,t){return f.formatNumberSyl(e)},show:!0,name:"dqShj"},{title:"纯债价值",key:"f227",order:!0,cb:function(e,t){return f.formatNumberSyl(e)},show:!0,name:"Volume"},{title:"开始转股日",key:"f242",order:!0,show:!0,name:"shtime",cb:function(e,t){return f.formatNumber3(e)}},{title:"上市日期",key:"f26",order:!0,show:!0,name:"shtime",cb:function(e,t){return f.formatNumber3(e)}},{title:"申购日期",key:"f243",order:!0,show:!0,name:"shtime",cb:function(e,t){return f.formatNumber3(e)}},{title:"加自选",key:"addzixuan",order:!1,show:!0,name:"Links"}],sumcount:50}}},function(e,t){e.exports={formatNumber:function(e){if(0==e)return"0.00";var t="";try{var r=Math.abs(e/1);"number"==typeof r&&(t=r>1e4&&r<1e8?(e/1e4).toFixed(2)+"万":r>1e8?(e/1e8).toFixed(2)+"亿":0==r?"-":e.toFixed(0))}catch(f){t="-"}return t},formatNumberHSGGLB:function(e){if(0==e)return"0.00";try{return e.toFixed(2)}catch(t){return"-"}},formatNumberIndex:function(e){if("-"==e)return"-";if(0==e)return"0.00";try{var t="number"==typeof t&&t>=0?t:NaN;try{var r=Math.abs(e/1);if("number"==typeof e)return r>=0&&r<1?e.toFixed(2):r>=1&&r<100?e.toFixed(2):r>=100&&r<1e3?e.toFixed(1):r>=1e3&&r<1e4?e.toFixed(0):r>=1e4&&r<1e6?(e/=1e4).toFixed(t||2)+"万":r>=1e6&&r<1e7?(e/=1e4).toFixed(t||1)+"万":r>=1e7&&r<1e8?(e/=1e4).toFixed(t||0)+"万":r>=1e8&&r<1e10?(e/=1e8).toFixed(t||2)+"亿":r>=1e10&&r<1e11?(e/=1e8).toFixed(t||1)+"亿":r>=1e11&&r<1e12?(e/=1e8).toFixed(t||0)+"亿":r>=1e12&&r<1e13?(e/=1e12).toFixed(t||1)+"万亿":r>=1e13||r<0&&r>-1e16?(e/=1e12).toFixed(t||0)+"万亿":e.toFixed(0)}catch(f){e="-"}return e}catch(f){return"-"}},kcbMyformatNum:function(e){if("-"==e)return"-";if(e==undefined||""==e||isNaN(e)||"-"==e)return"";var t="";try{return e>=0&&e<=99.999999999?t=parseFloat(e).toFixed(2):e>=100&&e<=999?t=parseFloat(e).toFixed(1):e>=1e3&&(t=e>1e4&&e<1e8?(e/1e4).toFixed(2)+"万":e>1e8?(e/1e8).toFixed(2)+"亿":0==e?"-":e.toFixed(0)),e<0&&((e=Math.abs(e))>=0&&e<=99?t=parseFloat(e).toFixed(2):e>=100&&e<=999?t=parseFloat(e).toFixed(1):e>=1e3&&(t=parseFloat(e).toFixed(0)),t="-"+t),t.toString()+""}catch(r){return"-"}},formatNumber_0:function(e){var t="";try{var r=Math.abs(e/1);"number"==typeof r&&(t=r>1e4&&r<1e8?(e/1e4).toFixed(0)+"万":r>1e8?(e/1e8).toFixed(2)+"亿":e)}catch(f){t="-"}return t},formatNumber2:function(e){var t="";try{var r=Math.abs(e/1);"number"==typeof r&&(t=r.toFixed(2))}catch(f){t="-"}return e>=0?t+"%":"-"},formatNumberJZB:function(e){var t="";try{var r=Math.abs(e/1);"number"==typeof r&&(t=r.toFixed(2))}catch(f){t="-"}return e>=0?t+"%":e<0?"-"+t+"%":"-"},formatNumberZCZB:function(e){var t="";try{var r=Math.abs(e/1);"number"==typeof r&&(t=r.toFixed(2))}catch(f){t="-"}return e>=0?t+"%":e<0?"-"+t+"%":"-"},formatNumberSyl:function(e){return e>0?e.toFixed(2):e<0?e.toFixed(2):"-"},formatNumberJiaZ:function(e,t){return e>0?e.toFixed(t):e<0?e.toFixed(t):"-"},formatNumber3:function(e){var t=e;return"number"==typeof t?t.toString().substr(0,4)+"-"+t.toString().substr(4,2)+"-"+t.toString().substr(6,2):"string"==typeof t?t:"-"},formatNumber4:function(e){var t="";try{var r=Math.abs(e/1);"number"==typeof r&&(t=r.toFixed(2))}catch(f){t="-"}return e>0?t:e<0?"-"+t:0==e?"0.00":"-"},formatNumberTime:function(e){var t=new Date(1e3*e),r=t.getFullYear(),f=t.getMonth()+1,o=t.getDate(),n=t.getHours(),a=t.getMinutes(),i=t.getSeconds();return r+"-"+s(f)+"-"+s(o)+" "+s(n)+":"+s(a)+":"+s(i);function s(e){return e<10?"0"+e:e}},formatNumberZde:function(e){var t="";try{var r=Math.abs(e/1);"number"==typeof r&&(t=r.toFixed(2))}catch(f){t="-"}return e>0?t:e<0?"-"+t:0==e?"0.00":"-"},formatPaiming:function(e){if(0==e)return"-";var t="";try{var r=Math.abs(e/1);"number"==typeof r&&(t=r>1e4&&r<1e8?(e/1e4).toFixed(2)+"万":r>1e8?(e/1e8).toFixed(2)+"亿":0==r?"-":e.toFixed(0))}catch(f){t="-"}return t>0&&(t="+"+t),t},formatNumberFlag:function(e,t){var r="";try{var f=Math.abs(e/1);"number"==typeof f&&(r=f.toFixed(t))}catch(o){r="-"}return e>0?r:e<0?"-"+r:0==e?(0).toFixed(t):"-"},formatNumberFlag2:function(e,t){var r="";try{var f=Math.abs(e/1);"number"==typeof f&&(r=f.toFixed(t))}catch(o){r="-"}return e>0?r+"%":e<0?"-"+r+"%":"-"},formatNumberIndexZdf:function(e,t){var r="";try{var f=Math.abs(e/1);"number"==typeof f&&(r=f.toFixed(t))}catch(o){r="-"}return e>0?r+"%":e<0?"-"+r+"%":0==e?"0.00%":"-"},txtPoint:function(e){var t=e.length,r=-1,f=0;strChar=[];for(var o=0;o<t;o++)r=e.charCodeAt(o),strChar[f]=e.charAt(o),r>=0&&r<=128?f+=1:(strChar[f+1]="",f+=2);return f>8&&(e=strChar.slice(0,6).join("")+".."),e},formatNumberQhsc:function(e){var t={1:"上交所",8:"中金所",113:"上期所",114:"大商所",115:"郑商所",116:"港交所",142:"上期能源"},r="";return e&&(r=t[e]?t[e]:"国际期货"),r}}},function(e,t){e.exports={ChangePercent:"f3",Amount:"f6",Volume:"f5",TurnoverRate:"f8",Speed:"f22",ChangePercent360Day:"f25",ChangePercent60Day:"f24",MarketValue:"f20",FlowCapitalValue:"f21",PB:"f23",PERation:"f115",Amplitude:"f7",VolumeRate:"f10",FiveMinuteChangePercent:"f11",PERation:"f9"}},function(e,t,r){(function(t){var f=!!r(83).get(),o=function(e){var r="mystock_web";return f||(r="mystock_webanonym"),t.ajax({type:"GET",url:"http://myfavor1.eastmoney.com/"+r+"?cb=?",data:e,dataType:"jsonp"})},n=function(e){var r="mystock_web";return f||(r="mystock_webanonym"),t.ajax({type:"GET",url:"http://myfavor1.eastmoney.com/"+r,data:e,dataType:"jsonp",jsonp:"cb"})};e.exports={getDefaultStocks:function(){return o({f:"gsaandcheck"}).then(function(e){return window._myFavor_list=e.data.list,e.data.list})},add:function(e){return n({f:"asz",sc:e}).then(function(e){return 1==e.result})},del:function(e){return n({f:"dsz",sc:e}).then(function(e){return 1==e.result})},get:function(e){return n({f:"gsaandcheck",sc:e}).then(function(e){return"True"==e.data.check})},newget:function(e){t.ajax({type:"get",data:"",url:"https://myfavor.eastmoney.com/mystock?f=gsaandcheck&t=undefined&cb=jsonp1553678369631",dataType:"jsonp",jsonp:"js",success:function(e){}})}}}).call(this,r(11))},function(e,t,r){var f=r(84),o={get:function(){if(f.get("ut")&&f.get("ct")&&f.get("uidal")){var e={vtype:null,state:null,name:""};if(f.get("vtpst")&&"|"!=f.get("vtpst")){var t=f.get("vtpst").split("|");if(t.length>1){if("0"==t[1]||"3"==t[1])switch(t[0]){case"301":e.vtype=1,e.name="理财师";break;case"302":e.vtype=2,e.name="非理财师";break;case"303":e.vtype=3,e.name="企业"}switch(t[1]){case"0":e.state=0;break;case"1":e.state=11;break;case"2":e.state=12;break;case"3":e.state=13;break;case"8":e.state=18;break;case"9":e.state=19}}}return{id:f.get("uidal").substring(0,16),nick:f.get("uidal").substring(16),jiav:e}}return null},logOut:function(e){var t=new Date;document.cookie="pi=;path=/;domain=eastmoney.com;expires="+t.toGMTString(),document.cookie="ct=;path=/;domain=eastmoney.com;expires="+t.toGMTString(),document.cookie="ut=;path=/;domain=eastmoney.com;expires="+t.toGMTString(),document.cookie="uidal=;path=/;domain=eastmoney.com;expires="+t.toGMTString(),e&&e()},isLogin:function(){return!!this.get()}};e.exports=o},function(e,t){var r={get:function(e){var t=document.cookie.match(new RegExp("(^| )"+e+"=([^;]*)(;|$)"));return null!=t?decodeURIComponent(t[2]):null},set:function(e,t,r,f){var o=new Date;o.setDate(o.getDate()+r),document.cookie=e+"="+escape(t)+";expires="+o.toGMTString()+";path=/;domain="+f},del:function(e,t){var r=new Date((new Date).getTime()-1);document.cookie=t?e+"=;path=/;expires="+r.toGMTString()+";domain="+t:e+"=;path=/;expires="+r.toGMTString()}};e.exports=r},function(e,t){},function(e){e.exports={ops:{order:"f3",orderDur:!1,type:"bankuai",thclick:!1},ops2:{order:"f62",orderDur:!1,type:"zijinliu",thclick:!1},ops3:{order:"f62",orderDur:!0,type:"zijinliu",thclick:!1},ops4:{order:"f3",orderDur:!1,type:"hushenAStock",zixuan:!0},opsKcb:{order:"f3",orderDur:!1,type:"hushenStockKcb",zixuan:!0},opsnewgu:{order:"f26",orderDur:!1,type:"opsnewgu",zixuan:!0},abgu:{order:"f199",orderDur:!1,type:"abgu",zixuan:!0},ahgu:{order:"f3",orderDur:!1,type:"ahgu",zixuan:!0,thclick:!1},ahgu2:{order:"f3",orderDur:!1,type:"ahgu2",zixuan:!0},ahgu3:{order:"f3",orderDur:!1,type:"ahgu3",zixuan:!0,thclick:!1},ops5:{order:"f26",orderDur:!1,type:"shhkBoard",zixuan:!0},ops6:{order:"f3",orderDur:!1,type:"staqnetBoard"},ops7:{order:"f3",orderDur:!1,type:"indexsh"},ops8:{order:"f3",orderDur:!1,type:"indexsz"},ops9:{order:"f3",orderDur:!1,type:"neeqstocks"},hkstocks:{order:"f3",orderDur:!1,type:"hkstocks",zixuan:!0},hkshstocks:{order:"f3",orderDur:!1,type:"hkshstocks",zixuan:!0},hkindex:{order:"f3",orderDur:!1,type:"hkindex"},hkindexNXZ:{order:"f6",orderDur:!1,type:"hkindex"},usstocks:{order:"f3",orderDur:!1,type:"usstocks"},usindex:{order:"f3",orderDur:!1,type:"usindex"},globalamerica:{order:"f3",orderDur:!1,type:"globalamerica"},globalamerica2:{orderDur:!1,type:"globalamerica2",thclick:!1},globalamericaOz:{orderDur:!1,type:"globalamericaOz",thclick:!1},globalamerica3:{orderDur:!1,type:"globalamerica3",thclick:!1},globalamerica4:{orderDur:!1,type:"globalamerica4",thclick:!1},conceptboard:{order:"f3",orderDur:!1,type:"conceptboard"},conceptboardDatil:{order:"f3",orderDur:!1,type:"conceptboardDatil",zixuan:!0},hsgt:{order:"f3",orderDur:!1,type:"hsgt",zixuan:!0,thclick:!1},qhsc_jq:{order:"f3",orderDur:!1,type:"qhsc_jq",zixuan:!0,thclick:!1},fundcloseend:{order:"f3",orderDur:!1,type:"fundcloseend"},fundcloseend2:{order:"f3",orderDur:!1,type:"fundcloseend2",thclick:!1},fundcloseend2d:{order:"f3",orderDur:!0,type:"fundcloseend2",thclick:!1},bond:{order:"f3",orderDur:!1,type:"bond"},bondnew:{order:"f6",orderDur:!1,type:"bondnew"},forex:{order:"f3",orderDur:!1,type:"forex"},forex2:{order:"f3",orderDur:!1,type:"forex2",thclick:!1},qqsc:{order:"f3",orderDur:!1,type:"qqsc"},gold:{order:"f3",orderDur:!1,type:"gold"},gold2:{order:"f3",orderDur:!1,type:"gold2",thclick:!1},hsbk:{order:"f3",orderDur:!1,type:"hsbk",thclick:!1},hsbkd:{order:"f3",orderDur:!0,type:"hsbkd",thclick:!1},hsbklz:{order:"f3",orderDur:!1,type:"hsbklz",thclick:!1},hszs:{order:"f3",orderDur:!1,type:"hszs",thclick:!1},hszs2:{order:"",orderDur:!1,type:"hszs2",thclick:!1},ggsc:{order:"f3",orderDur:!1,type:"ggsc",zixuan:!0,thclick:!1},ggscd:{order:"f3",orderDur:!0,type:"ggsc",zixuan:!0,thclick:!1},mgsc:{order:"f3",orderDur:!1,type:"mgsc",thclick:!1},mgscd:{order:"f3",orderDur:!0,type:"mgsc",thclick:!1},mgsc3:{order:"f3",orderDur:!1,type:"mgsc3",thclick:!1},bondmine:{order:"f3",orderDur:!1,type:"bondmine",thclick:!1},indexqh:{order:"f14",orderDur:!0,type:"indexqh"},indexqhNew:{order:"f14",orderDur:!0,type:"indexqhNew"},indexqh_gjs:{order:"f14",orderDur:!0,type:"indexqh"},zjs:{order:"f3",orderDur:!1,type:"zjs"},gjqh:{order:"f3",orderDur:!1,type:"gjqh"},hjqh:{order:"f3",orderDur:!1,type:"hjqh",thclick:!1},whpj:{order:"f3",orderDur:!1,type:"whpj"},Zqzqzs:{order:"f3",orderDur:!1,type:"Zqzqzs",thclick:!1},hkadr:{order:"f3",orderDur:!1,type:"hkadr"},fullscreenlist:{order:"f243",orderDur:!1,type:"fullscreenlist",zixuan:!0}}},,,,,,,,,,,function(e,t,r){(function(t){r(41),r(70);r(72),r(73);var f=r(98),o=r(77),n=r(99),a=r(82);function i(e){var r=e.type,f=n[r].head;this.tableHead=f;var a={orderBy:"zdf",sort:"desc",pageSize:n[r].sumcount,pageIndex:0,index:1};this.ops=t.extend(a,e),this.page=new o,this.codearr=[],this.mycontent="",this.myfs=""}r(85),i.prototype.Qihuo=function(e,r,f){this.getQihuo(e,r,f),0!=this.ops.thclick&&(t(".dataTable thead th").css("cursor","default"),this.addEvent(e,r,f))},i.prototype.pageClick=function(e,t,r,f){var o=this;o.page.onPage=function(n){o.ops.index=n,n>r&&(o.ops.index=r),o.getDataBank(e,t,f)}},i.prototype.hoverFn=function(){t("#digest-industry").show(),t("#digest-concept").hide(),t("#digest-region").hide(),t("#digest-industry").hover(function(){t("#digest-industry").show(),t("#digest-concept").hide(),t("#digest-region").hide()}),t("#digest-concept").hover(function(){t("#digest-industry").hide(),t("#digest-concept").show(),t("#digest-region").hide()}),t("#digest-region").hover(function(){t("#digest-industry").hide(),t("#digest-concept").hide(),t("#digest-region").show()})},i.prototype.getQihuo=function(e,t,r){0!=this.getParam("sr")&&1!=this.getParam("sr")||(this.ops.orderDur=!0),-1==this.getParam("sr")&&(this.ops.orderDur=!1);var f=window.location.href.split("#")[1];if("region_board"==f||"concept_board"==f||"industry_board"==f)0==this.ops.orderDur&&(this.tableHead[10].title="领涨股票",this.tableHead[10].key="f128",this.tableHead[11].key="f136",this.tableHead[11].color="f136",this.createHead(e,t),this.getDataBank(e,t,r)),1==this.ops.orderDur&&(this.tableHead[10].title="领跌股票",this.tableHead[10].key="f128",this.tableHead[11].key="f136",this.tableHead[11].color="f222",this.createHead(e,t),this.getDataBank(e,t,r));else{var o={PB:"市净率",MarketValue:"总市值",FlowCapitalValue:"流通市值",FlowCapitalValue:"流通市值",ChangePercent60Day:"60日涨跌幅",ChangePercent360Day:"年初至今涨跌幅",Speed:"涨速",FiveMinuteChangePercent:"5分钟涨跌",VolumeRate:"量比"};if(this.getParam("st")){for(var n=0;n<this.tableHead.length;n++){var a=this.tableHead[n].title;"总市值"!=a&&"流通市值"!=a&&"60日涨跌幅"!=a&&"年初至今涨跌幅"!=a&&"涨速"!=a&&"5分钟涨跌"!=a&&"量比"!=a||(this.tableHead[n].show=!1),a==o[this.getParam("st")]&&(this.tableHead[n].show=!0)}this.createHead(e,t),this.getDataBank(e,t,r)}else this.createHead(e,t),this.getDataBank(e,t,r)}},i.prototype.createHead=function(e,r){for(var f=this.tableHead,o=t('<tr role="row"></tr>'),n=0;n<f.length;n++){var a=f[n];if(a&&1==a.show){if("序号"==a.title||"加自选"==a.title||0==a.order)var i=t('<th style="" class="listview-col-'+a.name+' sorting_disabled" rowspan="1" colspan="1" aria-label="'+a.title+'"><span style="color:#333">'+a.title+'</span><b class="icon"></b></th>');else if(a.key==this.ops.order)if(1==this.ops.orderDur)if("zgValue"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting_asc" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="转股价值=正股价/转股价*100" class="tooltip-f">转股价值<em class="help-icon"></em></span></span><b class="icon"></b></th>');else if("zgYjb"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting_asc" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="转股溢价率 = （转债最新价 – 转股价值）/ 转股价值" class="tooltip-f">转股溢价率<em class="help-icon"></em></span></span><b class="icon"></b></th>');else if("czYjl"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting_asc" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="纯债溢价率 = （转债最新价 – 纯债价值）/ 纯债价值" class="tooltip-f">纯债溢价率<em class="help-icon"></em></span></span><b class="icon"></b></th>');else if("hsCfj"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting_asc" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="满足回售触发条件时，可转债持有人有权将其持有的可转债全部或部分按债券面值加上当期应计利息的价格回售给公司" class="tooltip-f">回售触发价<em class="help-icon"></em></span></span><b class="icon"></b></th>');else if("qsCfj"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting_asc" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="满足赎回触发条件时，公司有权按照债券面值加当期应计利息的价格赎回全部或部分未转股的可转债" class="tooltip-f">强赎触发价<em class="help-icon"></em></span></span><b class="icon"></b></th>');else if("dqShj"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting_asc" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="公司有权以债券发行说明书中规定的到期赎回价买回其发行在外债券" class="tooltip-f">到期赎回价<em class="help-icon"></em></span></span><b class="icon"></b></th>');else i=t('<th style="" class="listview-col-'+a.name+' sorting_asc" rowspan="1" colspan="1" aria-label="'+a.title+'"><span>'+a.title+'</span><b class="icon"></b></th>');else if("zgValue"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting_desc" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="转股价值=正股价/转股价*100" class="tooltip-f">转股价值<em class="help-icon"></em></span></span><b class="icon"></b></th>');else if("zgYjb"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting_desc" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="转股溢价率 = （转债最新价 – 转股价值）/ 转股价值" class="tooltip-f">转股溢价率<em class="help-icon"></em></span></span><b class="icon"></b></th>');else if("czYjl"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting_desc" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="纯债溢价率 = （转债最新价 – 纯债价值）/ 纯债价值" class="tooltip-f">纯债溢价率<em class="help-icon"></em></span></span><b class="icon"></b></th>');else if("hsCfj"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting_desc" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="满足回售触发条件时，可转债持有人有权将其持有的可转债全部或部分按债券面值加上当期应计利息的价格回售给公司" class="tooltip-f">回售触发价<em class="help-icon"></em></span></span><b class="icon"></b></th>');else if("qsCfj"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting_desc" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="满足赎回触发条件时，公司有权按照债券面值加当期应计利息的价格赎回全部或部分未转股的可转债" class="tooltip-f">强赎触发价<em class="help-icon"></em></span></span><b class="icon"></b></th>');else if("dqShj"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting_desc" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="公司有权以债券发行说明书中规定的到期赎回价买回其发行在外债券" class="tooltip-f">到期赎回价<em class="help-icon"></em></span></span><b class="icon"></b></th>');else i=t('<th style="" class="listview-col-'+a.name+' sorting_desc" rowspan="1" colspan="1" aria-label="'+a.title+'"><span>'+a.title+'</span><b class="icon"></b></th>');else if("zgValue"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="转股价值=正股价/转股价*100" class="tooltip-f">转股价值<em class="help-icon"></em></span></span><b class="icon"></b></th>');else if("zgYjb"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="转股溢价率 = （转债最新价 – 转股价值）/ 转股价值" class="tooltip-f">转股溢价率<em class="help-icon"></em></span></span><b class="icon"></b></th>');else if("czYjl"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="纯债溢价率 = （转债最新价 – 纯债价值）/ 纯债价值" class="tooltip-f">纯债溢价率<em class="help-icon"></em></span></span><b class="icon"></b></th>');else if("hsCfj"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="满足回售触发条件时，可转债持有人有权将其持有的可转债全部或部分按债券面值加上当期应计利息的价格回售给公司" class="tooltip-f">回售触发价<em class="help-icon"></em></span></span><b class="icon"></b></th>');else if("qsCfj"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="满足赎回触发条件时，公司有权按照债券面值加当期应计利息的价格赎回全部或部分未转股的可转债" class="tooltip-f">强赎触发价<em class="help-icon"></em></span></span><b class="icon"></b></th>');else if("dqShj"==a.name)i=t('<th style="" class="listview-col-'+a.name+' sorting" rowspan="1" colspan="1" aria-label="'+a.title+'"><span><span  title="公司有权以债券发行说明书中规定的到期赎回价买回其发行在外债券" class="tooltip-f">到期赎回价<em class="help-icon"></em></span></span><b class="icon"></b></th>');else i=t('<th style="" class="listview-col-'+a.name+' sorting" rowspan="1" colspan="1" aria-label="'+a.title+'"><span>'+a.title+'</span><b class="icon"></b></th>');i.attr("data-key",a.key),o.append(i)}}t(e).find("table thead").html(""),t(e).find("table thead").append(o)},i.prototype.getDataBank=function(e,r,o){var n=this,a=this.ops,i=(this.config,{orderBy:a.order,sort:a.orderDur?"asc":"desc",pageSize:a.pageSize,pageIndex:a.index-1,blockName:a.blockName});f(i,a.url,function(f){var i=f.list;if(i){var s=i;try{a.sc!=undefined&&(s=i.map(function(e){return e.sc=a.sc,e}))}catch(c){}var l=f.total,u=Math.ceil(l/a.pageSize);if(a.sumPage=u,u>1)n.page.setOps({index:a.index,sumPage:a.sumPage}),n.pageClick(e,r,u,o),t(".dataTables_paginate").show();else t(".dataTables_paginate").hide();n.setBody(e,s,o)}else s=[],t(".dataTables_paginate").hide(),n.setBody(e,s,o)})},i.prototype.addEvent=function(e,r,f){var o=this;t(e).find("thead").off(),t(e).find("thead").on("click","th",function(){var n=t(this).attr("data-key");n&&"addzixuan"!=n&&(n==o.ops.order?o.ops.orderDur=!o.ops.orderDur:(o.ops.order=n,o.ops.orderDur=!0),o.createHead(e,r),o.getDataBank(e,r,f))})},i.prototype.setBody=function(e,t,r){var f=this;if(f.body=t,1==f.ops.zixuan){if(r)o(r);else a.getDefaultStocks().then(function(e){o(e)});function o(t){if(t){f.zixuanList=t.split(",");for(var r=0;r<f.body.length;r++){var o=f.body[r],n=o.f13+"."+o.f12,a=!1;a=!!f.in_array(n,f.zixuanList),o.isZisuan=a}f.createBody(e)}}}f.createBody(e)},i.prototype.getParam=function(e){var t=location.search,r={};if(""!=t)for(var f,o,n=(t=t.substring(1,t.length)).split("&"),a=0;a<n.length;a++)f=n[a].substring(0,n[a].indexOf("=")),o=n[a].substring(n[a].indexOf("=")+1,n[a].length),r[f]=o;return"undefined"!=typeof r[e]?r[e]:null},i.prototype.formatData=function(){for(var e=this.body,t=["f2","f4","f15","f16","f17","f18","f28","f31","f32"].join(",")+",",r=["f3","f7","f8","f9","f10","f11","f22","f23","f24","f25","f33"].join(",")+",",f=["f115"].join(",")+",",o=0,n=e.length;o<n;o++){var a=e[o],i=Math.pow(10,a.f1);for(var s in a)if(t.indexOf(s+",")>-1&&(a[s]=(a[s]/i).toFixed(a.f1)),r.indexOf(s+",")>-1&&(a[s]=(a[s]/100).toFixed(2)),f.indexOf(s+",")>-1){var l=Math.pow(10,a.f152);a[s]=(a[s]/l).toFixed(a.f152)}}},i.prototype.createBody=function(e){var r=t(e+"-table").find("tbody");0==r.length&&(r=t(e).find("tbody"));var f=t(r);f.html("");for(var o=this.body,n=this.tableHead,a=0;a<o.length;a++){var i=o[a],s=t("<tr></tr>");a%2==0?s.addClass("odd"):s.addClass("even");for(var l=0;l<n.length;l++){var u=n[l];if(u&&1==u.show){var c="",d=t("<td></td>");if("名称"==u.title||"领涨股"==u.title||"领跌股"==u.title||"主力流入最大股"==u.title)d=t("<td class='mywidth'></td>");if("板块名称"==u.title||"领涨股票"==u.title||"领跌股票"==u.title)d=t("<td class='mywidth3'></td>");if("名称"==u.title&&"usindex_name"==u.name)if(5==i.f107)d=t("<td class='mywidth' style='text-align:left;padding-left:5px;'><em class='circle' title='已收盘'>●</em></td>");else if(3==i.f107)d=t("<td class='mywidth' style='text-align:left;padding-left:5px;'><em class='circle' title='盘中休息'>●</em></td>");else d=t("<td class='mywidth' style='text-align:left;padding-left:5px;'><em class='trading' title='交易中'>●</em></td>");if("最新价"==u.title||"涨跌幅"==u.title)d=t("<td class='mywidth2'></td>");if("名称"==u.title&&"mgsc_name"==u.name)d=t("<td class='text_overflow' title='"+i.f14+"'></td>");var m=i.f13+"."+i.f12;if("加自选"==u.title)if(0==i.isZisuan)d=t('<td class=" listview-col-add"><a class="addzx show" target="_self" onclick="return false;" href="javascript:void(0);" data-myscode='+m+'></a><a class="delzx hide" target="_self" onclick="return false;" href="javascript:void(0);" data-myscode='+m+"></a></td>");else if(1==i.isZisuan)d=t('<td class=" listview-col-add"><a class="addzx hide" target="_self" onclick="return false;" href="javascript:void(0);" data-myscode='+m+'></a><a class="delzx show" target="_self" onclick="return false;" href="javascript:void(0);" data-myscode='+m+"></a></td>");else d=t('<td class=" listview-col-add"><a class="addzx show" target="_self" onclick="return false;" href="javascript:void(0);" data-myscode='+m+'></a><a class="delzx hide" target="_self" onclick="return false;" href="javascript:void(0);" data-myscode='+m+"></a></td>");if(u.type)"seq"==u.type&&d.text(a+1+this.ops.pageSize*(this.ops.index-1));else{var h="-";if(u.key&&(h=i[u.key]),u.cb&&(h=u.cb(i[u.key],i)),u.newcb&&(h=u.newcb(i[u.key],i[u.fixedkey])),u.suffix&&(h+=u.suffix),u.color!==undefined){c=t("<span></span>");var b,y,w=u.color;"number"==typeof w?(b=i[u.key],y=w):0==w.indexOf("_")?(b=i[u.key],y=i[w.substr(1)]):(b=i[w],y=0);var k=b-y;if(k>0?c.addClass("red"):k<0?c.addClass("green"):c.addClass("fair"),-1!==w.indexOf("qihuo_")){var p=i.zjsj;h>p?c.addClass("red"):h<p&&c.addClass("green")}else"red"==w?c.addClass("red"):"green"==w&&c.addClass("green")}if(u.href){for(var g=u.data,x=u.href,N=0;N<g.length;N++){var _=RegExp("\\{\\{"+N+"\\}\\}");x=x.replace(_,i[g[N]])}c=t(x)}c?(c.text(h),d.append(c)):d.text(h)}s.append(d)}}f.append(s)}},i.prototype.in_array=function(e,t){for(s=0;s<t.length;s++)if(thisEntry=t[s].toString(),thisEntry==e)return!0;return!1},e.exports=i}).call(this,r(11))},function(e,t,r){(function(t){var f=r(75);r(76);e.exports=function(e,r,o){e.blockName?e.blockName=e.blockName:e.blockName="callback";var n={orderBy:"zdf",sort:"desc",pageSize:5,pageIndex:0,callbackName:"aaa_"+e.blockName};n=t.extend(n,e),t.ajax({url:r,method:"GET",data:f.objToPars(n),dataType:"jsonp",jsonp:"cb",jsonpCallback:"aaa_"+e.blockName,success:function(e){o(e)},error:function(e){}})}}).call(this,r(11))},function(e,t,r){var f=r(80);e.exports={gjqh:{head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"dm",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["sc","dm"],show:!0,name:"Code"},{title:"名称",key:"name",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["sc","dm"],show:!0,name:"Name"},{title:"最新价",key:"p",fixedkey:"zsjd",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_zjsj",order:!0,show:!0,name:"Close"},{title:"涨跌额",key:"zde",fixedkey:"zsjd",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"zdf",order:!0,show:!0,name:"Change"},{title:"涨跌幅",key:"zdf",fixedkey:"f152",newcb:function(e){return"-"!==e?e.toFixed(2)+"%":"-"},color:"zdf",order:!0,show:!0,name:"ChangePercent"},{title:"今开",key:"o",fixedkey:"zsjd",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_zjsj",order:!0,show:!0,name:"Open"},{title:"最高",key:"h",fixedkey:"zsjd",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_zjsj",order:!0,show:!0,name:"Hign"},{title:"最低",key:"l",fixedkey:"zsjd",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_zjsj",order:!0,show:!0,name:"Low"},{title:"昨结",key:"zjsj",fixedkey:"zsjd",newcb:function(e,t){return f.formatNumberFlag(e,t)},order:!0,show:!0,name:"PreviousClose"},{title:"成交量",key:"vol",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Volume"},{title:"买盘(外盘)",key:"wp",show:!0,order:!0},{title:"卖盘(内盘)",key:"np",show:!0,order:!0},{title:"持仓量",key:"ccl",show:!0,order:!0}],sumcount:20},sqs:{head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"dm",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["sc","dm"],show:!0,name:"Code"},{title:"名称",key:"name",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["sc","dm"],show:!0,name:"Name"},{title:"最新价",key:"p",fixedkey:"zsjd",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_zjsj",order:!0,show:!0,name:"Close"},{title:"涨跌额",key:"zde",fixedkey:"zsjd",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"zdf",order:!0,show:!0,name:"Change"},{title:"涨跌幅",key:"zdf",fixedkey:"f152",newcb:function(e){return"-"!==e?e.toFixed(2)+"%":"-"},color:"zdf",order:!0,show:!0,name:"ChangePercent"},{title:"今开",key:"o",fixedkey:"zsjd",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_zjsj",order:!0,show:!0,name:"Open"},{title:"最高",key:"h",fixedkey:"zsjd",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_zjsj",order:!0,show:!0,name:"Hign"},{title:"最低",key:"l",fixedkey:"zsjd",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_zjsj",order:!0,show:!0,name:"Low"},{title:"昨结",key:"zjsj",fixedkey:"zsjd",newcb:function(e,t){return f.formatNumberFlag(e,t)},order:!0,show:!0,name:"PreviousClose"},{title:"成交量",key:"vol",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Volume"},{title:"成交额",key:"cje",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Volume"},{title:"买盘(外盘)",key:"wp",show:!0,order:!0},{title:"卖盘(内盘)",key:"np",show:!0,order:!0},{title:"持仓量",key:"ccl",show:!0,order:!0}],sumcount:20},gjs:{head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"dm",order:!0,show:!0,name:"Code"},{title:"名称",key:"name",order:!0,show:!0,name:"Name"},{title:"最新价",key:"p",fixedkey:"zsjd",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_zjsj",order:!0,show:!0,name:"Close"},{title:"涨跌幅",key:"zdf",fixedkey:"f152",newcb:function(e){return"-"!==e?e.toFixed(2)+"%":"-"},color:"zdf",order:!0,show:!0,name:"ChangePercent"},{title:"涨跌额",key:"zde",fixedkey:"zsjd",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"zdf",order:!0,show:!0,name:"Change"},{title:"买入价",key:"mrj",fixedkey:"zsjd",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"qihuo_zjsj",order:!0,show:!0,name:"mrj"},{title:"卖出价",key:"mcj",fixedkey:"zsjd",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"qihuo_zjsj",order:!0,show:!0,name:"mcj"},{title:"买量",key:"mrl",cb:function(e,t){return f.formatNumber(e)},color:"red",order:!0,show:!0,name:"ml"},{title:"卖量",key:"mcl",cb:function(e,t){return f.formatNumber(e)},color:"green",order:!0,show:!0,name:"mll"},{title:"总量",key:"vol",color:"",order:!0,show:!0,name:"zl",cb:function(e,t){return f.formatNumber(e)}},{title:"现量",key:"xs",color:"",order:!0,show:!0,name:"xl",cb:function(e,t){return f.formatNumber(e)}},{title:"持仓量",key:"ccl",color:"",order:!0,show:!0,name:"ccl",cb:function(e,t){return f.formatNumber(e)}},{title:"日增",key:"rz",color:"rz",order:!0,show:!0,name:"rz",cb:function(e,t){return f.formatNumber(e)}},{title:"昨结算",key:"zjsj",fixedkey:"zsjd",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"",order:!0,show:!0,name:"zjs"}],sumcount:20},gjs_gpqh:{head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"dm",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["sc","dm"],show:!0,name:"Code"},{title:"名称",key:"name",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["sc","dm"],show:!0,name:"Name"},{title:"最新价",key:"p",fixedkey:"zsjd",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_zjsj",order:!0,show:!0,name:"Close"},{title:"涨跌幅",key:"zdf",fixedkey:"f152",newcb:function(e){return"-"!==e?e.toFixed(2)+"%":"-"},color:"zdf",order:!0,show:!0,name:"ChangePercent"},{title:"涨跌额",key:"zde",fixedkey:"zsjd",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"zdf",order:!0,show:!0,name:"Change"},{title:"买入价",key:"mrj",fixedkey:"zsjd",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"qihuo_zjsj",order:!0,show:!0,name:"mrj"},{title:"卖出价",key:"mcj",fixedkey:"zsjd",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"qihuo_zjsj",order:!0,show:!0,name:"mcj"},{title:"买量",key:"mrl",cb:function(e,t){return f.formatNumber(e)},color:"red",order:!0,show:!0,name:"ml"},{title:"卖量",key:"mcl",cb:function(e,t){return f.formatNumber(e)},color:"green",order:!0,show:!0,name:"mll"},{title:"总量",key:"vol",color:"",order:!0,show:!0,name:"zl",cb:function(e,t){return f.formatNumber(e)}},{title:"现量",key:"xs",color:"",order:!0,show:!0,name:"xl",cb:function(e,t){return f.formatNumber(e)}},{title:"持仓量",key:"ccl",color:"",order:!0,show:!0,name:"ccl",cb:function(e,t){return f.formatNumber(e)}},{title:"日增",key:"rz",color:"rz",order:!0,show:!0,name:"rz",cb:function(e,t){return f.formatNumber(e)}},{title:"昨结算",key:"zjsj",fixedkey:"zsjd",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"",order:!0,show:!0,name:"zjs"}],sumcount:20},zjs:{head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"dm",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["sc","dm"],show:!0,name:"Code"},{title:"名称",key:"name",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["sc","dm"],show:!0,name:"Name"},{title:"最新价",key:"p",fixedkey:"zsjd",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_zjsj",order:!0,show:!0,name:"Close"},{title:"涨跌额",key:"zde",fixedkey:"zsjd",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"zdf",order:!0,show:!0,name:"Change"},{title:"涨跌幅",key:"zdf",fixedkey:"f152",newcb:function(e){return"-"!==e?e.toFixed(2)+"%":"-"},color:"zdf",order:!0,show:!0,name:"ChangePercent"},{title:"今开",key:"o",fixedkey:"zsjd",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_zjsj",order:!0,show:!0,name:"Open"},{title:"最高",key:"h",fixedkey:"zsjd",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_zjsj",order:!0,show:!0,name:"Hign"},{title:"最低",key:"l",fixedkey:"zsjd",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_zjsj",order:!0,show:!0,name:"Low"},{title:"昨结",key:"zjsj",fixedkey:"zsjd",newcb:function(e,t){return f.formatNumberFlag(e,t)},order:!0,show:!0,name:"PreviousClose"},{title:"成交量",key:"vol",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Volume"},{title:"成交额",key:"cje",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"cje"},{title:"买盘(外盘)",key:"wp",show:!0,order:!0},{title:"卖盘(内盘)",key:"np",show:!0,order:!0},{title:"持仓量",key:"ccl",show:!0,order:!0}],sumcount:20},qqsc:{head:[{title:"序号",type:"seq",show:!0,name:"number"},{title:"代码",key:"dm",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["sc","dm"],show:!0,name:"Code"},{title:"名称",key:"name",order:!0,href:"<a href='//quote.eastmoney.com/unify/r/{{0}}.{{1}}'></a>",data:["sc","dm"],show:!0,name:"Name"},{title:"最新价",key:"p",fixedkey:"zsjd",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_zjsj",order:!0,show:!0,name:"Close"},{title:"涨跌额",key:"zde",fixedkey:"zsjd",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"zdf",order:!0,show:!0,name:"Change"},{title:"涨跌幅",key:"zdf",fixedkey:"f152",newcb:function(e){return"-"!==e?e.toFixed(2)+"%":"-"},color:"zdf",order:!0,show:!0,name:"ChangePercent"},{title:"成交量",key:"vol",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Volume"},{title:"成交额",key:"cje",order:!0,cb:function(e,t){return f.formatNumber(e)},show:!0,name:"Volume"},{title:"持仓量",key:"ccl",show:!0,order:!0},{title:"行权价",key:"",show:!0,order:!0,name:"xqj"},{title:"剩余日",key:"",show:!0,order:!0,name:"syr"},{title:"日增",key:"rz",color:"rz",show:!0,order:!0,name:"rz"},{title:"昨结",key:"zjsj",fixedkey:"zsjd",newcb:function(e,t){return f.formatNumberFlag(e,t)},order:!0,show:!0,name:"PreviousClose"},{title:"今开",key:"o",fixedkey:"zsjd",newcb:function(e,t){return f.formatNumberFlag(e,t)},color:"_zjsj",order:!0,show:!0,name:"Open"}],sumcount:20}}},function(e,t){var r,f;!function(e){try{for(var t=window.location.search.substring(1).split("&"),r=0;r<t.length;r++){var f=t[r].split("=");if(f[0]==e)return f[1]}return!1}catch(o){return!1}}("hq-env")?(r="http://futsse.eastmoney.com",f="http://futsse-static.eastmoney.com"):(r="http://futssetest.eastmoney.com",f="http://static.futssetest.eastmoney.com"),e.exports={qihuourl:r,qihuo_static_url:f}},function(e,t,r){(function(e){r(56),r(41);var t=r(102);t(),e(window).hashchange(function(e){t()})}).call(this,r(11))},function(e,t,r){(function(t){var f=r(69),o=r(86),n=r(97),a=r(100),i=!!r(83).get();e.exports=function(){var e=window.location.href.split("#")[1];switch(t("#yssm").hide(),e){case"hs_a_board":new f(o.ops4).Bankuai("#table_wrapper","m:0+t:6,m:0+t:13,m:0+t:80,m:1+t:2,m:1+t:23");break;case"sh_a_board":new f(o.ops4).Bankuai("#table_wrapper","m:1+t:2,m:1+t:23");break;case"sz_a_board":new f(o.ops4).Bankuai("#table_wrapper","m:0+t:6,m:0+t:13,m:0+t:80");break;case"newshares":new f(o.opsnewgu).Bankuai("#table_wrapper","m:0+f:8,m:1+f:8");break;case"sme_board":new f(o.ops4).Bankuai("#table_wrapper","m:0+t:13");break;case"gem_board":new f(o.ops4).Bankuai("#table_wrapper","m:0+t:80");break;case"kcb_board":new f(o.opsKcb).Bankuai("#table_wrapper","m:1+t:23");break;case"sh_hk_board":new f(o.ops5).Bankuai("#table_wrapper","b:BK0707");break;case"sz_hk_board":new f(o.ops5).Bankuai("#table_wrapper","b:BK0804");break;case"b_board":new f(o.ops4).Bankuai("#table_wrapper","m:0+t:7,m:1+t:3");break;case"ab_comparison_sh":new f(o.abgu).Bankuai("#table_wrapper","m:1+b:BK0498");break;case"ab_comparison_sz":new f(o.abgu).Bankuai("#table_wrapper","m:0+b:BK0498");break;case"st_board":new f(o.ops4).Bankuai("#table_wrapper","m:0+f:4,m:1+f:4");break;case"staq_net_board":new f(o.ops6).Bankuai("#table_wrapper","m:0+s:3");break;case"index_sh":new f(o.ops7).Bankuai("#table_wrapper","m:1+s:2");break;case"index_sz":new f(o.ops7).Bankuai("#table_wrapper","m:0+t:5");break;case"index_components":new f(o.ops7).Bankuai("#table_wrapper","m:1+s:3,m:0+t:5");break;case"index_zzzs":new f(o.ops7).Bankuai("#table_wrapper","m:1+s:1");break;case"hk_sh_stocks":new f(o.hkshstocks).Bankuai("#table_wrapper","b:MK0144");break;case"hk_sz_stocks":new f(o.hkshstocks).Bankuai("#table_wrapper","b:MK0146");break;case"ah_comparison":case"hkah_comparison":t.ajax({type:"get",data:"",url:"http://push2.eastmoney.com/api/qt/clist/get?pn=1&pz=20&po=1&np=1&ut=bd1d9ddb04089700cf9c27f6f7426281&fltt=2&invt=2&fid=f3&fs=b:MK0101&fields=f1,f2,f3,f4,f5,f6,f7,f8,f9,f10",dataType:"jsonp",jsonp:"cb",success:function(e){e&&e.lt&&(1==e.lt&&i?(new f(o.ahgu2).Bankuai("#table_wrapper","b:MK0101"),t("#yssm").hide()):(new f(o.ahgu2).Bankuai("#table_wrapper","b:DLMK0101"),t("#yssm").show()))}});break;case"neeq_stocks":new f(o.ops9).Bankuai("#table_wrapper","m:0+t:81+s:!4");break;case"neeq_innovate":new f(o.ops9).Bankuai("#table_wrapper","m:0+s:512");break;case"neeq_basic":new f(o.ops9).Bankuai("#table_wrapper","m:0+s:256");break;case"neeq_agreement":new f(o.ops9).Bankuai("#table_wrapper","m:0+s:16");break;case"neeq_marketmaking":new f(o.ops9).Bankuai("#table_wrapper","m:0+s:32");break;case"neeq_bidding":new f(o.ops9).Bankuai("#table_wrapper","m:0+s:192");break;case"hk_stocks":new f(o.hkstocks).Bankuai("#table_wrapper","m:116");break;case"hk_mainboard":new f(o.hkstocks).Bankuai("#table_wrapper","m:116+t:3");break;case"hk_gem":new f(o.hkstocks).Bankuai("#table_wrapper","m:116+t:4");break;case"hk_wellknown":new f(o.hkstocks).Bankuai("#table_wrapper","b:MK0106");break;case"hk_bluechips":new f(o.hkstocks).Bankuai("#table_wrapper","b:MK0104");break;case"hk_redchips":new f(o.hkstocks).Bankuai("#table_wrapper","b:MK0102");break;case"hk_redchips_components":new f(o.hkstocks).Bankuai("#table_wrapper","b:MK0111");break;case"hk_stateowned":new f(o.hkstocks).Bankuai("#table_wrapper","b:MK0103");break;case"hk_stateowned_components":new f(o.hkstocks).Bankuai("#table_wrapper","b:MK0112");break;case"hk_components":new f(o.hkstocks).Bankuai("#table_wrapper","b:MK0146,b:MK0144");break;case"hk_components":new f(o.hkstocks).Bankuai("#table_wrapper","111");break;case"hsi_large_components":new f(o.hkstocks).Bankuai("#table_wrapper","b:MK0141");break;case"hsi_medium_components":new f(o.hkstocks).Bankuai("#table_wrapper","b:MK0142");break;case"hk_adr":new f(o.hkadr).Bankuai("#table_wrapper","m:116+s:1");break;case"hk_index":new f(o.hkindex).Bankuai("#table_wrapper","m:124,m:125,m:305");break;case"hk_warrants":new f(o.hkindex).Bankuai("#table_wrapper","m:116+t:6");break;case"hk_CBBCs":new f(o.hkindexNXZ).Bankuai("#table_wrapper","m:116+t:5+s:6");break;case"us_stocks":new f(o.usstocks).Bankuai("#table_wrapper","m:105,m:106,m:107");break;case"us_chinese":new f(o.usstocks).Bankuai("#table_wrapper","b:MK0201");break;case"us_index":new f(o.usindex).Bankuai("#table_wrapper","i:100.NDX,i:100.DJIA,i:100.SPX");break;case"us_wellknown":new f(o.usstocks).Bankuai("#table_wrapper","b:MK0001");break;case"us_technology":new f(o.usstocks).Bankuai("#table_wrapper","b:MK0216");break;case"us_financial":new f(o.usstocks).Bankuai("#table_wrapper","b:MK0217");break;case"us_medicine_food":new f(o.usstocks).Bankuai("#table_wrapper","b:MK0218");break;case"us_media":new f(o.usstocks).Bankuai("#table_wrapper","b:MK0220");break;case"us_automotive_energy":new f(o.usstocks).Bankuai("#table_wrapper","b:MK0219");break;case"us_manufacture_retail":new f(o.usstocks).Bankuai("#table_wrapper","b:MK0221");break;case"us_chinese_internet":new f(o.usstocks).Bankuai("#table_wrapper","b:MK0202");break;case"global_asia":new f(o.globalamerica).Bankuai("#table_wrapper","i:1.000001,i:0.399001,i:0.399005,i:0.399006,i:1.000300,i:100.HSI,i:100.HSCEI,i:124.HSCCI,i:100.TWII,i:100.N225,i:100.KOSPI200,i:100.KS11,i:100.STI,i:100.SENSEX,i:100.KLSE,i:100.SET,i:100.PSI,i:100.KSE100,i:100.VNINDEX,i:100.JKSE,i:100.CSEALL");break;case"global_america":new f(o.globalamerica).Bankuai("#table_wrapper","i:100.DJIA,i:100.SPX,i:100.NDX,i:100.TSX,i:100.BVSP,i:100.MXX");break;case"global_euro":new f(o.globalamerica).Bankuai("#table_wrapper","i:100.SX5E,i:100.FTSE,i:100.MCX,i:100.AXX,i:100.FCHI,i:100.GDAXI,i:100.RTS,i:100.IBEX,i:100.PSI20,i:100.OMXC20,i:100.BFX,i:100.AEX,i:100.WIG,i:100.OMXSPI,i:100.SSMI,i:100.HEX,i:100.OSEBX,i:100.ATX,i:100.MIB,i:100.ASE,i:100.ICEXI,i:100.PX,i:100.ISEQ");break;case"global_australia":new f(o.globalamerica).Bankuai("#table_wrapper","i:100.AS51,i:100.AORD,i:100.NZ50");break;case"global_qtzs":new f(o.globalamerica).Bankuai("#table_wrapper","i:100.UDI,i:100.BDI,i:100.CRB");break;case"futures_cffex":var r={type:"zjs",order:"zdf",url:a.qihuourl+"/list/8"};new n(r).Qihuo("#table_wrapper");break;case"futures_cffex-_TS":r={type:"zjs",order:"zdf",url:a.qihuourl+"/list/variety/8/6"};new n(r).Qihuo("#table_wrapper");break;case"futures_cffex-_T":r={type:"zjs",order:"zdf",url:a.qihuourl+"/list/variety/8/4"};new n(r).Qihuo("#table_wrapper");break;case"futures_cffex-_TF":r={type:"zjs",order:"zdf",url:a.qihuourl+"/list/variety/8/5"};new n(r).Qihuo("#table_wrapper");break;case"futures_cffex-_IF":r={type:"zjs",order:"zdf",url:a.qihuourl+"/list/variety/8/2"};new n(r).Qihuo("#table_wrapper");break;case"futures_cffex-_IH":r={type:"zjs",order:"zdf",url:a.qihuourl+"/list/variety/8/3"};new n(r).Qihuo("#table_wrapper");break;case"futures_cffex-_IC":r={type:"zjs",order:"zdf",url:a.qihuourl+"/list/variety/8/1"};new n(r).Qihuo("#table_wrapper");break;case"hk_index_futures":r={type:"gjs",order:"name",orderDur:"1",url:a.qihuourl+"/list/HKINDEXF"};new n(r).Qihuo("#table_wrapper");break;case"hk_stock_futures":r={type:"gjs_gpqh",order:"name",orderDur:"1",url:a.qihuourl+"/list/HKSTOCKF"};new n(r).Qihuo("#table_wrapper");break;case"HCF_CUS":r={type:"gjs",order:"name",orderDur:"1",url:a.qihuourl+"/list/HKCNYF"};new n(r).Qihuo("#table_wrapper");break;case"HMFS_LRP":r={type:"gjs",order:"name",orderDur:"1",url:a.qihuourl+"/list/HKMETALFS"};new n(r).Qihuo("#table_wrapper");break;case"futures_global":r={type:"gjqh",order:"zdf",url:a.qihuourl+"/list/COMEX,NYMEX,COBOT,SGX,NYBOT,LME,MDEX,TOCOM,IPE"};new n(r).Qihuo("#table_wrapper");break;case"futures_global-comex":r={type:"gjqh",order:"zdf",url:a.qihuourl+"/list/COMEX"};new n(r).Qihuo("#table_wrapper");break;case"futures_global-nymex":r={type:"gjqh",order:"zdf",url:a.qihuourl+"/list/NYMEX"};new n(r).Qihuo("#table_wrapper");break;case"futures_global-cobot":r={type:"gjqh",order:"zdf",url:a.qihuourl+"/list/COBOT"};new n(r).Qihuo("#table_wrapper");break;case"futures_global-sgx":r={type:"gjqh",order:"zdf",url:a.qihuourl+"/list/SGX"};new n(r).Qihuo("#table_wrapper");break;case"futures_global-nybot":r={type:"gjqh",order:"zdf",url:a.qihuourl+"/list/NYBOT"};new n(r).Qihuo("#table_wrapper");break;case"futures_global-lme":r={type:"gjqh",order:"zdf",url:a.qihuourl+"/list/LME"};new n(r).Qihuo("#table_wrapper");break;case"futures_global-mdex":r={type:"gjqh",order:"zdf",url:a.qihuourl+"/list/MDEX"};new n(r).Qihuo("#table_wrapper");break;case"futures_global-tocom":r={type:"gjqh",order:"zdf",url:a.qihuourl+"/list/TOCOM"};new n(r).Qihuo("#table_wrapper");break;case"futures_global-ipe":r={type:"gjqh",order:"zdf",url:a.qihuourl+"/list/IPE"};new n(r).Qihuo("#table_wrapper");break;case"futures_finance":r={blockName:"financial",type:"gjqh",order:"zdf",url:a.qihuourl+"/list/block"};new n(r).Qihuo("#table_wrapper");break;case"futures_energy":r={blockName:"energy",type:"gjqh",order:"zdf",url:a.qihuourl+"/list/block"};new n(r).Qihuo("#table_wrapper");break;case"futures_metal":r={blockName:"metal",type:"gjqh",order:"zdf",url:a.qihuourl+"/list/block"};new n(r).Qihuo("#table_wrapper");break;case"futures_farmproduce":r={blockName:"agricultural",type:"gjqh",order:"zdf",url:a.qihuourl+"/list/block"};new n(r).Qihuo("#table_wrapper");break;case"fund_close_end":new f(o.fundcloseend).Bankuai("#table_wrapper","e:19");break;case"fund_etf":new f(o.fundcloseend).Bankuai("#table_wrapper","b:MK0021,b:MK0022,b:MK0023,b:MK0024");break;case"fund_lof":new f(o.fundcloseend).Bankuai("#table_wrapper","b:MK0404,b:MK0405,b:MK0406,b:MK0407");break;case"bond_index":new f(o.bond).Bankuai("#table_wrapper","i:1.000012,i:1.000013,i:1.000022,i:1.000061,i:0.395021,i:0.395022,i:0.395031,i:0.395032,i:0.399481");break;case"bond_sh":new f(o.bond).Bankuai("#table_wrapper","m:1+t:4");break;case"bond_national_sh":new f(o.bondnew).Bankuai("#table_wrapper","m:1+b:MK0351");break;case"bond_enterprise_sh":new f(o.bondnew).Bankuai("#table_wrapper","m:1+b:MK0353");break;case"bond_convertible_sh":new f(o.bond).Bankuai("#table_wrapper","m:1+b:MK0354");break;case"bond_sz":new f(o.bond).Bankuai("#table_wrapper","m:0+t:8");break;case"bond_national_sz":new f(o.bondnew).Bankuai("#table_wrapper","m:0+b:MK0351");break;case"bond_enterprise_sz":new f(o.bondnew).Bankuai("#table_wrapper","m:0+b:MK0353");break;case"bond_convertible_sz":new f(o.bond).Bankuai("#table_wrapper","m:0+b:MK0354");break;case"bond_sh_buyback":new f(o.bondnew).Bankuai("#table_wrapper","m:1+b:MK0356");break;case"bond_sz_buyback":new f(o.bondnew).Bankuai("#table_wrapper","m:0+b:MK0356");break;case"forex_all":new f(o.forex).Bankuai("#table_wrapper","m:119,m:120,m:121,m:133");break;case"forex_basic":new f(o.forex).Bankuai("#table_wrapper","b:MK0300");break;case"forex_cross":new f(o.forex).Bankuai("#table_wrapper","b:MK0301");break;case"forex_cny":new f(o.forex).Bankuai("#table_wrapper","m:120,m:121,m:133");break;case"forex_cnyc":new f(o.forex).Bankuai("#table_wrapper","m:120");break;case"forex_cnyi":new f(o.forex).Bankuai("#table_wrapper","m:121+t:1");break;case"forex_cnyb":new f(o.forex).Bankuai("#table_wrapper","m:121+t:2");break;case"forex_cnh":new f(o.forex).Bankuai("#table_wrapper","m:133");break;case"forex_exchange_icbc":new f(o.whpj).Bankuai("#table_wrapper","m:162+s:1");break;case"forex_exchange_abc":new f(o.whpj).Bankuai("#table_wrapper","m:162+s:2");break;case"forex_exchange_boc":new f(o.whpj).Bankuai("#table_wrapper","m:162+s:4");break;case"forex_exchange_ccb":new f(o.whpj).Bankuai("#table_wrapper","m:162+s:8");break;case"forex_exchange_bcm":new f(o.whpj).Bankuai("#table_wrapper","m:162+s:16");break;case"forex_exchange_cmb":new f(o.whpj).Bankuai("#table_wrapper","m:162+s:32");break;case"options_sh50etf_all":new f(o.qqsc).Bankuai("#table_wrapper","m:10");break;case"options_szetf_all":case"options_sz300etf_all":new f(o.qqsc).Bankuai("#table_wrapper","m:12");break;case"options_sh50etf_call":new f(o.qqsc).Bankuai("#table_wrapper","m:10+t:173");break;case"options_sh50etf_put":new f(o.qqsc).Bankuai("#table_wrapper","m:10+t:174");break;case"options_shfe_all":r={type:"qqsc",order:"zdf",url:a.qihuourl+"/list/SHFEOPTION"};new n(r).Qihuo("#table_wrapper");break;case"options_cu_all":r={type:"qqsc",order:"zdf",url:a.qihuourl+"/list/variety/SHFEOPTION/1"};new n(r).Qihuo("#table_wrapper");break;case"options_ru_all":r={type:"qqsc",order:"zdf",url:a.qihuourl+"/list/variety/SHFEOPTION/2"};new n(r).Qihuo("#table_wrapper");break;case"options_au_all":r={type:"qqsc",order:"zdf",url:a.qihuourl+"/list/variety/151/3"};new n(r).Qihuo("#table_wrapper");break;case"options_dce_all":r={type:"qqsc",order:"zdf",url:a.qihuourl+"/list/DCEOPTION"};new n(r).Qihuo("#table_wrapper");break;case"options_beanpulp_all":r={type:"qqsc",order:"zdf",url:a.qihuourl+"/list/variety/DCEOPTION/1"};new n(r).Qihuo("#table_wrapper");break;case"options_c_all":r={type:"qqsc",order:"zdf",url:a.qihuourl+"/list/variety/DCEOPTION/2"};new n(r).Qihuo("#table_wrapper");break;case"options_t_all":r={type:"qqsc",order:"zdf",url:a.qihuourl+"/list/variety/DCEOPTION/3"};new n(r).Qihuo("#table_wrapper");break;case"options_czce_all":r={type:"qqsc",order:"zdf",url:a.qihuourl+"/list/CZCEOPTION"};new n(r).Qihuo("#table_wrapper");break;case"options_sugar_all":r={type:"qqsc",order:"zdf",url:a.qihuourl+"/list/variety/CZCEOPTION/1"};new n(r).Qihuo("#table_wrapper");break;case"options_cf_all":r={type:"qqsc",order:"zdf",url:a.qihuourl+"/list/variety/CZCEOPTION/2"};new n(r).Qihuo("#table_wrapper");break;case"options_cf_ta":r={type:"qqsc",order:"zdf",url:a.qihuourl+"/list/variety/CZCEOPTION/4"};new n(r).Qihuo("#table_wrapper");break;case"options_cf_ma":r={type:"qqsc",order:"zdf",url:a.qihuourl+"/list/variety/CZCEOPTION/3"};new n(r).Qihuo("#table_wrapper");break;case"options_cf_cp":r={type:"qqsc",order:"zdf",url:a.qihuourl+"/list/variety/CZCEOPTION/5"};new n(r).Qihuo("#table_wrapper");break;case"options_cffex_all":case"options_cffex_io":r={type:"qqsc",order:"zdf",url:a.qihuourl+"/list/11",sc:11};new n(r).Qihuo("#table_wrapper");break;case"options_uscny_all":r={type:"qqsc",order:"zdf",url:a.qihuourl+"/list/HKUSDCNHOP"};new n(r).Qihuo("#table_wrapper");break;case"gold_sh_spotgoods":new f(o.gold).Bankuai("#table_wrapper","m:118");break;case"gold_sh_futures":new f(o.zjs).Bankuai("#table_wrapper","m:113+t:5");break;case"nobalmetal_spotgoods":new f(o.gold,"nobalmetal_spotgoods").Bankuai("#table_wrapper","m:122,m:123");break;case"nobalmetal_futures":new f(o.gold).Bankuai("#table_wrapper","i:111.JAGC,i:101.QI00Y,i:111.JPAC,i:101.HG00Y,i:111.JAUC,i:111.JPLC,i:102.PL00Y,i:101.QO00Y,i:101.MGC00Y,i:101.GC00Y,i:101.SI00Y,i:102.PA00Y");break;default:window.location.href="//quote.eastmoney.com/center/gridlist.html#hs_a_board"}}}).call(this,r(11))}]);
//# sourceMappingURL=gridlist3.min.js.map'''

menu='''[{"key":"index","show":true,"name":"","title":"首页","href":"/center","target":"_self","order":-20,"groupKey":"","className":"","hot":false,"next":[]},{"key":"kcb","show":true,"name":"","title":"科创板","href":"/center/gridlist.html#kcb_board","target":"_self","order":-1,"groupKey":"","className":"","hot":false,"next":[]},{"key":"favor","show":true,"name":"","title":"自选股","href":"http://quote.eastmoney.com/zixuan/?from=quotecenter","target":"_blank","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"sp_quotation","show":true,"name":"","title":"特色行情","href":"http://quote.eastmoney.com/zhuti/?from=center","target":"_blank","order":1,"groupKey":"","className":"","hot":false,"next":[{"key":"sp_quotation_changes","show":true,"name":"","title":"盘口异动","href":"http://quote.eastmoney.com/changes?from=center","target":"_blank","order":1,"groupKey":"","className":"","hot":false,"next":[]},{"key":"sp_quotation_zhuti","show":true,"name":"","title":"主题投资","href":"http://quote.eastmoney.com/zhuti/?from=center","target":"_blank","order":2,"groupKey":"","className":"","hot":false,"next":[]}]},{"key":"hs_market","show":true,"name":"","title":"沪深个股","href":"/center/gridlist.html#hs_a_board","target":"_self","order":2,"groupKey":"","className":"","hot":false,"next":[{"key":"hs_a_board","show":true,"name":"","title":"沪深A股","href":"/center/gridlist.html#hs_a_board","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"sh_a_board","show":true,"name":"","title":"上证A股","href":"/center/gridlist.html#sh_a_board","target":"_self","order":1,"groupKey":"","className":"","hot":false,"next":[]},{"key":"sz_a_board","show":true,"name":"","title":"深证A股","href":"/center/gridlist.html#sz_a_board","target":"_self","order":2,"groupKey":"","className":"","hot":false,"next":[]},{"key":"newshares","show":true,"name":"","title":"新股","href":"/center/gridlist.html#newshares","target":"_self","order":3,"groupKey":"","className":"","hot":false,"next":[]},{"key":"sme_board","show":true,"name":"","title":"中小板","href":"/center/gridlist.html#sme_board","target":"_self","order":4,"groupKey":"","className":"","hot":false,"next":[]},{"key":"gem_board","show":true,"name":"","title":"创业板","href":"/center/gridlist.html#gem_board","target":"_self","order":5,"groupKey":"","className":"","hot":false,"next":[]},{"key":"kcb_board","show":true,"name":"","title":"科创板","href":"/center/gridlist.html#kcb_board","target":"_self","order":6,"groupKey":"","className":"","hot":false,"next":[]},{"key":"sh_hk_board","show":true,"name":"","title":"沪股通","href":"/center/gridlist.html#sh_hk_board","target":"_self","order":7,"groupKey":"","className":"","hot":false,"next":[]},{"key":"sz_hk_board","show":true,"name":"","title":"深股通","href":"/center/gridlist.html#sz_hk_board","target":"_self","order":8,"groupKey":"","className":"","hot":false,"next":[]},{"key":"b_board","show":true,"name":"","title":"B股","href":"/center/gridlist.html#b_board","target":"_self","order":9,"groupKey":"","className":"","hot":false,"next":[]},{"key":"ab_comparison","show":true,"name":"","title":"AB股比价","href":"/center/gridlist.html#ab_comparison_sh","target":"_self","order":10,"groupKey":"","className":"","hot":false,"next":[{"key":"ab_comparison_sh","show":true,"name":"","title":"上证AB股比价","href":"/center/gridlist.html#ab_comparison_sh","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"ab_comparison_sz","show":true,"name":"","title":"深证AB股比价","href":"/center/gridlist.html#ab_comparison_sz","target":"_self","order":1,"groupKey":"","className":"","hot":false,"next":[]}]},{"key":"st_board","show":true,"name":"","title":"风险警示板","href":"/center/gridlist.html#st_board","target":"_self","order":11,"groupKey":"","className":"","hot":false,"next":[]},{"key":"staq_net_board","show":true,"name":"","title":"两网及退市","href":"/center/gridlist.html#staq_net_board","target":"_self","order":12,"groupKey":"","className":"","hot":false,"next":[]}]},{"key":"hsbroad","show":true,"name":"","title":"沪深板块","href":"/center/hsbk.html","target":"_self","order":3,"groupKey":"","className":"","hot":false,"next":[{"key":"concept_board","show":true,"name":"","title":"概念板块","href":"/center/boardlist.html#concept_board","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[{"key":"boards2-90.BK0713","show":true,"name":"","title":"2025规划","href":"/center/boardlist.html#boards2-90.BK0713","target":null,"order":0,"groupKey":"#","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0881","show":true,"name":"","title":"3D玻璃","href":"/center/boardlist.html#boards2-90.BK0881","target":null,"order":1,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0619","show":true,"name":"","title":"3D打印","href":"/center/boardlist.html#boards2-90.BK0619","target":null,"order":2,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0901","show":true,"name":"","title":"3D摄像头","href":"/center/boardlist.html#boards2-90.BK0901","target":null,"order":3,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0714","show":true,"name":"","title":"5G概念","href":"/center/boardlist.html#boards2-90.BK0714","target":null,"order":4,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0498","show":true,"name":"","title":"AB股","href":"/center/boardlist.html#boards2-90.BK0498","target":null,"order":5,"groupKey":"A","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0499","show":true,"name":"","title":"AH股","href":"/center/boardlist.html#boards2-90.BK0499","target":null,"order":6,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0689","show":true,"name":"","title":"阿里概念","href":"/center/boardlist.html#boards2-90.BK0689","target":null,"order":7,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0894","show":true,"name":"","title":"阿兹海默","href":"/center/boardlist.html#boards2-90.BK0894","target":null,"order":8,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0629","show":true,"name":"","title":"北斗导航","href":"/center/boardlist.html#boards2-90.BK0629","target":null,"order":9,"groupKey":"B","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0675","show":true,"name":"","title":"病毒防治","href":"/center/boardlist.html#boards2-90.BK0675","target":null,"order":10,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0845","show":true,"name":"","title":"百度概念","href":"/center/boardlist.html#boards2-90.BK0845","target":null,"order":11,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0636","show":true,"name":"","title":"B股","href":"/center/boardlist.html#boards2-90.BK0636","target":null,"order":12,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0566","show":true,"name":"","title":"滨海新区","href":"/center/boardlist.html#boards2-90.BK0566","target":null,"order":13,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0896","show":true,"name":"","title":"白酒","href":"/center/boardlist.html#boards2-90.BK0896","target":null,"order":14,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0717","show":true,"name":"","title":"北京冬奥","href":"/center/boardlist.html#boards2-90.BK0717","target":null,"order":15,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0879","show":true,"name":"","title":"标普概念","href":"/center/boardlist.html#boards2-90.BK0879","target":null,"order":16,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0860","show":true,"name":"","title":"边缘计算","href":"/center/boardlist.html#boards2-90.BK0860","target":null,"order":17,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0812","show":true,"name":"","title":"贬值受益","href":"/center/boardlist.html#boards2-90.BK0812","target":null,"order":18,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0679","show":true,"name":"","title":"超导概念","href":"/center/boardlist.html#boards2-90.BK0679","target":null,"order":19,"groupKey":"C","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0700","show":true,"name":"","title":"充电桩","href":"/center/boardlist.html#boards2-90.BK0700","target":null,"order":20,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0824","show":true,"name":"","title":"参股360","href":"/center/boardlist.html#boards2-90.BK0824","target":null,"order":21,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0604","show":true,"name":"","title":"参股保险","href":"/center/boardlist.html#boards2-90.BK0604","target":null,"order":22,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0950","show":true,"name":"","title":"草甘膦","href":"/center/boardlist.html#boards2-90.BK0950","target":null,"order":23,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0905","show":true,"name":"","title":"传感器","href":"/center/boardlist.html#boards2-90.BK0905","target":null,"order":24,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0524","show":true,"name":"","title":"参股期货","href":"/center/boardlist.html#boards2-90.BK0524","target":null,"order":25,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0514","show":true,"name":"","title":"参股券商","href":"/center/boardlist.html#boards2-90.BK0514","target":null,"order":26,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0525","show":true,"name":"","title":"参股银行","href":"/center/boardlist.html#boards2-90.BK0525","target":null,"order":27,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0703","show":true,"name":"","title":"超级电容","href":"/center/boardlist.html#boards2-90.BK0703","target":null,"order":28,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0811","show":true,"name":"","title":"超级品牌","href":"/center/boardlist.html#boards2-90.BK0811","target":null,"order":29,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0862","show":true,"name":"","title":"超级真菌","href":"/center/boardlist.html#boards2-90.BK0862","target":null,"order":30,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0920","show":true,"name":"","title":"车联网","href":"/center/boardlist.html#boards2-90.BK0920","target":null,"order":31,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0671","show":true,"name":"","title":"彩票概念","href":"/center/boardlist.html#boards2-90.BK0671","target":null,"order":32,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0859","show":true,"name":"","title":"超清视频","href":"/center/boardlist.html#boards2-90.BK0859","target":null,"order":33,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0899","show":true,"name":"","title":"CRO","href":"/center/boardlist.html#boards2-90.BK0899","target":null,"order":34,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0506","show":true,"name":"","title":"创投","href":"/center/boardlist.html#boards2-90.BK0506","target":null,"order":35,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0501","show":true,"name":"","title":"次新股","href":"/center/boardlist.html#boards2-90.BK0501","target":null,"order":36,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0874","show":true,"name":"","title":"创业板壳","href":"/center/boardlist.html#boards2-90.BK0874","target":null,"order":37,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0742","show":true,"name":"","title":"创业板综","href":"/center/boardlist.html#boards2-90.BK0742","target":null,"order":38,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0638","show":true,"name":"","title":"创业成份","href":"/center/boardlist.html#boards2-90.BK0638","target":null,"order":39,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0534","show":true,"name":"","title":"成渝特区","href":"/center/boardlist.html#boards2-90.BK0534","target":null,"order":40,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0838","show":true,"name":"","title":"东北振兴","href":"/center/boardlist.html#boards2-90.BK0838","target":null,"order":41,"groupKey":"D","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0814","show":true,"name":"","title":"大飞机","href":"/center/boardlist.html#boards2-90.BK0814","target":null,"order":42,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0835","show":true,"name":"","title":"独角兽","href":"/center/boardlist.html#boards2-90.BK0835","target":null,"order":43,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0676","show":true,"name":"","title":"独家药品","href":"/center/boardlist.html#boards2-90.BK0676","target":null,"order":44,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0870","show":true,"name":"","title":"单抗概念","href":"/center/boardlist.html#boards2-90.BK0870","target":null,"order":45,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0622","show":true,"name":"","title":"地热能","href":"/center/boardlist.html#boards2-90.BK0622","target":null,"order":46,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0665","show":true,"name":"","title":"电商概念","href":"/center/boardlist.html#boards2-90.BK0665","target":null,"order":47,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0634","show":true,"name":"","title":"大数据","href":"/center/boardlist.html#boards2-90.BK0634","target":null,"order":48,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0853","show":true,"name":"","title":"电子竞技","href":"/center/boardlist.html#boards2-90.BK0853","target":null,"order":49,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0865","show":true,"name":"","title":"电子烟","href":"/center/boardlist.html#boards2-90.BK0865","target":null,"order":50,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0875","show":true,"name":"","title":"ETC","href":"/center/boardlist.html#boards2-90.BK0875","target":null,"order":51,"groupKey":"E","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0664","show":true,"name":"","title":"二胎概念","href":"/center/boardlist.html#boards2-90.BK0664","target":null,"order":52,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0878","show":true,"name":"","title":"分拆预期","href":"/center/boardlist.html#boards2-90.BK0878","target":null,"order":53,"groupKey":"F","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0690","show":true,"name":"","title":"氟化工","href":"/center/boardlist.html#boards2-90.BK0690","target":null,"order":54,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0595","show":true,"name":"","title":"风能","href":"/center/boardlist.html#boards2-90.BK0595","target":null,"order":55,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0867","show":true,"name":"","title":"富时概念","href":"/center/boardlist.html#boards2-90.BK0867","target":null,"order":56,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0842","show":true,"name":"","title":"富士康","href":"/center/boardlist.html#boards2-90.BK0842","target":null,"order":57,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0696","show":true,"name":"","title":"国产软件","href":"/center/boardlist.html#boards2-90.BK0696","target":null,"order":58,"groupKey":"G","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0891","show":true,"name":"","title":"国产芯片","href":"/center/boardlist.html#boards2-90.BK0891","target":null,"order":59,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0904","show":true,"name":"","title":"广电","href":"/center/boardlist.html#boards2-90.BK0904","target":null,"order":60,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0868","show":true,"name":"","title":"GDR概念","href":"/center/boardlist.html#boards2-90.BK0868","target":null,"order":61,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0667","show":true,"name":"","title":"国家安防","href":"/center/boardlist.html#boards2-90.BK0667","target":null,"order":62,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0884","show":true,"name":"","title":"光刻胶","href":"/center/boardlist.html#boards2-90.BK0884","target":null,"order":63,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0683","show":true,"name":"","title":"国企改革","href":"/center/boardlist.html#boards2-90.BK0683","target":null,"order":64,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0567","show":true,"name":"","title":"股权激励","href":"/center/boardlist.html#boards2-90.BK0567","target":null,"order":65,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0803","show":true,"name":"","title":"股权转让","href":"/center/boardlist.html#boards2-90.BK0803","target":null,"order":66,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0723","show":true,"name":"","title":"高送转","href":"/center/boardlist.html#boards2-90.BK0723","target":null,"order":67,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0491","show":true,"name":"","title":"高校","href":"/center/boardlist.html#boards2-90.BK0491","target":null,"order":68,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0807","show":true,"name":"","title":"共享经济","href":"/center/boardlist.html#boards2-90.BK0807","target":null,"order":69,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0810","show":true,"name":"","title":"工业4.0","href":"/center/boardlist.html#boards2-90.BK0810","target":null,"order":70,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0856","show":true,"name":"","title":"工业大麻","href":"/center/boardlist.html#boards2-90.BK0856","target":null,"order":71,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0832","show":true,"name":"","title":"工业互联","href":"/center/boardlist.html#boards2-90.BK0832","target":null,"order":72,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0707","show":true,"name":"","title":"沪股通","href":"/center/boardlist.html#boards2-90.BK0707","target":null,"order":73,"groupKey":"H","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0512","show":true,"name":"","title":"化工原料","href":"/center/boardlist.html#boards2-90.BK0512","target":null,"order":74,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0601","show":true,"name":"","title":"海工装备","href":"/center/boardlist.html#boards2-90.BK0601","target":null,"order":75,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0908","show":true,"name":"","title":"HIT电池","href":"/center/boardlist.html#boards2-90.BK0908","target":null,"order":76,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0547","show":true,"name":"","title":"黄金概念","href":"/center/boardlist.html#boards2-90.BK0547","target":null,"order":77,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0637","show":true,"name":"","title":"互联金融","href":"/center/boardlist.html#boards2-90.BK0637","target":null,"order":78,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0837","show":true,"name":"","title":"互联医疗","href":"/center/boardlist.html#boards2-90.BK0837","target":null,"order":79,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0724","show":true,"name":"","title":"海绵城市","href":"/center/boardlist.html#boards2-90.BK0724","target":null,"order":80,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0715","show":true,"name":"","title":"航母概念","href":"/center/boardlist.html#boards2-90.BK0715","target":null,"order":81,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0577","show":true,"name":"","title":"核能核电","href":"/center/boardlist.html#boards2-90.BK0577","target":null,"order":82,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0672","show":true,"name":"","title":"沪企改革","href":"/center/boardlist.html#boards2-90.BK0672","target":null,"order":83,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0500","show":true,"name":"","title":"HS300_","href":"/center/boardlist.html#boards2-90.BK0500","target":null,"order":84,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0854","show":true,"name":"","title":"华为概念","href":"/center/boardlist.html#boards2-90.BK0854","target":null,"order":85,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0623","show":true,"name":"","title":"海洋经济","href":"/center/boardlist.html#boards2-90.BK0623","target":null,"order":86,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0697","show":true,"name":"","title":"IPO受益","href":"/center/boardlist.html#boards2-90.BK0697","target":null,"order":87,"groupKey":"I","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0897","show":true,"name":"","title":"IPv6","href":"/center/boardlist.html#boards2-90.BK0897","target":null,"order":88,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0561","show":true,"name":"","title":"基本金属","href":"/center/boardlist.html#boards2-90.BK0561","target":null,"order":89,"groupKey":"J","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0849","show":true,"name":"","title":"京东金融","href":"/center/boardlist.html#boards2-90.BK0849","target":null,"order":90,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0490","show":true,"name":"","title":"军工","href":"/center/boardlist.html#boards2-90.BK0490","target":null,"order":91,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0552","show":true,"name":"","title":"机构重仓","href":"/center/boardlist.html#boards2-90.BK0552","target":null,"order":92,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0684","show":true,"name":"","title":"京津冀","href":"/center/boardlist.html#boards2-90.BK0684","target":null,"order":93,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0909","show":true,"name":"","title":"降解塑料","href":"/center/boardlist.html#boards2-90.BK0909","target":null,"order":94,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0536","show":true,"name":"","title":"基金重仓","href":"/center/boardlist.html#boards2-90.BK0536","target":null,"order":95,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0850","show":true,"name":"","title":"进口博览","href":"/center/boardlist.html#boards2-90.BK0850","target":null,"order":96,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0719","show":true,"name":"","title":"健康中国","href":"/center/boardlist.html#boards2-90.BK0719","target":null,"order":97,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0808","show":true,"name":"","title":"军民融合","href":"/center/boardlist.html#boards2-90.BK0808","target":null,"order":98,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0494","show":true,"name":"","title":"节能环保","href":"/center/boardlist.html#boards2-90.BK0494","target":null,"order":99,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0685","show":true,"name":"","title":"举牌概念","href":"/center/boardlist.html#boards2-90.BK0685","target":null,"order":100,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0887","show":true,"name":"","title":"鸡肉概念","href":"/center/boardlist.html#boards2-90.BK0887","target":null,"order":101,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0693","show":true,"name":"","title":"基因测序","href":"/center/boardlist.html#boards2-90.BK0693","target":null,"order":102,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0806","show":true,"name":"","title":"精准医疗","href":"/center/boardlist.html#boards2-90.BK0806","target":null,"order":103,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0990","show":true,"name":"","title":"快递概念","href":"/center/boardlist.html#boards2-90.BK0990","target":null,"order":104,"groupKey":"K","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0818","show":true,"name":"","title":"可燃冰","href":"/center/boardlist.html#boards2-90.BK0818","target":null,"order":105,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0911","show":true,"name":"","title":"口罩","href":"/center/boardlist.html#boards2-90.BK0911","target":null,"order":106,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0820","show":true,"name":"","title":"壳资源","href":"/center/boardlist.html#boards2-90.BK0820","target":null,"order":107,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0674","show":true,"name":"","title":"蓝宝石","href":"/center/boardlist.html#boards2-90.BK0674","target":null,"order":108,"groupKey":"L","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0574","show":true,"name":"","title":"锂电池","href":"/center/boardlist.html#boards2-90.BK0574","target":null,"order":109,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0580","show":true,"name":"","title":"LED","href":"/center/boardlist.html#boards2-90.BK0580","target":null,"order":110,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0906","show":true,"name":"","title":"流感","href":"/center/boardlist.html#boards2-90.BK0906","target":null,"order":111,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0873","show":true,"name":"","title":"垃圾分类","href":"/center/boardlist.html#boards2-90.BK0873","target":null,"order":112,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0852","show":true,"name":"","title":"冷链物流","href":"/center/boardlist.html#boards2-90.BK0852","target":null,"order":113,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0710","show":true,"name":"","title":"量子通信","href":"/center/boardlist.html#boards2-90.BK0710","target":null,"order":114,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0492","show":true,"name":"","title":"煤化工","href":"/center/boardlist.html#boards2-90.BK0492","target":null,"order":115,"groupKey":"M","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0902","show":true,"name":"","title":"MiniLED","href":"/center/boardlist.html#boards2-90.BK0902","target":null,"order":116,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0890","show":true,"name":"","title":"MLCC","href":"/center/boardlist.html#boards2-90.BK0890","target":null,"order":117,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0626","show":true,"name":"","title":"美丽中国","href":"/center/boardlist.html#boards2-90.BK0626","target":null,"order":118,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0857","show":true,"name":"","title":"MSCI大盘","href":"/center/boardlist.html#boards2-90.BK0857","target":null,"order":119,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0821","show":true,"name":"","title":"MSCI中国","href":"/center/boardlist.html#boards2-90.BK0821","target":null,"order":120,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0858","show":true,"name":"","title":"MSCI中盘","href":"/center/boardlist.html#boards2-90.BK0858","target":null,"order":121,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0698","show":true,"name":"","title":"免疫治疗","href":"/center/boardlist.html#boards2-90.BK0698","target":null,"order":122,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0855","show":true,"name":"","title":"纳米银","href":"/center/boardlist.html#boards2-90.BK0855","target":null,"order":123,"groupKey":"N","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0888","show":true,"name":"","title":"农业种植","href":"/center/boardlist.html#boards2-90.BK0888","target":null,"order":124,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0840","show":true,"name":"","title":"OLED","href":"/center/boardlist.html#boards2-90.BK0840","target":null,"order":125,"groupKey":"O","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0877","show":true,"name":"","title":"PCB","href":"/center/boardlist.html#boards2-90.BK0877","target":null,"order":126,"groupKey":"P","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0666","show":true,"name":"","title":"苹果概念","href":"/center/boardlist.html#boards2-90.BK0666","target":null,"order":127,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0721","show":true,"name":"","title":"PPP模式","href":"/center/boardlist.html#boards2-90.BK0721","target":null,"order":128,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0535","show":true,"name":"","title":"QFII重仓","href":"/center/boardlist.html#boards2-90.BK0535","target":null,"order":129,"groupKey":"Q","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0872","show":true,"name":"","title":"青蒿素","href":"/center/boardlist.html#boards2-90.BK0872","target":null,"order":130,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0830","show":true,"name":"","title":"区块链","href":"/center/boardlist.html#boards2-90.BK0830","target":null,"order":131,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0864","show":true,"name":"","title":"氢能源","href":"/center/boardlist.html#boards2-90.BK0864","target":null,"order":132,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0711","show":true,"name":"","title":"券商概念","href":"/center/boardlist.html#boards2-90.BK0711","target":null,"order":133,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0699","show":true,"name":"","title":"全息技术","href":"/center/boardlist.html#boards2-90.BK0699","target":null,"order":134,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0800","show":true,"name":"","title":"人工智能","href":"/center/boardlist.html#boards2-90.BK0800","target":null,"order":135,"groupKey":"R","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0682","show":true,"name":"","title":"燃料电池","href":"/center/boardlist.html#boards2-90.BK0682","target":null,"order":136,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0706","show":true,"name":"","title":"人脑工程","href":"/center/boardlist.html#boards2-90.BK0706","target":null,"order":137,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0892","show":true,"name":"","title":"乳业","href":"/center/boardlist.html#boards2-90.BK0892","target":null,"order":138,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0866","show":true,"name":"","title":"人造肉","href":"/center/boardlist.html#boards2-90.BK0866","target":null,"order":139,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0596","show":true,"name":"","title":"融资融券","href":"/center/boardlist.html#boards2-90.BK0596","target":null,"order":140,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0520","show":true,"name":"","title":"社保重仓","href":"/center/boardlist.html#boards2-90.BK0520","target":null,"order":141,"groupKey":"S","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0568","show":true,"name":"","title":"深成500","href":"/center/boardlist.html#boards2-90.BK0568","target":null,"order":142,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0804","show":true,"name":"","title":"深股通","href":"/center/boardlist.html#boards2-90.BK0804","target":null,"order":143,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0643","show":true,"name":"","title":"上海自贸","href":"/center/boardlist.html#boards2-90.BK0643","target":null,"order":144,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0851","show":true,"name":"","title":"纾困概念","href":"/center/boardlist.html#boards2-90.BK0851","target":null,"order":145,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0597","show":true,"name":"","title":"水利建设","href":"/center/boardlist.html#boards2-90.BK0597","target":null,"order":146,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0709","show":true,"name":"","title":"赛马概念","href":"/center/boardlist.html#boards2-90.BK0709","target":null,"order":147,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0617","show":true,"name":"","title":"石墨烯","href":"/center/boardlist.html#boards2-90.BK0617","target":null,"order":148,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0614","show":true,"name":"","title":"食品安全","href":"/center/boardlist.html#boards2-90.BK0614","target":null,"order":149,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0511","show":true,"name":"","title":"ST概念","href":"/center/boardlist.html#boards2-90.BK0511","target":null,"order":150,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0669","show":true,"name":"","title":"生态农业","href":"/center/boardlist.html#boards2-90.BK0669","target":null,"order":151,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0970","show":true,"name":"","title":"生物识别","href":"/center/boardlist.html#boards2-90.BK0970","target":null,"order":152,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0548","show":true,"name":"","title":"生物疫苗","href":"/center/boardlist.html#boards2-90.BK0548","target":null,"order":153,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0642","show":true,"name":"","title":"手游概念","href":"/center/boardlist.html#boards2-90.BK0642","target":null,"order":154,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0743","show":true,"name":"","title":"深证100R","href":"/center/boardlist.html#boards2-90.BK0743","target":null,"order":155,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0612","show":true,"name":"","title":"上证180_","href":"/center/boardlist.html#boards2-90.BK0612","target":null,"order":156,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0705","show":true,"name":"","title":"上证380","href":"/center/boardlist.html#boards2-90.BK0705","target":null,"order":157,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0611","show":true,"name":"","title":"上证50_","href":"/center/boardlist.html#boards2-90.BK0611","target":null,"order":158,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0883","show":true,"name":"","title":"数字货币","href":"/center/boardlist.html#boards2-90.BK0883","target":null,"order":159,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0861","show":true,"name":"","title":"数字孪生","href":"/center/boardlist.html#boards2-90.BK0861","target":null,"order":160,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0549","show":true,"name":"","title":"深圳特区","href":"/center/boardlist.html#boards2-90.BK0549","target":null,"order":161,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0633","show":true,"name":"","title":"送转预期","href":"/center/boardlist.html#boards2-90.BK0633","target":null,"order":162,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0836","show":true,"name":"","title":"数字中国","href":"/center/boardlist.html#boards2-90.BK0836","target":null,"order":163,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0805","show":true,"name":"","title":"钛白粉","href":"/center/boardlist.html#boards2-90.BK0805","target":null,"order":164,"groupKey":"T","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0632","show":true,"name":"","title":"土地流转","href":"/center/boardlist.html#boards2-90.BK0632","target":null,"order":165,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0592","show":true,"name":"","title":"铁路基建","href":"/center/boardlist.html#boards2-90.BK0592","target":null,"order":166,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0863","show":true,"name":"","title":"透明工厂","href":"/center/boardlist.html#boards2-90.BK0863","target":null,"order":167,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0843","show":true,"name":"","title":"天然气","href":"/center/boardlist.html#boards2-90.BK0843","target":null,"order":168,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0644","show":true,"name":"","title":"特斯拉","href":"/center/boardlist.html#boards2-90.BK0644","target":null,"order":169,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0841","show":true,"name":"","title":"体外诊断","href":"/center/boardlist.html#boards2-90.BK0841","target":null,"order":170,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0708","show":true,"name":"","title":"体育产业","href":"/center/boardlist.html#boards2-90.BK0708","target":null,"order":171,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0625","show":true,"name":"","title":"通用航空","href":"/center/boardlist.html#boards2-90.BK0625","target":null,"order":172,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0898","show":true,"name":"","title":"胎压监测","href":"/center/boardlist.html#boards2-90.BK0898","target":null,"order":173,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0588","show":true,"name":"","title":"太阳能","href":"/center/boardlist.html#boards2-90.BK0588","target":null,"order":174,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0880","show":true,"name":"","title":"UWB概念","href":"/center/boardlist.html#boards2-90.BK0880","target":null,"order":175,"groupKey":"U","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0885","show":true,"name":"","title":"VPN","href":"/center/boardlist.html#boards2-90.BK0885","target":null,"order":176,"groupKey":"V","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0831","show":true,"name":"","title":"万达概念","href":"/center/boardlist.html#boards2-90.BK0831","target":null,"order":177,"groupKey":"W","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0940","show":true,"name":"","title":"网红直播","href":"/center/boardlist.html#boards2-90.BK0940","target":null,"order":178,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0915","show":true,"name":"","title":"WiFi","href":"/center/boardlist.html#boards2-90.BK0915","target":null,"order":179,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0655","show":true,"name":"","title":"网络安全","href":"/center/boardlist.html#boards2-90.BK0655","target":null,"order":180,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0554","show":true,"name":"","title":"物联网","href":"/center/boardlist.html#boards2-90.BK0554","target":null,"order":181,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0509","show":true,"name":"","title":"网络游戏","href":"/center/boardlist.html#boards2-90.BK0509","target":null,"order":182,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0704","show":true,"name":"","title":"无人机","href":"/center/boardlist.html#boards2-90.BK0704","target":null,"order":183,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0802","show":true,"name":"","title":"无人驾驶","href":"/center/boardlist.html#boards2-90.BK0802","target":null,"order":184,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0895","show":true,"name":"","title":"维生素","href":"/center/boardlist.html#boards2-90.BK0895","target":null,"order":185,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0960","show":true,"name":"","title":"无线充电","href":"/center/boardlist.html#boards2-90.BK0960","target":null,"order":186,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0893","show":true,"name":"","title":"无线耳机","href":"/center/boardlist.html#boards2-90.BK0893","target":null,"order":187,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0813","show":true,"name":"","title":"雄安新区","href":"/center/boardlist.html#boards2-90.BK0813","target":null,"order":188,"groupKey":"X","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0523","show":true,"name":"","title":"新材料","href":"/center/boardlist.html#boards2-90.BK0523","target":null,"order":189,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0834","show":true,"name":"","title":"乡村振兴","href":"/center/boardlist.html#boards2-90.BK0834","target":null,"order":190,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0913","show":true,"name":"","title":"消毒剂","href":"/center/boardlist.html#boards2-90.BK0913","target":null,"order":191,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0695","show":true,"name":"","title":"小金属","href":"/center/boardlist.html#boards2-90.BK0695","target":null,"order":192,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0825","show":true,"name":"","title":"新零售","href":"/center/boardlist.html#boards2-90.BK0825","target":null,"order":193,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0833","show":true,"name":"","title":"小米概念","href":"/center/boardlist.html#boards2-90.BK0833","target":null,"order":194,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0722","show":true,"name":"","title":"虚拟现实","href":"/center/boardlist.html#boards2-90.BK0722","target":null,"order":195,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0493","show":true,"name":"","title":"新能源","href":"/center/boardlist.html#boards2-90.BK0493","target":null,"order":196,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0900","show":true,"name":"","title":"新能源车","href":"/center/boardlist.html#boards2-90.BK0900","target":null,"order":197,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0519","show":true,"name":"","title":"稀缺资源","href":"/center/boardlist.html#boards2-90.BK0519","target":null,"order":198,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0600","show":true,"name":"","title":"新三板","href":"/center/boardlist.html#boards2-90.BK0600","target":null,"order":199,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0578","show":true,"name":"","title":"稀土永磁","href":"/center/boardlist.html#boards2-90.BK0578","target":null,"order":200,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0912","show":true,"name":"","title":"远程办公","href":"/center/boardlist.html#boards2-90.BK0912","target":null,"order":201,"groupKey":"Y","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0712","show":true,"name":"","title":"一带一路","href":"/center/boardlist.html#boards2-90.BK0712","target":null,"order":202,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0556","show":true,"name":"","title":"移动支付","href":"/center/boardlist.html#boards2-90.BK0556","target":null,"order":203,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0914","show":true,"name":"","title":"医废处理","href":"/center/boardlist.html#boards2-90.BK0914","target":null,"order":204,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0663","show":true,"name":"","title":"油改概念","href":"/center/boardlist.html#boards2-90.BK0663","target":null,"order":205,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0677","show":true,"name":"","title":"粤港自贸","href":"/center/boardlist.html#boards2-90.BK0677","target":null,"order":206,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0579","show":true,"name":"","title":"云计算","href":"/center/boardlist.html#boards2-90.BK0579","target":null,"order":207,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0563","show":true,"name":"","title":"油价相关","href":"/center/boardlist.html#boards2-90.BK0563","target":null,"order":208,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0570","show":true,"name":"","title":"预亏预减","href":"/center/boardlist.html#boards2-90.BK0570","target":null,"order":209,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0653","show":true,"name":"","title":"养老概念","href":"/center/boardlist.html#boards2-90.BK0653","target":null,"order":210,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0823","show":true,"name":"","title":"养老金","href":"/center/boardlist.html#boards2-90.BK0823","target":null,"order":211,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0889","show":true,"name":"","title":"医疗美容","href":"/center/boardlist.html#boards2-90.BK0889","target":null,"order":212,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0668","show":true,"name":"","title":"医疗器械","href":"/center/boardlist.html#boards2-90.BK0668","target":null,"order":213,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0606","show":true,"name":"","title":"油气设服","href":"/center/boardlist.html#boards2-90.BK0606","target":null,"order":214,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0610","show":true,"name":"","title":"央视50_","href":"/center/boardlist.html#boards2-90.BK0610","target":null,"order":215,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0847","show":true,"name":"","title":"影视概念","href":"/center/boardlist.html#boards2-90.BK0847","target":null,"order":216,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0603","show":true,"name":"","title":"页岩气","href":"/center/boardlist.html#boards2-90.BK0603","target":null,"order":217,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0903","show":true,"name":"","title":"云游戏","href":"/center/boardlist.html#boards2-90.BK0903","target":null,"order":218,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0571","show":true,"name":"","title":"预盈预增","href":"/center/boardlist.html#boards2-90.BK0571","target":null,"order":219,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0635","show":true,"name":"","title":"中超概念","href":"/center/boardlist.html#boards2-90.BK0635","target":null,"order":220,"groupKey":"Z","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0628","show":true,"name":"","title":"智慧城市","href":"/center/boardlist.html#boards2-90.BK0628","target":null,"order":221,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0886","show":true,"name":"","title":"智慧政务","href":"/center/boardlist.html#boards2-90.BK0886","target":null,"order":222,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0718","show":true,"name":"","title":"证金持股","href":"/center/boardlist.html#boards2-90.BK0718","target":null,"order":223,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0594","show":true,"name":"","title":"长江三角","href":"/center/boardlist.html#boards2-90.BK0594","target":null,"order":224,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0907","show":true,"name":"","title":"转基因","href":"/center/boardlist.html#boards2-90.BK0907","target":null,"order":225,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0641","show":true,"name":"","title":"智能穿戴","href":"/center/boardlist.html#boards2-90.BK0641","target":null,"order":226,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0656","show":true,"name":"","title":"智能电视","href":"/center/boardlist.html#boards2-90.BK0656","target":null,"order":227,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0581","show":true,"name":"","title":"智能电网","href":"/center/boardlist.html#boards2-90.BK0581","target":null,"order":228,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0680","show":true,"name":"","title":"智能家居","href":"/center/boardlist.html#boards2-90.BK0680","target":null,"order":229,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0640","show":true,"name":"","title":"智能机器","href":"/center/boardlist.html#boards2-90.BK0640","target":null,"order":230,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0801","show":true,"name":"","title":"增强现实","href":"/center/boardlist.html#boards2-90.BK0801","target":null,"order":231,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0817","show":true,"name":"","title":"昨日触板","href":"/center/boardlist.html#boards2-90.BK0817","target":null,"order":232,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0882","show":true,"name":"","title":"猪肉概念","href":"/center/boardlist.html#boards2-90.BK0882","target":null,"order":233,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0816","show":true,"name":"","title":"昨日连板","href":"/center/boardlist.html#boards2-90.BK0816","target":null,"order":234,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0815","show":true,"name":"","title":"昨日涨停","href":"/center/boardlist.html#boards2-90.BK0815","target":null,"order":235,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0839","show":true,"name":"","title":"知识产权","href":"/center/boardlist.html#boards2-90.BK0839","target":null,"order":236,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0822","show":true,"name":"","title":"租售同权","href":"/center/boardlist.html#boards2-90.BK0822","target":null,"order":237,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0662","show":true,"name":"","title":"在线教育","href":"/center/boardlist.html#boards2-90.BK0662","target":null,"order":238,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0692","show":true,"name":"","title":"在线旅游","href":"/center/boardlist.html#boards2-90.BK0692","target":null,"order":239,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0615","show":true,"name":"","title":"中药","href":"/center/boardlist.html#boards2-90.BK0615","target":null,"order":240,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0701","show":true,"name":"","title":"中证500","href":"/center/boardlist.html#boards2-90.BK0701","target":null,"order":241,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0528","show":true,"name":"","title":"转债标的","href":"/center/boardlist.html#boards2-90.BK0528","target":null,"order":242,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0980","show":true,"name":"","title":"债转股","href":"/center/boardlist.html#boards2-90.BK0980","target":null,"order":243,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0505","show":true,"name":"","title":"中字头","href":"/center/boardlist.html#boards2-90.BK0505","target":null,"order":244,"groupKey":"","className":null,"hot":false,"next":null}]},{"key":"region_board","show":true,"name":"","title":"地域板块","href":"/center/boardlist.html#region_board","target":"_self","order":1,"groupKey":"","className":"","hot":false,"next":[{"key":"boards2-90.BK0149","show":true,"name":"","title":"安徽板块","href":"/center/boardlist.html#boards2-90.BK0149","target":null,"order":0,"groupKey":"A","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0150","show":true,"name":"","title":"北京板块","href":"/center/boardlist.html#boards2-90.BK0150","target":null,"order":1,"groupKey":"B","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0170","show":true,"name":"","title":"重庆板块","href":"/center/boardlist.html#boards2-90.BK0170","target":null,"order":2,"groupKey":"C","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0151","show":true,"name":"","title":"福建板块","href":"/center/boardlist.html#boards2-90.BK0151","target":null,"order":3,"groupKey":"F","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0153","show":true,"name":"","title":"广东板块","href":"/center/boardlist.html#boards2-90.BK0153","target":null,"order":4,"groupKey":"G","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0152","show":true,"name":"","title":"甘肃板块","href":"/center/boardlist.html#boards2-90.BK0152","target":null,"order":5,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0154","show":true,"name":"","title":"广西板块","href":"/center/boardlist.html#boards2-90.BK0154","target":null,"order":6,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0173","show":true,"name":"","title":"贵州板块","href":"/center/boardlist.html#boards2-90.BK0173","target":null,"order":7,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0155","show":true,"name":"","title":"河北板块","href":"/center/boardlist.html#boards2-90.BK0155","target":null,"order":8,"groupKey":"H","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0157","show":true,"name":"","title":"湖北板块","href":"/center/boardlist.html#boards2-90.BK0157","target":null,"order":9,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0146","show":true,"name":"","title":"黑龙江","href":"/center/boardlist.html#boards2-90.BK0146","target":null,"order":10,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0158","show":true,"name":"","title":"湖南板块","href":"/center/boardlist.html#boards2-90.BK0158","target":null,"order":11,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0156","show":true,"name":"","title":"河南板块","href":"/center/boardlist.html#boards2-90.BK0156","target":null,"order":12,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0176","show":true,"name":"","title":"海南板块","href":"/center/boardlist.html#boards2-90.BK0176","target":null,"order":13,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0148","show":true,"name":"","title":"吉林板块","href":"/center/boardlist.html#boards2-90.BK0148","target":null,"order":14,"groupKey":"J","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0159","show":true,"name":"","title":"江苏板块","href":"/center/boardlist.html#boards2-90.BK0159","target":null,"order":15,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0160","show":true,"name":"","title":"江西板块","href":"/center/boardlist.html#boards2-90.BK0160","target":null,"order":16,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0161","show":true,"name":"","title":"辽宁板块","href":"/center/boardlist.html#boards2-90.BK0161","target":null,"order":17,"groupKey":"L","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0175","show":true,"name":"","title":"内蒙古","href":"/center/boardlist.html#boards2-90.BK0175","target":null,"order":18,"groupKey":"N","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0162","show":true,"name":"","title":"宁夏板块","href":"/center/boardlist.html#boards2-90.BK0162","target":null,"order":19,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0163","show":true,"name":"","title":"青海板块","href":"/center/boardlist.html#boards2-90.BK0163","target":null,"order":20,"groupKey":"Q","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0169","show":true,"name":"","title":"四川板块","href":"/center/boardlist.html#boards2-90.BK0169","target":null,"order":21,"groupKey":"S","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0164","show":true,"name":"","title":"山东板块","href":"/center/boardlist.html#boards2-90.BK0164","target":null,"order":22,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0145","show":true,"name":"","title":"上海板块","href":"/center/boardlist.html#boards2-90.BK0145","target":null,"order":23,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0165","show":true,"name":"","title":"陕西板块","href":"/center/boardlist.html#boards2-90.BK0165","target":null,"order":24,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0167","show":true,"name":"","title":"山西板块","href":"/center/boardlist.html#boards2-90.BK0167","target":null,"order":25,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0166","show":true,"name":"","title":"天津板块","href":"/center/boardlist.html#boards2-90.BK0166","target":null,"order":26,"groupKey":"T","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0147","show":true,"name":"","title":"新疆板块","href":"/center/boardlist.html#boards2-90.BK0147","target":null,"order":27,"groupKey":"X","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0174","show":true,"name":"","title":"西藏板块","href":"/center/boardlist.html#boards2-90.BK0174","target":null,"order":28,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0171","show":true,"name":"","title":"云南板块","href":"/center/boardlist.html#boards2-90.BK0171","target":null,"order":29,"groupKey":"Y","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0172","show":true,"name":"","title":"浙江板块","href":"/center/boardlist.html#boards2-90.BK0172","target":null,"order":30,"groupKey":"Z","className":null,"hot":false,"next":null}]},{"key":"industry_board","show":true,"name":"","title":"行业板块","href":"/center/boardlist.html#industry_board","target":"_self","order":2,"groupKey":"","className":"","hot":false,"next":[{"key":"boards2-90.BK0735","show":true,"name":"","title":"安防设备","href":"/center/boardlist.html#boards2-90.BK0735","target":null,"order":0,"groupKey":"A","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0546","show":true,"name":"","title":"玻璃陶瓷","href":"/center/boardlist.html#boards2-90.BK0546","target":null,"order":1,"groupKey":"B","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0474","show":true,"name":"","title":"保险","href":"/center/boardlist.html#boards2-90.BK0474","target":null,"order":2,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0733","show":true,"name":"","title":"包装材料","href":"/center/boardlist.html#boards2-90.BK0733","target":null,"order":3,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0729","show":true,"name":"","title":"船舶制造","href":"/center/boardlist.html#boards2-90.BK0729","target":null,"order":4,"groupKey":"C","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0537","show":true,"name":"","title":"材料行业","href":"/center/boardlist.html#boards2-90.BK0537","target":null,"order":5,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0428","show":true,"name":"","title":"电力行业","href":"/center/boardlist.html#boards2-90.BK0428","target":null,"order":6,"groupKey":"D","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0736","show":true,"name":"","title":"电信运营","href":"/center/boardlist.html#boards2-90.BK0736","target":null,"order":7,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0738","show":true,"name":"","title":"多元金融","href":"/center/boardlist.html#boards2-90.BK0738","target":null,"order":8,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0447","show":true,"name":"","title":"电子信息","href":"/center/boardlist.html#boards2-90.BK0447","target":null,"order":9,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0459","show":true,"name":"","title":"电子元件","href":"/center/boardlist.html#boards2-90.BK0459","target":null,"order":10,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0451","show":true,"name":"","title":"房地产","href":"/center/boardlist.html#boards2-90.BK0451","target":null,"order":11,"groupKey":"F","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0436","show":true,"name":"","title":"纺织服装","href":"/center/boardlist.html#boards2-90.BK0436","target":null,"order":12,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0425","show":true,"name":"","title":"工程建设","href":"/center/boardlist.html#boards2-90.BK0425","target":null,"order":13,"groupKey":"G","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0484","show":true,"name":"","title":"国际贸易","href":"/center/boardlist.html#boards2-90.BK0484","target":null,"order":14,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0732","show":true,"name":"","title":"贵金属","href":"/center/boardlist.html#boards2-90.BK0732","target":null,"order":15,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0450","show":true,"name":"","title":"港口水运","href":"/center/boardlist.html#boards2-90.BK0450","target":null,"order":16,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0421","show":true,"name":"","title":"高速公路","href":"/center/boardlist.html#boards2-90.BK0421","target":null,"order":17,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0479","show":true,"name":"","title":"钢铁行业","href":"/center/boardlist.html#boards2-90.BK0479","target":null,"order":18,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0440","show":true,"name":"","title":"工艺商品","href":"/center/boardlist.html#boards2-90.BK0440","target":null,"order":19,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0427","show":true,"name":"","title":"公用事业","href":"/center/boardlist.html#boards2-90.BK0427","target":null,"order":20,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0728","show":true,"name":"","title":"环保工程","href":"/center/boardlist.html#boards2-90.BK0728","target":null,"order":21,"groupKey":"H","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0731","show":true,"name":"","title":"化肥行业","href":"/center/boardlist.html#boards2-90.BK0731","target":null,"order":22,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0538","show":true,"name":"","title":"化工行业","href":"/center/boardlist.html#boards2-90.BK0538","target":null,"order":23,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0480","show":true,"name":"","title":"航天航空","href":"/center/boardlist.html#boards2-90.BK0480","target":null,"order":24,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0471","show":true,"name":"","title":"化纤行业","href":"/center/boardlist.html#boards2-90.BK0471","target":null,"order":25,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0456","show":true,"name":"","title":"家电行业","href":"/center/boardlist.html#boards2-90.BK0456","target":null,"order":26,"groupKey":"J","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0739","show":true,"name":"","title":"金属制品","href":"/center/boardlist.html#boards2-90.BK0739","target":null,"order":27,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0545","show":true,"name":"","title":"机械行业","href":"/center/boardlist.html#boards2-90.BK0545","target":null,"order":28,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0429","show":true,"name":"","title":"交运设备","href":"/center/boardlist.html#boards2-90.BK0429","target":null,"order":29,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0422","show":true,"name":"","title":"交运物流","href":"/center/boardlist.html#boards2-90.BK0422","target":null,"order":30,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0485","show":true,"name":"","title":"旅游酒店","href":"/center/boardlist.html#boards2-90.BK0485","target":null,"order":31,"groupKey":"L","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0420","show":true,"name":"","title":"民航机场","href":"/center/boardlist.html#boards2-90.BK0420","target":null,"order":32,"groupKey":"M","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0437","show":true,"name":"","title":"煤炭采选","href":"/center/boardlist.html#boards2-90.BK0437","target":null,"order":33,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0476","show":true,"name":"","title":"木业家具","href":"/center/boardlist.html#boards2-90.BK0476","target":null,"order":34,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0477","show":true,"name":"","title":"酿酒行业","href":"/center/boardlist.html#boards2-90.BK0477","target":null,"order":35,"groupKey":"N","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0433","show":true,"name":"","title":"农牧饲渔","href":"/center/boardlist.html#boards2-90.BK0433","target":null,"order":36,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0730","show":true,"name":"","title":"农药兽药","href":"/center/boardlist.html#boards2-90.BK0730","target":null,"order":37,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0481","show":true,"name":"","title":"汽车行业","href":"/center/boardlist.html#boards2-90.BK0481","target":null,"order":38,"groupKey":"Q","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0473","show":true,"name":"","title":"券商信托","href":"/center/boardlist.html#boards2-90.BK0473","target":null,"order":39,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0737","show":true,"name":"","title":"软件服务","href":"/center/boardlist.html#boards2-90.BK0737","target":null,"order":40,"groupKey":"R","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0454","show":true,"name":"","title":"塑胶制品","href":"/center/boardlist.html#boards2-90.BK0454","target":null,"order":41,"groupKey":"S","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0424","show":true,"name":"","title":"水泥建材","href":"/center/boardlist.html#boards2-90.BK0424","target":null,"order":42,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0457","show":true,"name":"","title":"输配电气","href":"/center/boardlist.html#boards2-90.BK0457","target":null,"order":43,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0438","show":true,"name":"","title":"食品饮料","href":"/center/boardlist.html#boards2-90.BK0438","target":null,"order":44,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0482","show":true,"name":"","title":"商业百货","href":"/center/boardlist.html#boards2-90.BK0482","target":null,"order":45,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0464","show":true,"name":"","title":"石油行业","href":"/center/boardlist.html#boards2-90.BK0464","target":null,"order":46,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0448","show":true,"name":"","title":"通讯行业","href":"/center/boardlist.html#boards2-90.BK0448","target":null,"order":47,"groupKey":"T","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0486","show":true,"name":"","title":"文化传媒","href":"/center/boardlist.html#boards2-90.BK0486","target":null,"order":48,"groupKey":"W","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0740","show":true,"name":"","title":"文教休闲","href":"/center/boardlist.html#boards2-90.BK0740","target":null,"order":49,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0475","show":true,"name":"","title":"银行","href":"/center/boardlist.html#boards2-90.BK0475","target":null,"order":50,"groupKey":"Y","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0726","show":true,"name":"","title":"园林工程","href":"/center/boardlist.html#boards2-90.BK0726","target":null,"order":51,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0727","show":true,"name":"","title":"医疗行业","href":"/center/boardlist.html#boards2-90.BK0727","target":null,"order":52,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0458","show":true,"name":"","title":"仪器仪表","href":"/center/boardlist.html#boards2-90.BK0458","target":null,"order":53,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0478","show":true,"name":"","title":"有色金属","href":"/center/boardlist.html#boards2-90.BK0478","target":null,"order":54,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0465","show":true,"name":"","title":"医药制造","href":"/center/boardlist.html#boards2-90.BK0465","target":null,"order":55,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0734","show":true,"name":"","title":"珠宝首饰","href":"/center/boardlist.html#boards2-90.BK0734","target":null,"order":56,"groupKey":"Z","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0539","show":true,"name":"","title":"综合行业","href":"/center/boardlist.html#boards2-90.BK0539","target":null,"order":57,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0725","show":true,"name":"","title":"装修装饰","href":"/center/boardlist.html#boards2-90.BK0725","target":null,"order":58,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0910","show":true,"name":"","title":"专用设备","href":"/center/boardlist.html#boards2-90.BK0910","target":null,"order":59,"groupKey":"","className":null,"hot":false,"next":null},{"key":"boards2-90.BK0470","show":true,"name":"","title":"造纸印刷","href":"/center/boardlist.html#boards2-90.BK0470","target":null,"order":60,"groupKey":"","className":null,"hot":false,"next":null}]}]},{"key":"hsindex","show":true,"name":"","title":"沪深指数","href":"/center/hszs.html","target":"_self","order":4,"groupKey":"","className":"","hot":false,"next":[{"key":"index_sh","show":true,"name":"","title":"上证系列指数","href":"/center/gridlist.html#index_sh","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"index_sz","show":true,"name":"","title":"深证系列指数","href":"/center/gridlist.html#index_sz","target":"_self","order":1,"groupKey":"","className":"","hot":false,"next":[]},{"key":"index_components","show":true,"name":"","title":"指数成份","href":"/center/gridlist.html#index_components","target":"_self","order":2,"groupKey":"","className":"","hot":false,"next":[]},{"key":"index_zzzs","show":true,"name":"","title":"中证系列指数","href":"/center/gridlist.html#index_zzzs","target":"_self","order":3,"groupKey":"","className":"","hot":false,"next":[]}]},{"key":"neeq_market","show":true,"name":"","title":"新三板","href":"/center/gridlist.html#neeq_stocks","target":"_self","order":5,"groupKey":"","className":"","hot":false,"next":[{"key":"neeq_stocks","show":true,"name":"","title":"全部","href":"/center/gridlist.html#neeq_stocks","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"neeq_innovate","show":true,"name":"","title":"创新层","href":"/center/gridlist.html#neeq_innovate","target":"_self","order":1,"groupKey":"","className":"","hot":false,"next":[]},{"key":"neeq_basic","show":true,"name":"","title":"基础层","href":"/center/gridlist.html#neeq_basic","target":"_self","order":2,"groupKey":"","className":"","hot":false,"next":[]},{"key":"neeq_agreement","show":true,"name":"","title":"协议","href":"/center/gridlist.html#neeq_agreement","target":"_self","order":3,"groupKey":"","className":"","hot":false,"next":[]},{"key":"neeq_marketmaking","show":true,"name":"","title":"做市","href":"/center/gridlist.html#neeq_marketmaking","target":"_self","order":4,"groupKey":"","className":"","hot":false,"next":[]},{"key":"neeq_bidding","show":true,"name":"","title":"竞价","href":"/center/gridlist.html#neeq_bidding","target":"_self","order":5,"groupKey":"","className":"","hot":false,"next":[]}]},{"key":"hs_hk_market","show":true,"name":"","title":"沪深港通","href":"/center/hsgt.html","target":"_self","order":6,"groupKey":"","className":"","hot":false,"next":[{"key":"sh_hk_board","show":true,"name":"","title":"沪股通","href":"/center/gridlist.html#sh_hk_board","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"sz_hk_board","show":true,"name":"","title":"深股通","href":"/center/gridlist.html#sz_hk_board","target":"_self","order":1,"groupKey":"","className":"","hot":false,"next":[]},{"key":"hk_sh_stocks","show":true,"name":"","title":"港股通(沪)","href":"/center/gridlist.html#hk_sh_stocks","target":"_self","order":2,"groupKey":"","className":"","hot":false,"next":[]},{"key":"hk_sz_stocks","show":true,"name":"","title":"港股通(深)","href":"/center/gridlist.html#hk_sz_stocks","target":"_self","order":3,"groupKey":"","className":"","hot":false,"next":[]},{"key":"ah_comparison","show":true,"name":"","title":"AH股比价","href":"/center/gridlist.html#ah_comparison","target":"_self","order":4,"groupKey":"","className":"","hot":false,"next":[]}]},{"key":"hk_market","show":true,"name":"","title":"港股市场","href":"/center/ggsc.html","target":"_self","order":7,"groupKey":"","className":"","hot":false,"next":[{"key":"hk_stocks","show":true,"name":"","title":"全部港股","href":"/center/gridlist.html#hk_stocks","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"hk_mainboard","show":true,"name":"","title":"港股主板","href":"/center/gridlist.html#hk_mainboard","target":"_self","order":1,"groupKey":"","className":"","hot":false,"next":[]},{"key":"hk_gem","show":true,"name":"","title":"港股创业板","href":"/center/gridlist.html#hk_gem","target":"_self","order":2,"groupKey":"","className":"","hot":false,"next":[]},{"key":"hk_wellknown","show":true,"name":"","title":"知名港股","href":"/center/gridlist.html#hk_wellknown","target":"_self","order":3,"groupKey":"","className":"","hot":false,"next":[]},{"key":"hk_bluechips","show":true,"name":"","title":"蓝筹股","href":"/center/gridlist.html#hk_bluechips","target":"_self","order":4,"groupKey":"","className":"","hot":false,"next":[]},{"key":"hk_redchips","show":true,"name":"","title":"红筹股","href":"/center/gridlist.html#hk_redchips","target":"_self","order":5,"groupKey":"","className":"","hot":false,"next":[]},{"key":"hk_redchips_components","show":true,"name":"","title":"红筹成分股","href":"/center/gridlist.html#hk_redchips_components","target":"_self","order":5,"groupKey":"","className":"","hot":false,"next":[]},{"key":"hk_stateowned","show":true,"name":"","title":"国企股","href":"/center/gridlist.html#hk_stateowned","target":"_self","order":7,"groupKey":"","className":"","hot":false,"next":[]},{"key":"hk_stateowned_components","show":true,"name":"","title":"国企成分股","href":"/center/gridlist.html#hk_stateowned_components","target":"_self","order":8,"groupKey":"","className":"","hot":false,"next":[]},{"key":"hk_components","show":true,"name":"","title":"港股通成份股","href":"/center/gridlist.html#hk_components","target":"_self","order":9,"groupKey":"","className":"","hot":false,"next":[]},{"key":"hsi_large_components","show":true,"name":"","title":"恒生综合大型成份股","href":"/center/gridlist.html#hsi_large_components","target":"_self","order":10,"groupKey":"","className":"","hot":false,"next":[]},{"key":"hsi_medium_components","show":true,"name":"","title":"恒生综合中型成份股","href":"/center/gridlist.html#hsi_medium_components","target":"_self","order":11,"groupKey":"","className":"","hot":false,"next":[]},{"key":"hkah_comparison","show":true,"name":"","title":"AH股比价","href":"/center/gridlist.html#hkah_comparison","target":"_self","order":12,"groupKey":"","className":"","hot":false,"next":[]},{"key":"hk_adr","show":true,"name":"","title":"ADR","href":"/center/gridlist.html#hk_adr","target":"_self","order":13,"groupKey":"","className":"","hot":false,"next":[]},{"key":"hk_index","show":true,"name":"","title":"香港指数","href":"/center/gridlist.html#hk_index","target":"_self","order":14,"groupKey":"","className":"","hot":false,"next":[]},{"key":"hk_warrants","show":true,"name":"","title":"港股窝轮","href":"/center/gridlist.html#hk_warrants","target":"_self","order":15,"groupKey":"","className":"","hot":false,"next":[]},{"key":"hk_CBBCs","show":true,"name":"","title":"港股牛熊证","href":"/center/gridlist.html#hk_CBBCs","target":"_self","order":16,"groupKey":"","className":"","hot":false,"next":[]}]},{"key":"us_market","show":true,"name":"","title":"美股市场","href":"/center/mgsc.html","target":"_self","order":8,"groupKey":"","className":"","hot":false,"next":[{"key":"us_stocks","show":true,"name":"","title":"全部美股","href":"/center/gridlist.html#us_stocks","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"us_wellknown","show":true,"name":"","title":"知名美股","href":"/center/gridlist.html#us_wellknown","target":"_self","order":1,"groupKey":"","className":"","hot":false,"next":[{"key":"us_technology","show":true,"name":"","title":"科技类","href":"/center/gridlist.html#us_technology","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"us_financial","show":true,"name":"","title":"金融类","href":"/center/gridlist.html#us_financial","target":"_self","order":1,"groupKey":"","className":"","hot":false,"next":[]},{"key":"us_medicine_food","show":true,"name":"","title":"医药食品类","href":"/center/gridlist.html#us_medicine_food","target":"_self","order":2,"groupKey":"","className":"","hot":false,"next":[]},{"key":"us_media","show":true,"name":"","title":"媒体类","href":"/center/gridlist.html#us_media","target":"_self","order":3,"groupKey":"","className":"","hot":false,"next":[]},{"key":"us_automotive_energy","show":true,"name":"","title":"汽车能源类","href":"/center/gridlist.html#us_automotive_energy","target":"_self","order":4,"groupKey":"","className":"","hot":false,"next":[]},{"key":"us_manufacture_retail","show":true,"name":"","title":"制造零售类","href":"/center/gridlist.html#us_manufacture_retail","target":"_self","order":5,"groupKey":"","className":"","hot":false,"next":[]}]},{"key":"us_chinese","show":true,"name":"","title":"中国概念股","href":"/center/gridlist.html#us_chinese","target":"_self","order":2,"groupKey":"","className":"","hot":false,"next":[]},{"key":"us_index","show":true,"name":"","title":"美股指数","href":"/center/gridlist.html#us_index","target":"_self","order":3,"groupKey":"","className":"","hot":false,"next":[]}]},{"key":"uks_market","show":true,"name":"","title":"英股市场","href":"/center/yg.html","target":"_self","order":9,"groupKey":"","className":"","hot":false,"next":[{"key":"stocks_all","show":true,"name":"","title":"全部英股","href":"/center/gridlist2.html#stocks_all","target":"_self","order":1,"groupKey":"","className":"","hot":false,"next":[]},{"key":"stocks_mt_156_7","show":true,"name":"","title":"GDR","href":"/center/gridlist2.html#stocks_mt_156_7","target":"_self","order":2,"groupKey":"","className":"","hot":false,"next":[]},{"key":"stocks_b_MK0794","show":true,"name":"","title":"知名英股","href":"/center/gridlist2.html#stocks_b_MK0794","target":"_self","order":3,"groupKey":"","className":"","hot":false,"next":[]},{"key":"stocks_mt_155_3","show":true,"name":"","title":"英国ETF","href":"/center/gridlist2.html#stocks_mt_155_3","target":"_self","order":4,"groupKey":"","className":"","hot":false,"next":[]},{"key":"stocks_mt_341","show":true,"name":"","title":"英国指数","href":"/center/gridlist2.html#stocks_mt_341","target":"_self","order":5,"groupKey":"","className":"","hot":false,"next":[]}]},{"key":"global_index","show":true,"name":"","title":"全球指数","href":"/center/qqzs.html","target":"_self","order":10,"groupKey":"","className":"","hot":false,"next":[{"key":"global_asia","show":true,"name":"","title":"亚洲股市","href":"/center/gridlist.html#global_asia","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"global_euro","show":true,"name":"","title":"欧洲股市","href":"/center/gridlist.html#global_euro","target":"_self","order":1,"groupKey":"","className":"","hot":false,"next":[]},{"key":"global_asia","show":false,"name":"","title":"亚洲股市","href":"/center/gridlist.html#global_asia","target":"_self","order":1,"groupKey":"","className":"","hot":false,"next":[]},{"key":"global_america","show":true,"name":"","title":"美洲股市","href":"/center/gridlist.html#global_america","target":"_self","order":2,"groupKey":"","className":"","hot":false,"next":[]},{"key":"global_america","show":false,"name":"","title":"美洲股市","href":"/center/gridlist.html#global_america","target":"_self","order":2,"groupKey":"","className":"","hot":false,"next":[]},{"key":"global_australia","show":true,"name":"","title":"澳洲股市","href":"/center/gridlist.html#global_australia","target":"_self","order":3,"groupKey":"","className":"","hot":false,"next":[]},{"key":"global_qtzs","show":true,"name":"","title":"其他指数","href":"/center/gridlist.html#global_qtzs","target":"_self","order":3,"groupKey":"","className":"","hot":false,"next":[]},{"key":"global_euro","show":false,"name":"","title":" 欧洲股市","href":"/center/gridlist.html#global_euro","target":"_self","order":3,"groupKey":"","className":"","hot":false,"next":[]},{"key":"global_australia","show":false,"name":"","title":" 澳洲股市","href":"/center/gridlist.html#global_australia","target":"_self","order":4,"groupKey":"","className":"","hot":false,"next":[]},{"key":"global_qtzs","show":false,"name":"","title":" 其他指数","href":"/center/gridlist.html#global_qtzs","target":"_self","order":5,"groupKey":"","className":"","hot":false,"next":[]}]},{"key":"futures_market","show":true,"name":"","title":"期货市场","href":"/center/futures.html","target":"_self","order":11,"groupKey":"","className":"","hot":false,"next":[{"key":"futures_113","show":true,"name":"","title":"上期所","href":"/center/gridlist2.html#futures_113","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[{"key":"futures_113_1","show":true,"name":"","title":"沪铜","href":"/center/gridlist2.html#futures_113_1","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_113_14","show":true,"name":"","title":"沪锡","href":"/center/gridlist2.html#futures_113_14","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_113_5","show":true,"name":"","title":"沪金","href":"/center/gridlist2.html#futures_113_5","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_113_13","show":true,"name":"","title":"沪镍","href":"/center/gridlist2.html#futures_113_13","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_113_10","show":true,"name":"","title":"橡胶","href":"/center/gridlist2.html#futures_113_10","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_113_7","show":true,"name":"","title":"螺纹钢","href":"/center/gridlist2.html#futures_113_7","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_113_6","show":true,"name":"","title":"沪银","href":"/center/gridlist2.html#futures_113_6","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_113_8","show":true,"name":"","title":"线材","href":"/center/gridlist2.html#futures_113_8","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_113_4","show":true,"name":"","title":"沪铅","href":"/center/gridlist2.html#futures_113_4","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_113_3","show":true,"name":"","title":"沪锌","href":"/center/gridlist2.html#futures_113_3","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_113_11","show":true,"name":"","title":"石油沥青","href":"/center/gridlist2.html#futures_113_11","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_113_2","show":true,"name":"","title":"沪铝","href":"/center/gridlist2.html#futures_113_2","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_113_9","show":true,"name":"","title":"燃油","href":"/center/gridlist2.html#futures_113_9","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_113_12","show":true,"name":"","title":"热轧卷板","href":"/center/gridlist2.html#futures_113_12","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_113_15","show":true,"name":"","title":"纸浆","href":"/center/gridlist2.html#futures_113_15","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_113_16","show":true,"name":"","title":"不锈钢","href":"/center/gridlist2.html#futures_113_16","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]}]},{"key":"futures_142","show":true,"name":"","title":"上期能源","href":"/center/gridlist2.html#futures_142","target":"_self","order":1,"groupKey":"","className":"","hot":false,"next":[{"key":"futures_142_1","show":true,"name":"","title":"原油","href":"/center/gridlist2.html#futures_142_1","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_142_2","show":true,"name":"","title":"20号胶","href":"/center/gridlist2.html#futures_142_2","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]}]},{"key":"futures_114","show":true,"name":"","title":"大商所","href":"/center/gridlist2.html#futures_114","target":"_self","order":2,"groupKey":"","className":"","hot":false,"next":[{"key":"futures_114_1","show":true,"name":"","title":"玉米","href":"/center/gridlist2.html#futures_114_1","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_114_2","show":true,"name":"","title":"豆一","href":"/center/gridlist2.html#futures_114_2","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_114_3","show":true,"name":"","title":"豆二","href":"/center/gridlist2.html#futures_114_3","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_114_4","show":true,"name":"","title":"豆粕","href":"/center/gridlist2.html#futures_114_4","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_114_5","show":true,"name":"","title":"豆油","href":"/center/gridlist2.html#futures_114_5","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_114_6","show":true,"name":"","title":"棕榈油","href":"/center/gridlist2.html#futures_114_6","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_114_7","show":true,"name":"","title":"聚乙烯","href":"/center/gridlist2.html#futures_114_7","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_114_8","show":true,"name":"","title":"聚氯乙烯","href":"/center/gridlist2.html#futures_114_8","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_114_9","show":true,"name":"","title":"焦炭","href":"/center/gridlist2.html#futures_114_9","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_114_10","show":true,"name":"","title":"焦煤","href":"/center/gridlist2.html#futures_114_10","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_114_11","show":true,"name":"","title":"纤维板","href":"/center/gridlist2.html#futures_114_11","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_114_12","show":true,"name":"","title":"胶合板","href":"/center/gridlist2.html#futures_114_12","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_114_13","show":true,"name":"","title":"铁矿石","href":"/center/gridlist2.html#futures_114_13","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_114_14","show":true,"name":"","title":"鸡蛋","href":"/center/gridlist2.html#futures_114_14","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_114_15","show":true,"name":"","title":"聚丙烯","href":"/center/gridlist2.html#futures_114_15","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_114_16","show":true,"name":"","title":"玉米淀粉","href":"/center/gridlist2.html#futures_114_16","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_114_17","show":true,"name":"","title":"乙二醇","href":"/center/gridlist2.html#futures_114_17","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_114_18","show":true,"name":"","title":"粳米","href":"/center/gridlist2.html#futures_114_18","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_114_19","show":true,"name":"","title":"苯乙烯","href":"/center/gridlist2.html#futures_114_19","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]}]},{"key":"futures_115","show":true,"name":"","title":"郑商所","href":"/center/gridlist2.html#futures_115","target":"_self","order":3,"groupKey":"","className":"","hot":false,"next":[{"key":"futures_115_1","show":true,"name":"","title":"强麦","href":"/center/gridlist2.html#futures_115_1","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_115_2","show":true,"name":"","title":"普麦","href":"/center/gridlist2.html#futures_115_2","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_115_3","show":true,"name":"","title":"一号棉花","href":"/center/gridlist2.html#futures_115_3","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_115_4","show":true,"name":"","title":"白糖","href":"/center/gridlist2.html#futures_115_4","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_115_5","show":true,"name":"","title":"PTA","href":"/center/gridlist2.html#futures_115_5","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_115_6","show":true,"name":"","title":"菜油","href":"/center/gridlist2.html#futures_115_6","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_115_7","show":true,"name":"","title":"早籼稻","href":"/center/gridlist2.html#futures_115_7","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_115_8","show":true,"name":"","title":"甲醇","href":"/center/gridlist2.html#futures_115_8","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_115_9","show":true,"name":"","title":"玻璃","href":"/center/gridlist2.html#futures_115_9","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_115_10","show":true,"name":"","title":"菜籽","href":"/center/gridlist2.html#futures_115_10","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_115_11","show":true,"name":"","title":"菜粕","href":"/center/gridlist2.html#futures_115_11","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_115_13","show":true,"name":"","title":"粳稻","href":"/center/gridlist2.html#futures_115_13","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_115_14","show":true,"name":"","title":"晚籼稻","href":"/center/gridlist2.html#futures_115_14","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_115_15","show":true,"name":"","title":"硅铁","href":"/center/gridlist2.html#futures_115_15","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_115_16","show":true,"name":"","title":"锰硅","href":"/center/gridlist2.html#futures_115_16","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_115_17","show":true,"name":"","title":"动力煤","href":"/center/gridlist2.html#futures_115_17","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_115_18","show":true,"name":"","title":"棉纱","href":"/center/gridlist2.html#futures_115_18","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_115_19","show":true,"name":"","title":"苹果","href":"/center/gridlist2.html#futures_115_19","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_115_20","show":true,"name":"","title":"红枣","href":"/center/gridlist2.html#futures_115_20","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_115_21","show":true,"name":"","title":"尿素","href":"/center/gridlist2.html#futures_115_21","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_115_22","show":true,"name":"","title":"纯碱","href":"/center/gridlist2.html#futures_115_22","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]}]},{"key":"futures_cffex","show":true,"name":"","title":"中金所","href":"/center/gridlist.html#futures_cffex","target":"_self","order":4,"groupKey":"","className":"","hot":false,"next":[{"key":"futures_cffex-_TS","show":true,"name":"","title":"2年期国债","href":"/center/gridlist.html#futures_cffex-_TS","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_cffex-_TF","show":true,"name":"","title":"5年期国债","href":"/center/gridlist.html#futures_cffex-_TF","target":"_self","order":1,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_cffex-_T","show":true,"name":"","title":"10年期国债","href":"/center/gridlist.html#futures_cffex-_T","target":"_self","order":2,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_cffex-_IH","show":true,"name":"","title":"上证50","href":"/center/gridlist.html#futures_cffex-_IH","target":"_self","order":3,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_cffex-_IC","show":true,"name":"","title":"中证500","href":"/center/gridlist.html#futures_cffex-_IC","target":"_self","order":4,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_cffex-_IF","show":true,"name":"","title":"沪深300","href":"/center/gridlist.html#futures_cffex-_IF","target":"_self","order":5,"groupKey":"","className":"","hot":false,"next":[]}]},{"key":"futures_hkex","show":true,"name":"","title":"港交所","href":"/center/gjs.html#futures_hkex","target":"_self","order":5,"groupKey":"","className":"","hot":false,"next":[{"key":"hk_index_futures","show":true,"name":"","title":"指数期货","href":"/center/gridlist.html#hk_index_futures","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"hk_stock_futures","show":true,"name":"","title":"股票期货","href":"/center/gridlist.html#hk_stock_futures","target":"_self","order":1,"groupKey":"","className":"","hot":false,"next":[]},{"key":"HCF_CUS","show":true,"name":"","title":"外汇期货","href":"/center/gridlist.html#HCF_CUS","target":"_self","order":2,"groupKey":"","className":"","hot":false,"next":[]},{"key":"HMFS_LRP","show":true,"name":"","title":"商品期货","href":"/center/gridlist.html#HMFS_LRP","target":"_self","order":3,"groupKey":"","className":"","hot":false,"next":[]}]},{"key":"futures_global","show":true,"name":"","title":"国际期货","href":"/center/gridlist.html#futures_global","target":"_self","order":6,"groupKey":"","className":"","hot":false,"next":[{"key":"futures_global-cobot","show":true,"name":"","title":"CME农业期货","href":"/center/gridlist.html#futures_global-cobot","target":"_self","order":1,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_global-nymex","show":true,"name":"","title":"CME能源期货","href":"/center/gridlist.html#futures_global-nymex","target":"_self","order":2,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_global-comex","show":true,"name":"","title":"CME金属期货","href":"/center/gridlist.html#futures_global-comex","target":"_self","order":3,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_global-nybot","show":true,"name":"","title":"ICE农业期货","href":"/center/gridlist.html#futures_global-nybot","target":"_self","order":4,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_global-lme","show":true,"name":"","title":"伦敦金属交易所","href":"/center/gridlist.html#futures_global-lme","target":"_self","order":5,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_global-ipe","show":true,"name":"","title":"ICE能源期货","href":"/center/gridlist.html#futures_global-ipe","target":"_self","order":6,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_global-tocom","show":true,"name":"","title":"东京商品期货","href":"/center/gridlist.html#futures_global-tocom","target":"_self","order":7,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_global-sgx","show":true,"name":"","title":"新加坡交易所","href":"/center/gridlist.html#futures_global-sgx","target":"_self","order":8,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_global-mdex","show":true,"name":"","title":"马来西亚交易所","href":"/center/gridlist.html#futures_global-mdex","target":"_self","order":9,"groupKey":"","className":"","hot":false,"next":[]}]},{"key":"futures_finance","show":true,"name":"","title":"金融期货","href":"/center/gridlist.html#futures_finance","target":"_self","order":13,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_energy","show":true,"name":"","title":"能源化工","href":"/center/gridlist.html#futures_energy","target":"_self","order":14,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_metal","show":true,"name":"","title":"金属钢材","href":"/center/gridlist.html#futures_metal","target":"_self","order":15,"groupKey":"","className":"","hot":false,"next":[]},{"key":"futures_farmproduce","show":true,"name":"","title":"农产品食品原料","href":"/center/gridlist.html#futures_farmproduce","target":"_self","order":16,"groupKey":"","className":"","hot":false,"next":[]}]},{"key":"fund_market","show":true,"name":"","title":"基金市场","href":"/center/jjsc.html","target":"_self","order":12,"groupKey":"","className":"","hot":false,"next":[{"key":"fund_close_end","show":true,"name":"","title":"封闭基金行情","href":"/center/gridlist.html#fund_close_end","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"fund_etf","show":true,"name":"","title":"ETF基金行情","href":"/center/gridlist.html#fund_etf","target":"_self","order":1,"groupKey":"","className":"","hot":false,"next":[]},{"key":"fund_lof","show":true,"name":"","title":"LOF基金行情","href":"/center/gridlist.html#fund_lof","target":"_self","order":2,"groupKey":"","className":"","hot":false,"next":[]},{"key":"fund_open_nav","show":true,"name":"","title":"开放式基金净值","href":"http://fund.eastmoney.com/data/fundranking.html","target":"_blank","order":3,"groupKey":"","className":"","hot":false,"next":[{"key":"fund_stocks","show":true,"name":"","title":"全部","href":"http://fund.eastmoney.com/data/fundranking.html","target":"_blank","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"fund_open_stock","show":true,"name":"","title":"股票型","href":"http://fund.eastmoney.com/data/fundranking.html#tgp","target":"_blank","order":1,"groupKey":"","className":"","hot":false,"next":[]},{"key":"fund_open_blend","show":true,"name":"","title":"混合型","href":"http://fund.eastmoney.com/data/fundranking.html#thh","target":"_blank","order":2,"groupKey":"","className":"","hot":false,"next":[]},{"key":"fund_open_bond","show":true,"name":"","title":"债券型","href":"http://fund.eastmoney.com/data/fundranking.html#tzq","target":"_blank","order":3,"groupKey":"","className":"","hot":false,"next":[]},{"key":"fund_open_lof","show":true,"name":"","title":"LOF","href":"http://fund.eastmoney.com/data/fundranking.html#tlof","target":"_blank","order":4,"groupKey":"","className":"","hot":false,"next":[]},{"key":"fund_open_eft","show":true,"name":"","title":"ETF","href":"http://fund.eastmoney.com/data/fundranking.html#tzs","target":"_blank","order":5,"groupKey":"","className":"","hot":false,"next":[]},{"key":"fund_open_qdii","show":true,"name":"","title":"QDII","href":"http://fund.eastmoney.com/data/fundranking.html#tqdii","target":"_blank","order":6,"groupKey":"","className":"","hot":false,"next":[]}]},{"key":"fund_close_nav","show":true,"name":"","title":"封闭式基金净值","href":"http://fund.eastmoney.com/CXXFBS_bzdm.html","target":"_blank","order":4,"groupKey":"","className":"","hot":false,"next":[]},{"key":"fund_monetary","show":true,"name":"","title":"货币型基金收益","href":"http://fund.eastmoney.com/HBJJ_dwsy.html","target":"_blank","order":5,"groupKey":"","className":"","hot":false,"next":[]},{"key":"fund_open_estimate","show":true,"name":"","title":"开放式净值估算","href":"http://fund.eastmoney.com/fund.html","target":"_blank","order":6,"groupKey":"","className":"","hot":false,"next":[]}]},{"key":"bond_market","show":true,"name":"","title":"债券市场","href":"/center/zqsc.html","target":"_self","order":13,"groupKey":"","className":"","hot":false,"next":[{"key":"bond_index","show":true,"name":"","title":"债券指数","href":"/center/gridlist.html#bond_index","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"bond_sh","show":true,"name":"","title":"上海债券","href":"/center/gridlist.html#bond_sh","target":"_self","order":1,"groupKey":"","className":"","hot":false,"next":[{"key":"bond_national_sh","show":true,"name":"","title":"沪国债","href":"/center/gridlist.html#bond_national_sh","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"bond_enterprise_sh","show":true,"name":"","title":"沪企债","href":"/center/gridlist.html#bond_enterprise_sh","target":"_self","order":1,"groupKey":"","className":"","hot":false,"next":[]},{"key":"bond_convertible_sh","show":true,"name":"","title":"沪转债","href":"/center/gridlist.html#bond_convertible_sh","target":"_self","order":2,"groupKey":"","className":"","hot":false,"next":[]}]},{"key":"convertible_comparison","show":true,"name":"","title":"可转债比价表","href":"/center/fullscreenlist.html#convertible_comparison","target":"_blank","order":1,"groupKey":"","className":"","hot":false,"next":[]},{"key":"bond_sz","show":true,"name":"","title":"深圳债券","href":"/center/gridlist.html#bond_sz","target":"_self","order":2,"groupKey":"","className":"","hot":false,"next":[{"key":"bond_national_sz","show":true,"name":"","title":"深国债","href":"/center/gridlist.html#bond_national_sz","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"bond_enterprise_sz","show":true,"name":"","title":"深企债","href":"/center/gridlist.html#bond_enterprise_sz","target":"_self","order":1,"groupKey":"","className":"","hot":false,"next":[]},{"key":"bond_convertible_sz","show":true,"name":"","title":"深转债","href":"/center/gridlist.html#bond_convertible_sz","target":"_self","order":2,"groupKey":"","className":"","hot":false,"next":[]}]},{"key":"bond_sh_buyback","show":true,"name":"","title":"上证回购","href":"/center/gridlist.html#bond_sh_buyback","target":"_self","order":3,"groupKey":"","className":"","hot":false,"next":[]},{"key":"bond_sz_buyback","show":true,"name":"","title":"深证回购","href":"/center/gridlist.html#bond_sz_buyback","target":"_self","order":4,"groupKey":"","className":"","hot":false,"next":[]}]},{"key":"forex_market","show":true,"name":"","title":"外汇市场","href":"/center/whsc.html","target":"_self","order":14,"groupKey":"","className":"","hot":false,"next":[{"key":"forex_all","show":true,"name":"","title":"所有汇率","href":"/center/gridlist.html#forex_all","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"forex_basic","show":true,"name":"","title":"基本汇率","href":"/center/gridlist.html#forex_basic","target":"_self","order":1,"groupKey":"","className":"","hot":false,"next":[]},{"key":"forex_cross","show":true,"name":"","title":"交叉汇率","href":"/center/gridlist.html#forex_cross","target":"_self","order":2,"groupKey":"","className":"","hot":false,"next":[]},{"key":"forex_cny","show":true,"name":"","title":"人民币品种","href":"/center/gridlist.html#forex_cny","target":"_self","order":3,"groupKey":"","className":"","hot":false,"next":[{"key":"forex_cnyc","show":true,"name":"","title":"人民币汇率中间价","href":"/center/gridlist.html#forex_cnyc","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"forex_cnyi","show":true,"name":"","title":"人民币询价","href":"/center/gridlist.html#forex_cnyi","target":"_self","order":1,"groupKey":"","className":"","hot":false,"next":[]},{"key":"forex_cnyb","show":true,"name":"","title":"人民币竞价","href":"/center/gridlist.html#forex_cnyb","target":"_self","order":2,"groupKey":"","className":"","hot":false,"next":[]},{"key":"forex_cnh","show":true,"name":"","title":"离岸人民币外币","href":"/center/gridlist.html#forex_cnh","target":"_self","order":3,"groupKey":"","className":"","hot":false,"next":[]}]},{"key":"forex_exchange","show":true,"name":"","title":"外汇牌价","href":"/center/gridlist.html#forex_exchange_icbc","target":"_self","order":4,"groupKey":"","className":"","hot":false,"next":[{"key":"forex_exchange_icbc","show":true,"name":"","title":"工商银行报价","href":"/center/gridlist.html#forex_exchange_icbc","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"forex_exchange_abc","show":true,"name":"","title":"农业银行报价","href":"/center/gridlist.html#forex_exchange_abc","target":"_self","order":1,"groupKey":"","className":"","hot":false,"next":[]},{"key":"forex_exchange_boc","show":true,"name":"","title":"中国银行报价","href":"/center/gridlist.html#forex_exchange_boc","target":"_self","order":2,"groupKey":"","className":"","hot":false,"next":[]},{"key":"forex_exchange_ccb","show":true,"name":"","title":"建设银行报价","href":"/center/gridlist.html#forex_exchange_ccb","target":"_self","order":3,"groupKey":"","className":"","hot":false,"next":[]},{"key":"forex_exchange_bcm","show":true,"name":"","title":"交通银行报价","href":"/center/gridlist.html#forex_exchange_bcm","target":"_self","order":4,"groupKey":"","className":"","hot":false,"next":[]},{"key":"forex_exchange_cmb","show":true,"name":"","title":"招商银行报价","href":"/center/gridlist.html#forex_exchange_cmb","target":"_self","order":4,"groupKey":"","className":"","hot":false,"next":[]}]},{"key":"forex_exchange_icbc","show":false,"name":"","title":"工商银行报价","href":"/center/gridlist.html#forex_exchange_icbc","target":"_self","order":5,"groupKey":"","className":"","hot":false,"next":[]},{"key":"forex_exchange_abc","show":false,"name":"","title":"农业银行报价","href":"/center/gridlist.html#forex_exchange_abc","target":"_self","order":6,"groupKey":"","className":"","hot":false,"next":[]},{"key":"forex_exchange_boc","show":false,"name":"","title":"中国银行报价","href":"/center/gridlist.html#forex_exchange_boc","target":"_self","order":7,"groupKey":"","className":"","hot":false,"next":[]},{"key":"forex_exchange_ccb","show":false,"name":"","title":"建设银行报价","href":"/center/gridlist.html#forex_exchange_ccb","target":"_self","order":8,"groupKey":"","className":"","hot":false,"next":[]},{"key":"forex_exchange_bcm","show":false,"name":"","title":"交通银行报价","href":"/center/gridlist.html#forex_exchange_bcm","target":"_self","order":8,"groupKey":"","className":"","hot":false,"next":[]},{"key":"forex_exchange_cmb","show":false,"name":"","title":"招商银行报价","href":"/center/gridlist.html#forex_exchange_cmb","target":"_self","order":9,"groupKey":"","className":"","hot":false,"next":[]}]},{"key":"options_market","show":true,"name":"","title":"期权市场","href":"/center/qqsc.html","target":"_self","order":15,"groupKey":"","className":"","hot":false,"next":[{"key":"options_sh50etf","show":true,"name":"","title":"上交所","href":"/center/gridlist.html#options_sh50etf_all","target":"_self","order":-2,"groupKey":"","className":"","hot":false,"next":[{"key":"options_sh50etf","show":true,"name":"","title":"上交期权","href":"/center/gridlist.html#options_sh50etf_all","target":"_self","order":-1,"groupKey":"","className":"","hot":false,"next":[]},{"key":"options_sh50etf_all","show":false,"name":"","title":"全部期权","href":"/center/gridlist.html#options_sh50etf_all","target":"_self","order":-1,"groupKey":"","className":"","hot":false,"next":[]},{"key":"options_sh50etf_call","show":false,"name":"","title":"认购期权","href":"/center/gridlist.html#options_sh50etf_call","target":"_self","order":-1,"groupKey":"","className":"","hot":false,"next":[]},{"key":"options_sh50etf_put","show":false,"name":"","title":"认沽期权","href":"/center/gridlist.html#options_sh50etf_put","target":"_self","order":-1,"groupKey":"","className":"","hot":false,"next":[]}]},{"key":"options_sh50etf_all","show":false,"name":"","title":"上交期权","href":"/center/gridlist.html#options_sh50etf_all","target":"_self","order":-1,"groupKey":"","className":"","hot":false,"next":[]},{"key":"options_sh50etf_call","show":false,"name":"","title":"认购期权","href":"/center/gridlist.html#options_sh50etf_call","target":"_self","order":-1,"groupKey":"","className":"","hot":false,"next":[]},{"key":"options_sh50etf_put","show":false,"name":"","title":"认沽期权","href":"/center/gridlist.html#options_sh50etf_put","target":"_self","order":-1,"groupKey":"","className":"","hot":false,"next":[]},{"key":"options_szetf_all","show":true,"name":"","title":"深交所","href":"/center/gridlist.html#options_szetf_all","target":"_self","order":-1,"groupKey":"","className":"","hot":false,"next":[{"key":"options_sz300etf_all","show":true,"name":"","title":"深交期权","href":"/center/gridlist.html#options_sz300etf_all","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]}]},{"key":"options_cffex_all","show":true,"name":"","title":"中金所","href":"/center/gridlist.html#options_cffex_all","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[{"key":"options_cffex_io","show":true,"name":"","title":"沪深300指数","href":"/center/gridlist.html#options_cffex_io","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]}]},{"key":"options_shfe_all","show":true,"name":"","title":"上期所","href":"/center/gridlist.html#options_shfe_all","target":"_self","order":1,"groupKey":"","className":"","hot":false,"next":[{"key":"options_cu_all","show":true,"name":"","title":"铜","href":"/center/gridlist.html#options_cu_all","target":"_self","order":1,"groupKey":"","className":"","hot":false,"next":[]},{"key":"options_ru_all","show":true,"name":"","title":"橡胶","href":"/center/gridlist.html#options_ru_all","target":"_self","order":2,"groupKey":"","className":"","hot":false,"next":[]},{"key":"options_au_all","show":true,"name":"","title":"黄金","href":"/center/gridlist.html#options_au_all","target":"_self","order":3,"groupKey":"","className":"","hot":false,"next":[]}]},{"key":"options_dce_all","show":true,"name":"","title":"大商所","href":"/center/gridlist.html#options_dce_all","target":"_self","order":2,"groupKey":"","className":"","hot":false,"next":[{"key":"options_beanpulp_all","show":true,"name":"","title":"豆粕","href":"/center/gridlist.html#options_beanpulp_all","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"options_c_all","show":true,"name":"","title":"玉米","href":"/center/gridlist.html#options_c_all","target":"_self","order":1,"groupKey":"","className":"","hot":false,"next":[]},{"key":"options_t_all","show":true,"name":"","title":"铁矿石","href":"/center/gridlist.html#options_t_all","target":"_self","order":2,"groupKey":"","className":"","hot":false,"next":[]}]},{"key":"options_czce_all","show":true,"name":"","title":"郑商所","href":"/center/gridlist.html#options_czce_all","target":"_self","order":3,"groupKey":"","className":"","hot":false,"next":[{"key":"options_sugar_all","show":true,"name":"","title":"白糖","href":"/center/gridlist.html#options_sugar_all","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"options_cf_all","show":true,"name":"","title":"棉花","href":"/center/gridlist.html#options_cf_all","target":"_self","order":1,"groupKey":"","className":"","hot":false,"next":[]},{"key":"options_cf_ta","show":true,"name":"","title":"PTA期权","href":"/center/gridlist.html#options_cf_ta","target":"_self","order":2,"groupKey":"","className":"","hot":false,"next":[]},{"key":"options_cf_ma","show":true,"name":"","title":"甲醇","href":"/center/gridlist.html#options_cf_ma","target":"_self","order":3,"groupKey":"","className":"","hot":false,"next":[]},{"key":"options_cf_cp","show":true,"name":"","title":"菜粕","href":"/center/gridlist.html#options_cf_cp","target":"_self","order":4,"groupKey":"","className":"","hot":false,"next":[]}]},{"key":"options_hkex","show":true,"name":"","title":"香港期交所","href":"/center/gridlist.html#options_uscny_all","target":"_self","order":4,"groupKey":"","className":"","hot":false,"next":[{"key":"options_uscny_all","show":true,"name":"","title":"美元兑人民币","href":"/center/gridlist.html#options_uscny_all","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]}]}]},{"key":"gold_market","show":true,"name":"","title":"黄金市场","href":"/center/hjsc.html","target":"_self","order":16,"groupKey":"","className":"","hot":false,"next":[{"key":"gold_sh_spotgoods","show":true,"name":"","title":"上海黄金现货","href":"/center/gridlist.html#gold_sh_spotgoods","target":"_self","order":0,"groupKey":"","className":"","hot":false,"next":[]},{"key":"gold_sh_futures","show":true,"name":"","title":"上海黄金期货","href":"/center/gridlist.html#gold_sh_futures","target":"_self","order":1,"groupKey":"","className":"","hot":false,"next":[]},{"key":"nobalmetal_spotgoods","show":true,"name":"","title":"国际贵金属现货","href":"/center/gridlist.html#nobalmetal_spotgoods","target":"_self","order":2,"groupKey":"","className":"","hot":false,"next":[]},{"key":"nobalmetal_futures","show":true,"name":"","title":"国际贵金属期货","href":"/center/gridlist.html#nobalmetal_futures","target":"_self","order":3,"groupKey":"","className":"","hot":false,"next":[]}]}]'''

timejs='''/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "./jssrc/timetrade.ts");
/******/ })
/************************************************************************/
/******/ ({

/***/ "./jssrc/timetrade.ts":
/*!****************************!*\
  !*** ./jssrc/timetrade.ts ***!
  \****************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

/**
 * 分时成交JS
 */
function GetQueryString(name) {
    var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
    var r = window.location.search.toLowerCase().substr(1).match(reg);
    if (r != null)
        return unescape(r[2]);
    return null;
}
window['stockEnity'] = {
    "stockCode": GetQueryString("code") || "",
    "stockmarket": GetQueryString("market") || "",
    "stockId": GetQueryString("id") || GetQueryString("code") + GetQueryString("market")
};
__webpack_require__(/*! ../src/modules/old_f1 */ "./src/modules/old_f1/index.js");
setTimeout(function () {
    qphf.getIndexQuote(15);
}, 500);
var HV = new HistoryViews("historyest", {
    def: "",
    set: "",
    lns: 11
});
var _cpyno = "c1";


/***/ }),

/***/ "./src/modules/ie_sse_polyfill/index.js":
/*!**********************************************!*\
  !*** ./src/modules/ie_sse_polyfill/index.js ***!
  \**********************************************/
/*! no static exports found */
/***/ (function(module, exports) {

/*
   * EventSource polyfill version 0.9.7
   * Supported by sc AmvTek srl
   * :email: devel@amvtek.com
 */
;(function (global) {

    if (global.EventSource && !global._eventSourceImportPrefix){
        return;
    }

    var evsImportName = (global._eventSourceImportPrefix||'')+"EventSource";

    var EventSource = function (url, options) {

        if (!url || typeof url != 'string') {
            throw new SyntaxError('Not enough arguments');
        }

        this.URL = url;
        this.setOptions(options);
        var evs = this;
        setTimeout(function(){evs.poll()}, 0);
    };

    EventSource.prototype = {

        CONNECTING: 0,

        OPEN: 1,

        CLOSED: 2,

        defaultOptions: {

            loggingEnabled: false,

            loggingPrefix: "eventsource",

            interval: 500, // milliseconds

            bufferSizeLimit: 256*1024, // bytes

            silentTimeout: 300000, // milliseconds

            getArgs:{
                'evs_buffer_size_limit': 256*1024
            },

            xhrHeaders:{
                'Accept': 'text/event-stream',
                'Cache-Control': 'no-cache',
                'X-Requested-With': 'XMLHttpRequest'
            }
        },

        setOptions: function(options){

            var defaults = this.defaultOptions;
            var option;

            // set all default options...
            for (option in defaults){

                if ( defaults.hasOwnProperty(option) ){
                    this[option] = defaults[option];
                }
            }

            // override with what is in options
            for (option in options){

                if (option in defaults && options.hasOwnProperty(option)){
                    this[option] = options[option];
                }
            }

            // if getArgs option is enabled
            // ensure evs_buffer_size_limit corresponds to bufferSizeLimit
            if (this.getArgs && this.bufferSizeLimit) {

                this.getArgs['evs_buffer_size_limit'] = this.bufferSizeLimit;
            }

            // if console is not available, force loggingEnabled to false
            if (typeof console === "undefined" || typeof console.log === "undefined") {

                this.loggingEnabled = false;
            }
        },

        log: function(message) {

            if (this.loggingEnabled) {

                console.log("[" + this.loggingPrefix +"]:" + message)
            }
        },

        poll: function() {

            try {

                if (this.readyState == this.CLOSED) {
                    return;
                }

                this.cleanup();
                this.readyState = this.CONNECTING;
                this.cursor = 0;
                this.cache = '';
                this._xhr = new this.XHR(this);
                this.resetNoActivityTimer();

            }
            catch (e) {

                // in an attempt to silence the errors
                this.log('There were errors inside the pool try-catch');
                this.dispatchEvent('error', { type: 'error', data: e.message });
            }
        },

        pollAgain: function (interval) {

            // schedule poll to be called after interval milliseconds
            var evs = this;
            evs.readyState = evs.CONNECTING;
            evs.dispatchEvent('error', {
                type: 'error',
                data: "Reconnecting "
            });
            this._pollTimer = setTimeout(function(){evs.poll()}, interval||0);
        },


        cleanup: function() {

            this.log('evs cleaning up')

            if (this._pollTimer){
                clearInterval(this._pollTimer);
                this._pollTimer = null;
            }

            if (this._noActivityTimer){
                clearInterval(this._noActivityTimer);
                this._noActivityTimer = null;
            }

            if (this._xhr){
                this._xhr.abort();
                this._xhr = null;
            }
        },

        resetNoActivityTimer: function(){

            if (this.silentTimeout){

                if (this._noActivityTimer){
                    clearInterval(this._noActivityTimer);
                }
                var evs = this;
                this._noActivityTimer = setTimeout(
                        function(){ evs.log('Timeout! silentTImeout:'+evs.silentTimeout); evs.pollAgain(); },
                        this.silentTimeout
                        );
            }
        },

        close: function () {

            this.readyState = this.CLOSED;
            this.log('Closing connection. readyState: '+this.readyState);
            this.cleanup();
        },

        _onxhrdata: function() {

            var request = this._xhr;

            if (request.isReady() && !request.hasError() ) {
                // reset the timer, as we have activity
                this.resetNoActivityTimer();

                // move this EventSource to OPEN state...
                if (this.readyState == this.CONNECTING) {
                    this.readyState = this.OPEN;
                    this.dispatchEvent('open', { type: 'open' });
                }

                var buffer = request.getBuffer();

                if (buffer.length > this.bufferSizeLimit) {
                    this.log('buffer.length > this.bufferSizeLimit');
                    this.pollAgain();
                }

                if (this.cursor == 0 && buffer.length > 0){

                    // skip byte order mark \uFEFF character if it starts the stream
                    if (buffer.substring(0,1) == '\uFEFF'){
                        this.cursor = 1;
                    }
                }

                var lastMessageIndex = this.lastMessageIndex(buffer);
                if (lastMessageIndex[0] >= this.cursor){

                    var newcursor = lastMessageIndex[1];
                    var toparse = buffer.substring(this.cursor, newcursor);
                    this.parseStream(toparse);
                    this.cursor = newcursor;
                }

                // if request is finished, reopen the connection
                if (request.isDone()) {
                    this.log('request.isDone(). reopening the connection');
                    this.pollAgain(this.interval);
                }
            }
            else if (this.readyState !== this.CLOSED) {

                this.log('this.readyState !== this.CLOSED');
                this.pollAgain(this.interval);

                //MV: Unsure why an error was previously dispatched
            }
        },

        parseStream: function(chunk) {

            // normalize line separators (\r\n,\r,\n) to \n
            // remove white spaces that may precede \n
            chunk = this.cache + this.normalizeToLF(chunk);

            var events = chunk.split('\n\n');

            var i, j, eventType, datas, line, retry;

            for (i=0; i < (events.length - 1); i++) {

                eventType = 'message';
                datas = [];
                parts = events[i].split('\n');

                for (j=0; j < parts.length; j++) {

                    line = this.trimWhiteSpace(parts[j]);

                    if (line.indexOf('event') == 0) {

                        eventType = line.replace(/event:?\s*/, '');
                    }
                    else if (line.indexOf('retry') == 0) {

                        retry = parseInt(line.replace(/retry:?\s*/, ''));
                        if(!isNaN(retry)) {
                            this.interval = retry;
                        }
                    }
                    else if (line.indexOf('data') == 0) {

                        datas.push(line.replace(/data:?\s*/, ''));
                    }
                    else if (line.indexOf('id:') == 0) {

                        this.lastEventId = line.replace(/id:?\s*/, '');
                    }
                    else if (line.indexOf('id') == 0) { // this resets the id

                        this.lastEventId = null;
                    }
                }

                if (datas.length) {
                    // dispatch a new event
                    var event = new MessageEvent(eventType, datas.join('\n'), window.location.origin, this.lastEventId);
                    this.dispatchEvent(eventType, event);
                }
            }

            this.cache = events[events.length - 1];
        },

        dispatchEvent: function (type, event) {
            var handlers = this['_' + type + 'Handlers'];

            if (handlers) {

                for (var i = 0; i < handlers.length; i++) {
                    handlers[i].call(this, event);
                }
            }

            if (this['on' + type]) {
                this['on' + type].call(this, event);
            }

        },

        addEventListener: function (type, handler) {
            if (!this['_' + type + 'Handlers']) {
                this['_' + type + 'Handlers'] = [];
            }

            this['_' + type + 'Handlers'].push(handler);
        },

        removeEventListener: function (type, handler) {
            var handlers = this['_' + type + 'Handlers'];
            if (!handlers) {
                return;
            }
            for (var i = handlers.length - 1; i >= 0; --i) {
                if (handlers[i] === handler) {
                    handlers.splice(i, 1);
                    break;
                }
            }
        },

        _pollTimer: null,

        _noactivityTimer: null,

        _xhr: null,

        lastEventId: null,

        cache: '',

        cursor: 0,

        onerror: null,

        onmessage: null,

        onopen: null,

        readyState: 0,

        // ===================================================================
        // helpers functions
        // those are attached to prototype to ease reuse and testing...

        urlWithParams: function (baseURL, params) {

            var encodedArgs = [];

            if (params){

                var key, urlarg;
                var urlize = encodeURIComponent;

                for (key in params){
                    if (params.hasOwnProperty(key)) {
                        urlarg = urlize(key)+'='+urlize(params[key]);
                        encodedArgs.push(urlarg);
                    }
                }
            }

            if (encodedArgs.length > 0){

                if (baseURL.indexOf('?') == -1)
                    return baseURL + '?' + encodedArgs.join('&');
                return baseURL + '&' + encodedArgs.join('&');
            }
            return baseURL;
        },

        lastMessageIndex: function(text) {

            var ln2 =text.lastIndexOf('\n\n');
            var lr2 = text.lastIndexOf('\r\r');
            var lrln2 = text.lastIndexOf('\r\n\r\n');

            if (lrln2 > Math.max(ln2, lr2)) {
                return [lrln2, lrln2+4];
            }
            return [Math.max(ln2, lr2), Math.max(ln2, lr2) + 2]
        },

        trimWhiteSpace: function(str) {
            // to remove whitespaces left and right of string

            var reTrim = /^(\s|\u00A0)+|(\s|\u00A0)+$/g;
            return str.replace(reTrim, '');
        },

        normalizeToLF: function(str) {

            // replace \r and \r\n with \n
            return str.replace(/\r\n|\r/g, '\n');
        }

    };

    if (!isOldIE()){

        EventSource.isPolyfill = "XHR";

        // EventSource will send request using XMLHttpRequest
        EventSource.prototype.XHR = function(evs) {

            request = new XMLHttpRequest();
            this._request = request;
            evs._xhr = this;

            // set handlers
            request.onreadystatechange = function(){
                if (request.readyState > 1 && evs.readyState != evs.CLOSED) {
                    if (request.status == 200 || (request.status>=300 && request.status<400)){
                        evs._onxhrdata();
                    }
                    else {
                        request._failed = true;
                        evs.readyState = evs.CLOSED;
                        evs.dispatchEvent('error', {
                            type: 'error',
                            data: "The server responded with "+request.status
                        });
                        evs.close();
                    }
                }
            };

            request.onprogress = function () {
            };

            request.open('GET', evs.urlWithParams(evs.URL, evs.getArgs), true);

            var headers = evs.xhrHeaders; // maybe null
            for (var header in headers) {
                if (headers.hasOwnProperty(header)){
                    request.setRequestHeader(header, headers[header]);
                }
            }
            if (evs.lastEventId) {
                request.setRequestHeader('Last-Event-Id', evs.lastEventId);
            }

            request.send();
        };

        EventSource.prototype.XHR.prototype = {

            useXDomainRequest: false,

            _request: null,

            _failed: false, // true if we have had errors...

            isReady: function() {


                return this._request.readyState >= 2;
            },

            isDone: function() {

                return (this._request.readyState == 4);
            },

            hasError: function() {

                return (this._failed || (this._request.status >= 400));
            },

            getBuffer: function() {

                var rv = '';
                try {
                    rv = this._request.responseText || '';
                }
                catch (e){}
                return rv;
            },

            abort: function() {

                if ( this._request ) {
                    this._request.abort();
                }
            }
        };
    }
    else {

	EventSource.isPolyfill = "IE_8-9";

        // patch EventSource defaultOptions
        var defaults = EventSource.prototype.defaultOptions;
        defaults.xhrHeaders = null; // no headers will be sent
        defaults.getArgs['evs_preamble'] = 2048 + 8;

        // EventSource will send request using Internet Explorer XDomainRequest
        EventSource.prototype.XHR = function(evs) {

            request = new XDomainRequest();
            this._request = request;

            // set handlers
            request.onprogress = function(){
                request._ready = true;
                evs._onxhrdata();
            };

            request.onload = function(){
                this._loaded = true;
                evs._onxhrdata();
            };

            request.onerror = function(){
                this._failed = true;
                evs.readyState = evs.CLOSED;
                evs.dispatchEvent('error', {
                    type: 'error',
                    data: "XDomainRequest error"
                });
            };

            request.ontimeout = function(){
                this._failed = true;
                evs.readyState = evs.CLOSED;
                evs.dispatchEvent('error', {
                    type: 'error',
                    data: "XDomainRequest timed out"
                });
            };

            // XDomainRequest does not allow setting custom headers
            // If EventSource has enabled the use of GET arguments
            // we add parameters to URL so that server can adapt the stream...
            var reqGetArgs = {};
            if (evs.getArgs) {

                // copy evs.getArgs in reqGetArgs
                var defaultArgs = evs.getArgs;
                    for (var key in defaultArgs) {
                        if (defaultArgs.hasOwnProperty(key)){
                            reqGetArgs[key] = defaultArgs[key];
                        }
                    }
                if (evs.lastEventId){
                    reqGetArgs['evs_last_event_id'] = evs.lastEventId;
                }
            }
            // send the request

            request.open('GET', evs.urlWithParams(evs.URL,reqGetArgs));
            request.send();
        };

        EventSource.prototype.XHR.prototype = {

            useXDomainRequest: true,

            _request: null,

            _ready: false, // true when progress events are dispatched

            _loaded: false, // true when request has been loaded

            _failed: false, // true if when request is in error

            isReady: function() {

                return this._request._ready;
            },

            isDone: function() {

                return this._request._loaded;
            },

            hasError: function() {

                return this._request._failed;
            },

            getBuffer: function() {

                var rv = '';
                try {
                    rv = this._request.responseText || '';
                }
                catch (e){}
                return rv;
            },

            abort: function() {

                if ( this._request){
                    this._request.abort();
                }
            }
        };
    }

    function MessageEvent(type, data, origin, lastEventId) {

        this.bubbles = false;
        this.cancelBubble = false;
        this.cancelable = false;
        this.data = data || null;
        this.origin = origin || '';
        this.lastEventId = lastEventId || '';
        this.type = type || 'message';
    }

    function isOldIE () {

        //return true if we are in IE8 or IE9
        return (window.XDomainRequest && (window.XMLHttpRequest && new XMLHttpRequest().responseType === undefined)) ? true : false;
    }

    global[evsImportName] = EventSource;
})(window);

/***/ }),

/***/ "./src/modules/old_f1/index.js":
/*!*************************************!*\
  !*** ./src/modules/old_f1/index.js ***!
  \*************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {


__webpack_require__(/*! ../ie_sse_polyfill */ "./src/modules/ie_sse_polyfill/index.js");

var template = __webpack_require__(/*! ../template */ "./src/modules/template/index.js")
// var marge = require('lodash/merge');
var marge = _.merge;



    $(function () {
        drawTable();
        setInterval(refresh, 30 * 1000);
        //setInterval(loadQuote, 10*1000);
        loadQuote();
        JuadeIe7();
        

        filterFun();
        clickFun();
        // isRong();
        var suggest =  new suggest2017({
            inputid: "search_box",
            offset: { left: -91, top: 5 }
        });
    });

    function refresh() {
        var option = argFun();
        drawTable(option);
        // loadQuote();
    }

    //区分ie7
    function JuadeIe7() {
         //增加判断浏览器是否为ie7及以下
         if (document.all && !document.querySelector) {
            setInterval(loadQuote, 30 * 1000);
         } else {
            sseHeadData();
         }
    }

    function argFun() {
        var option = {};
        $(".bigOrder dd input[type=radio]").each(function () {
            if ($(this).prop("checked")) {
                // option.gtvolume = $(this).val();
                var gtvolume = $(this).val();
                if(gtvolume == '100') {
                    option.ft = 2
                } else if(gtvolume == '200') {
                    option.ft = 3
                } else if(gtvolume == '500') {
                    option.ft = 4
                } else if(gtvolume == '1000') {
                    option.ft = 5
                } else if(gtvolume == '2000') {
                    option.ft = 6
                } else if(gtvolume == '5000') {
                    option.ft = 7
                } else if(gtvolume == '10000') {
                    option.ft = 8
                } else {
                    option.ft = 1
                }
            }

        });
        option.sort = $("#reverseInput").val();
        option.pageindex = Number($(".curPage").html()) - 1;
        //console.log(option)
        return option;
    }


    //青色=绿色=1=#00ffff，紫色=红色=2=ff00ff 先判断方向再判断大于20万  1是涨 -1是跌 0是没跌没涨
    //增加newflag 倒序无需执行分页
    //分时成交
    function drawTable(option, newflag) {
        var _default = {
            "pageindex": 0, "id": stockEnity.stockId, "sort": 1, "ft": 1
        }
        var _option = $.extend(_default, option);
        _option.code = getCode();
        _option.market = getMarket();


        if (_option.pageindex == -1) { return; }
        // var url = "http://61.152.230.32:1981/getStockFenShi?pagesize=144&ut=7eea3edcaed734bea9cbfc24409ed989&dpt=wzfscj"
        var url = "http://push2ex.eastmoney.com/getStockFenShi?pagesize=144&ut=7eea3edcaed734bea9cbfc24409ed989&dpt=wzfscj"
        $.ajax({
            url: url,
            dataType: "jsonp",
            jsonp: "cb",
            data: _option,
            success: function (json) {
                if (json.data) {
                    // console.log('分时时间')
                    // console.log(json)
                    var count = Math.ceil(json.data.tc / 144);
                    var kcbFlag = json.data.ct;
                    if(count == 0) {
                        count = 1;
                    }
                    // console.log(count)
                    var data = json.data.data, pc = Dealprice(json.data.cp);
                    var list1 = [], list2 = [], list3 = [], list4 = [];
                    var html_1 = "", html_2 = "", html_3 = "", html_4 = "";
                    var dir = "", color = "", otherColor = "", chje = "";
                    if (!data && data.length == 0 && typeof data == "string") { return; }
                    for (var i = 0; i < data.length; i++) {
                        var preItems = data[i-1];
                        var items = data[i];
                        color = Dealprice(items.p) - pc == 0 ? "" : Dealprice(items.p) - pc > 0 ? "red" : Dealprice(items.p) - pc < 0 ? "green" : "";
                        chje = items.v * 100 * Dealprice(items.p);
                        if (items.bs == "1") {
                            otherColor = chje > 200000 ? "blue" : "green";
                        } else if (items.bs == "2") {
                            otherColor = chje > 200000 ? "purple" : "red";
                        } else {
                            otherColor = "";
                        }
                        //箭头
                        if (items.bs != "4") {
                            if(preItems) {
                                if (items.p > preItems.p) {
                                    dir = "red";
                                } else if (items.p < preItems.p) {
                                    dir = "green";
                                } else {
                                    dir = "";
                                }
                            }else {
                                dir = "";
                            }
                           
                        } else {
                            dir = "";
                            items.v = "-";
                            color = "";
                        }

                        //判断是否是科创板 手数做不同处理
                        var new_cjs = items.v;
                        if(kcbFlag == 1) {
                            new_cjs = kcbMyformatNum(new_cjs);
                            // console.log(new_cjs)
                            
                        }else {
                            new_cjs = new_cjs;
                        }
                        

                        if (i < 36) {
                            list1.push({
                                "time": DealTime(items.t),
                                "close": Dealprice(items.p),
                                "coloseColor": color,
                                "num": new_cjs,
                                "fontColor": otherColor,
                                "dir": dir
                            });
                        }
                        if (i > 35 && i < 72) {
                            list2.push({
                                "time": DealTime(items.t),
                                "close": Dealprice(items.p),
                                "coloseColor": color,
                                "num": new_cjs,
                                "fontColor": otherColor,
                                "dir": dir
                            });
                        }
                        if (i > 71 && i < 108) {
                            list3.push({
                                "time": DealTime(items.t),
                                "close": Dealprice(items.p),
                                "coloseColor": color,
                                "num": new_cjs,
                                "fontColor": otherColor,
                                "dir": dir
                            });
                        }
                        if (i > 107 && i < 144) {
                            list4.push({
                                "time": DealTime(items.t),
                                "close": Dealprice(items.p),
                                "coloseColor": color,
                                "num": new_cjs,
                                "fontColor": otherColor,
                                "dir": dir
                            });
                        }
                    }
                    var html_1 = template("tmp", { list: list1 });
                    var html_2 = template("tmp", { list: list2 });
                    var html_3 = template("tmp", { list: list3 });
                    var html_4 = template("tmp", { list: list4 });
                    $("#listTable1 tbody").html(html_1);
                    $("#listTable2 tbody").html(html_2);
                    $("#listTable3 tbody").html(html_3);
                    $("#listTable4 tbody").html(html_4);

                   

                    if(newflag !== false) {
                        pageFun(count, _option.pageindex);
                    }
                    
                }


            }
        })

    }


    //科创板成交量
    function kcbMyformatNum(num) {
        if (num == '-') {
            return '-';
        }

        if (num == undefined  || isNaN(num)) {
            return '';
        }


        var hz = '';
        var num2 = '';
        try {
           if (num >= 0 && num <= 99.999999999) {
                num2 = parseFloat(num).toFixed(2);
            } else if (num >= 100 && num <= 999) {
                num2 = parseFloat(num).toFixed(1);
            } else if (num >= 1000) {
                // num2 = parseFloat(num).toFixed(0);
                if (num > 10000 && num < 100000000) {
                    num2 = (num / 10000).toFixed(2) + "万";
                } else if (num > 100000000) {
                    num2 = (num / 100000000).toFixed(2) + "亿";
                } else if (num == 0) {
                    num2 = '-';
                } else {
                    num2 = num.toFixed(0);
                }
            }


            return num2.toString() + hz;

        } catch (error) {
            return '-';
        }


    }


    //处理价格
    function Dealprice(val) {
        try {
            val = val/1000;
            return val.toFixed(2);
        } catch(e) {
            return '-'
        }

    }

    //处理时间
    function DealTime(val) {
        try {
            val = '' + val;
           if(val.length == 5) {
               val = '0' + val;
           }

           return val.substr(0,2) + ':' + val.substr(2,2) + ':' + val.substr(4,2)

        } catch(e) {
            return '-'
        }

    }

    //翻页的html
    function pageFun(count, page) {
        var count = Number(count);
        var page = Number(page);
        if (count == 0) {
            page = 0;
        }

        var obj = {
            "curPage": page,
            "prev": page == 0 ? 0 : page - 1 ,
            "next": page == count ? count : page + 1,
            "count": count
        };
        var lstxt = obj.curPage + 1;
        //ie7
        $(".prevPage").attr("mypage",  obj.prev);
        // $(".prevPage").attr("value", obj.prev);
        $(".nextPage").attr("mypage", obj.next);
        $(".lastPage").attr("mypage", obj.count-1);
       
        $(".curPage").text(lstxt);
       
       
        $(".count").text(obj.count);

        if (count == page+1) {
            $(".lastPage").removeClass("canClick");
            $(".arrowR").hide();
            $(".nextPage").removeClass("canClick");
        } else {
            $(".lastPage").addClass("canClick");
            $(".nextPage").addClass("canClick");
            $(".arrowR").show();
        }
        if (page+1 == 1) {
            $(".fistPage").removeClass("canClick");
            $(".prevPage").removeClass("canClick");
            $(".arrowL").hide();
        } else {
            $(".fistPage").addClass("canClick");
            $(".prevPage").addClass("canClick");
            $(".arrowL").show();
        }
        if (count == 0) {
            $(".liPage").removeClass("canClick");
            $(".arrowR").hide();
            $(".arrowL").hide();
        }
    }

    //筛选、倒序
    function filterFun() {
        $(".bigOrder input[type=radio]").change(function () {
            var option = {};
            // console.log('筛选大单：',$(this).val())
            // option.gtvolume = $(this).val();
            var gtvolume = $(this).val();
            if(gtvolume == '100') {
                option.ft = 2
            } else if(gtvolume == '200') {
                option.ft = 3
            } else if(gtvolume == '500') {
                option.ft = 4
            } else if(gtvolume == '1000') {
                option.ft = 5
            } else if(gtvolume == '2000') {
                option.ft = 6
            } else if(gtvolume == '5000') {
                option.ft = 7
            } else if(gtvolume == '10000') {
                option.ft = 8
            } else {
                option.ft = 1
            }
           
            option.sort = $("#reverseInput").val();

            drawTable(option);
        });

        $(".reverseDiv input[type=checkbox]").change(function () {
            var option = {};
            if ($(this).prop("checked")) {
                $(this).val("2");
            } else {
                $(this).val("1");
            }
            option.sort = $("#reverseInput").val();
            //option.page = Number($(".curPage").html());
            //argFun()
            var _option = $.extend(argFun(), option);
            drawTable(_option, false);
        });
    }


    //点击事件
    function clickFun() {

        $(".goBtn").click(function () {
            var val = Number($(".go").val());           
            var curPage = Number($(".PageNavBtm .curPage").text());
            var lastPage = Number($(".PageNavBtm .lastPage").attr("mypage"));
            if (val == "" || val > lastPage+1 || val < 1 || isNaN(val) > 0 || val == curPage) { $(".go").val(""); return; }
            var option = {};
            option.pageindex = val-1;
            var _option = $.extend(argFun(), option);           
            drawTable(_option);
            $(".go").val("");

        });
        $(".liPage").click(function () {
            $(".go").val("");
            if ($(this).hasClass("canClick")) {
                var val = $(this).attr("mypage");
                var option = {};
                option.pageindex = val;
                var _option = $.extend(argFun(), option);
                drawTable(_option);
            }
        });
        $(".go").keydown(function (e) {
            var keyCode = e.keyCode ? e.keyCode : e.which ? e.which : e.charCode; //兼容IE 火狐 谷歌  
            if (keyCode == 13) {
                $(".goBtn").trigger("click");
                return false;
            }
        });

        $(".mobile-icon").mouseover(function () {
            $(".QRcode-div").show();
        });
        $(".mobile-icon").mouseout(function () {
            $(".QRcode-div").hide();
        });
    }

    //快速行情
    function loadQuote() {
        var options = {
            "id": stockEnity.stockId
        }

        var secid = getMarket() + '.' + getCode();

        // var _url = "//nuff.eastmoney.com/EM_Finance2015TradeInterface/JS.ashx?token=beb0a0047196124721f56b0f0ff5a27c";
        var url = 'http://push2.eastmoney.com/api/qt/stock/get?ut=fa5fd1943c7b386f172d6893dbfba10b&invt=2&fltt=2&fields=f1,f43,f57,f58,f169,f170,f46,f44,f51,f168,f47,f116,f60,f45,f52,f50,f48,f167,f117,f71,f161,f49,f162,f107,f86,f177,f127,f199,f128,f80,f152,f110,f111,f107,f285,f286,f262,f263,f256,f257,f269,f270&secid=' + secid;
        
        $.ajax({
            url: url,
            // data: options,
            dataType: "jsonp",
            jsonp: "cb",
            success: function (json) {
                // console.log(json)
                var items = json.data;

                if (!items || items.length == 0 || typeof items == "string") { return; }

                if(items) {
                    formatHead(json);
                    renderContent(items);
                    renderRong(items);

                    renderGenming();
                }
                
            }
        });
    }



    //sse
    function sseHeadData() {
        var secid = getMarket() + '.' + getCode();

        //正式地址
        var url = "http://" + (Math.floor(Math.random() * 99) + 1) +".push2.eastmoney.com/api/qt/stock/sse?ut=fa5fd1943c7b386f172d6893dbfba10b&invt=2&fltt=2&fields=f1,f43,f57,f58,f169,f170,f46,f44,f51,f168,f47,f116,f60,f45,f52,f50,f48,f167,f117,f71,f161,f49,f162,f107,f86,f177,f127,f199,f128,f80,f152,f110,f111,f107,f285,f286,f262,f263,f256,f257,f269,f270&secid=" + secid;


        var evtSource = new EventSource(url);
        evtSource.onmessage = function (msg) {
            var obj = JSON.parse(msg.data)
            var items = msg.data;

            if (obj.data) {
                formatHead(obj);

            }
        }
            

    }


    //head format
    var headSourceData;
    function formatHead(data) {
        // console.log(data);

        if(data.full == 1 && data.data){

            headSourceData = data.data;

        }
        else if(data.full == 0 && data.data ){   

            if(headSourceData) {
                
                headSourceData = marge(headSourceData, data.data);

            }
            
        }

        renderHead(headSourceData);
      
    }


    function renderHead(items) {
        var list = [
            { "name": "zxj", "item": items.f43  == "-" ? "-" : (items.f43).toFixed(items.f152), "color": getColor(items.f170) },
            { "name": "zde", "item": items.f169 == "-" ? "-" : (items.f169).toFixed(items.f152), "color": getColor(items.f170) },
            { "name": "zdf", "item": items.f170 == "-" ? "-" : (items.f170).toFixed(items.f152) + "%", "color": getColor(items.f170) },
            { "name": "jk", "item": items.f46 == "-" ? "-" : (items.f46).toFixed(items.f152), "color": getColor(items.f46 - items.f60) },
            { "name": "zs", "item": items.f60 == "-" ? "-" : (items.f60).toFixed(items.f152)},
            { "name": "zg", "item": items.f44 == "-" ? "-" : (items.f44).toFixed(items.f152), "color": getColor(items.f44 - items.f60) },
            { "name": "zd", "item": items.f45 == "-" ? "-" : (items.f45).toFixed(items.f152), "color": getColor(items.f45 - items.f60) },
            { "name": "zt", "item": items.f51 == "-" ? "-" : (items.f51).toFixed(2), "color": getColor(items.f51 - items.f60) },
            { "name": "dt", "item": items.f52 == "-" ? "-" : (items.f52).toFixed(2), "color": getColor(items.f52 - items.f60) },
            { "name": "hs", "item": items.f168 == "-" ? "-" : items.f168 + "%" },
            { "name": "lb", "item": items.f50 == "-" ? "-" : (items.f50).toFixed(2)},
            { "name": "cjl", "item": items.f47 == "-" ? "-" : NumbericFormat(items.f47) },
            { "name": "cje", "item": items.f48 == "-" ? "-" : NumbericFormat(items.f48) },
            { "name": "sy", "item": items.f162 == "-" ? "-" : (items.f162).toFixed(2)},
            { "name": "sj", "item": items.f167 == "-" ? "-" : (items.f167).toFixed(2)},
            { "name": "zsz", "item": items.f116 == "-" ? "-" : NumbericFormat(items.f116) },
            { "name": "ltsz", "item": items.f117 == "-" ? "-" : NumbericFormat(items.f117) }
        ];
        for (var i = 0; i < list.length; i++) {
            var name = $("#" + list[i].name);
            name.text(list[i].item);
            name.removeClass("red").removeClass("green").addClass(list[i].color);
        }

        //箭头颜色
        onChangeDataRender(items.f170);

        //时间
        if(items.f86) {
            var d = new Date(items.f86 * 1000);  //("0" + (d.getMonth() + 1)).slice(-2)    d.getMinutes()  d.getMinutes()  d.getSeconds()
            var whichDay = '';
            if(d.getDay() == 0) {
                whichDay = '星期天';
            } else if(d.getDay() == 1) {
                whichDay = '星期一';
            } else if(d.getDay() == 2) {
                whichDay = '星期二';
            } else if(d.getDay() == 3) {
                whichDay = '星期三';
            } else if(d.getDay() == 4) {
                whichDay = '星期四';
            } else if(d.getDay() == 5) {
                whichDay = '星期五';
            }else if(d.getDay() == 6) {
                whichDay = '星期六';
            }

            youWant = d.getFullYear() + '-' + (("0" + (d.getMonth() + 1)).slice(-2)) + '-' + (("0" + (d.getDate())).slice(-2)) +  ' ' + whichDay + ' ' + ("0" + (d.getHours())).slice(-2) + ':' + ("0" + (d.getMinutes())).slice(-2) + ':' + ("0" + (d.getSeconds())).slice(-2);
            
            $("#day").html('（' + youWant + '）');
        }

        //判断若字数过长  字体变小
        if(items.f43 >= 1000) {
            $("#zxj").css("font-size", "23px")
            
        }

    }


    function renderContent(items) {
        var obj = {
            "market": items.f107,
            "code": items.f57,
            "name": items.f58,
            "id": items.f107 + items.f57,
            "time": '111'
        }
       


        $(".n1").attr("href", "http://data.eastmoney.com/zlsj/detail/" + obj["code"] + "-1.html");

        if(obj["name"]) {
            $(".n2").text("查看" + obj["name"] + "买卖点");
            $(".n3").text(obj["name"] + "股价预警")
            $(".quote_title_0").text(obj["name"]);
        }
        


        $(".quote_title_1").text(obj["code"]);
        var src = "//pifm3.eastmoney.com/EM_Finance2014PictureInterface/RC.ashx?url=http://m.quote.eastmoney.com/stock," + obj["code"] + ".shtml";
        $(".QRcode-div img").attr("src", src);
        
        
        //ie8
        if(obj["code"] && obj["name"]) {
            // $("title").text(obj["name"] + obj["code"] + "股票价格_行情_走势图—东方财富网");
            document.title = obj["name"] + obj["code"] + "股票价格_行情_走势图—东方财富网";
        }
       

    }

    function renderRong(items) {
         //融 和港股通
        // if(items.f177 & 64) {
        //     $(".rongi").show();
        //     $(".rongi a").attr("href", "http://data.eastmoney.com/rzrq/detail/" + items.f57 + ".html");
        // } else {
        //     $(".rongi").hide();
        // }
        // if (items.f177 & 1024) {
        //     $("#sgt_icon").show();
        //     $("#hgt_icon").hide();
        // } else if (items.f177 & 512){
        //     $("#sgt_icon").hide();
        //     $("#hgt_icon").show();
        // }


        if (items.f110 == 1 && items.f111 == 2) {
            $("#jys-box").show().find("b ").text("沪主板");
            $("#jys-box").attr("title", "该股票在沪主板上市");
            $("#jys-box").find("a").attr("href", "//quote.eastmoney.com/center/gridlist.html#sh_a_board")
        }
        if (items.f110 == 0 && items.f111 == 6) {
            $("#jys-box").show().find("b ").text("深主板");
            $("#jys-box").attr("title", "该股票在深主板上市");
            $("#jys-box").find("a").attr("href", "//quote.eastmoney.com/center/gridlist.html#sz_a_board")
        }
        if (items.f107 == 0 && items.f111 == 13) {
            $("#jys-box").show().find("b ").text("中小板");
            $("#jys-box").attr("title", "该股票在中小板上市");
            $("#jys-box").find("a").attr("href", "//quote.eastmoney.com/center/gridlist.html#sme_board")
        }
        if (items.f107 == 0 && items.f111 == 80) {
            $("#jys-box").show().find("b ").text("创业板");
            $("#jys-box").attr("title", "该股票在创业板上市");
            $("#jys-box").find("a").attr("href", "//quote.eastmoney.com/center/gridlist.html#gem_board")
        }
        if ((items.f177) & 512) {
            $("#hgt_icon").show()
        } else {
            if ((items.f177) & 1024) {
                $("#sgt_icon").show()
            }
        }
        if(items.f107 == 1 && items.f111 == 23) {
            $("#kcb").show()
        }else {
            $("#kcb").hide()
        }
        

        if ((items.f177) & 64) {
            $("#rong").show();
            $("#rong a").attr("href", "http://data.eastmoney.com/rzrq/detail/" + items.f57 + ".html");
        } else {
            $("#rong").hide()
        }
        if (items.f177 & 32768) {
            $("#hlt").show().find("b ").text("沪伦通");
            $("#hlt").attr("title", "该股票为沪伦通标的");
            $("#hlt").find("a").attr("href", "http://quote.eastmoney.com/uk/" + items.f286 + "." + items.f285 + ".html");
            $("#GDR").show().find("b ").text("GDR");
            $("#GDR").attr("title", "该股票存在关联的GDR（全球存托凭证）");
            $("#GDR").find("a").attr("href", "http://quote.eastmoney.com/uk/" + items.f286 + "." + items.f285 + ".html")
        }
        var marketzhai = items.f263 == "1" ? "sh" : "sz";
        if (items.f262 && items.f262 != "-") {
            $("#Z-box").show().find("b").text("可转债");
            $("#Z-box").attr("title", "点击查看关联可转债行情");
            $("#Z-box").find("a").attr("href", "http://quote.eastmoney.com/bond/" + marketzhai + items.f262 + ".html")
        } else {
            $("#Z-box").hide()
        }
        var marketH = items.f257;
        if (items.f256 && items.f256 != "-") {
            $("#H-box").show().find("b").text("H股");
            $("#H-box").attr("title", "点击查看关联H股行情");
            $("#H-box").find("a").attr("href", "http://quote.eastmoney.com/unify/r/" + marketH + "." + items.f256)
        } else {
            $("#H-box").hide()
        }
        var marketB = items.f270 == "1" ? "sh" : "sz";
        if (items.f269 && items.f269 != "-") {
            $("#B-box").show().find("b ").text("B股");
            $("#B-box").attr("title", "点击查看关联B股行情");
            $("#B-box").find("a").attr("href", "http://quote.eastmoney.com/" + marketB + items.f269 + ".html")
        } else {
            $("#B-box").hide()
        }


        //


    }

    //更名
    function renderGenming() {
        var _this = this;
        var code = getCode();
        $.ajax({
            url: "http://dcfm.eastmoney.com/em_mutisvcexpandinterface/api/js/get?type=ABLS_MB&token=70f12f2f4f091e459a279469fe49eca5&filter=(scode=%27" + code + "%27)&st=changedate",
            dataType: "jsonp",
            scriptCharset: "utf-8",
            accept: "json",
            success: function(json) {
                if (json.length > 1) {
                    $("#stock_change_name").show();
                    $("#stock_change_name .rongi").css("display", "block");
                    var html = "<span class=usedName>" + json[0].sname + "</span> <span class='usedName'>&gt;&gt;&gt;</span>";
                    for (var i = 1; i < json.length - 1; i++) {
                        html += '<span class="usedName">' + json[i].sname + '<span class="hasDate">(' + json[i].changedate.substring(0, 9).replace(/\//g, "-") + ")</span></span><span class='usedName'>&gt;&gt;&gt;</span>"
                    }
                    html += '<span class="usedName">' + json[json.length - 1].sname + '<span class="hasDate">(' + json[json.length - 1].changedate.substring(0, 9).replace(/\//g, "-") + ")</span></span>";
                    $("#stock_change_name .shorthandInfo").html(html)

                    $("#stock_change_name").hover(function() {
                        // console.log('777');
                        $(".comNameExInfo").show();
                        $(".arrowUp").show();
                    }, function() {
                        $(".comNameExInfo").hide();
                    })

                    $(".closeBtn").click(function() {
                        $(".comNameExInfo").hide();
                    })
                }
            }
        })

    }


    function onChangeDataRender(item) {
        
        if (item != 0 && item != "-") {
            if (item > 0) {
                $("#arrow-find").removeClass("down-arrow").addClass("up-arrow");

            } else {
                $("#arrow-find").removeClass("up-arrow").addClass("down-arrow");
            }
        } 

        if(item == 0){
            $("#arrow-find").removeClass("up-arrow").removeClass("down-arrow");
        }

      
        
    }


    function getParam(name) {
        var urlpara = location.search;
        var par = {};
        if (urlpara != "") {
            urlpara = urlpara.substring(1, urlpara.length);
            var para = urlpara.split("&");
            var parname;
            var parvalue;
            for (var i = 0; i < para.length; i++) {
                parname = para[i].substring(0, para[i].indexOf("="));
                parvalue = para[i].substring(para[i].indexOf("=") + 1, para[i].length);
                par[parname] = parvalue;
            }
        }
        if (typeof (par[name]) != "undefined") {
            return par[name];
        } else {
            return null;
        }
    }

    //获取code和market
    function getCode() {
        var code;
        if(getParam('code')) {
            code = getParam('code');
        }else if(getParam('newcode')) {
            code = getParam('newcode').split('.')[1];
        } else if(getParam('id')) {
            code = getParam('id').substr(0,6);
           
        }

        return code;
    }
    function getMarket() {
        var market;
        if(getParam('market')) {
            var newmarket = getParam('market') == 2 ? 0 : 1;
            market = newmarket;
        }else if(getParam('newcode')) {
            market = getParam('newcode').split('.')[0];
        }else if(getParam('id')) {
            market = getParam('id').substr(6);
            var newmarket = market == 2 ? 0 : 1;

            market = newmarket;
            
        }
        return market
    }


    function gw_now(time, id) {
        var str = time.replace(/-/g, "/");
        var _date = new Date(str);
        var year = _date.getFullYear();
        var month = gw_now_addzero(_date.getMonth() + 1);
        var day = gw_now_addzero(_date.getDate());
        var hour = gw_now_addzero(_date.getHours());
        var minute = gw_now_addzero(_date.getMinutes());
        var second = gw_now_addzero(_date.getSeconds());
        var week = "";
        switch (_date.getDay()) {
            case 0: week = "星期天"; break
            case 1: week = "星期一"; break
            case 2: week = "星期二"; break
            case 3: week = "星期三"; break
            case 4: week = "星期四"; break
            case 5: week = "星期五"; break
            case 6: week = "星期六"; break
        }
        var Time = year + "-" + month + "-" + day + " " + week + " " + hour + ":" + minute + ":" + second;
        $(id).html('(' + Time + ')')
    }
    function gw_now_addzero(temp) {
        if (temp < 10) return "0" + temp;
        else return temp;
    }
    function getColor(str) {
        var context = str.toString();
        context = context.replace("%", "");
        if (context == 0 || isNaN(context)) {
            return "";
        } else if (context > 0) {
            return "red";
        } else {
            return "green";
        }
    }

    //融和沪深股通
    function isRong() {
        var _url = "//nufm.dfcfw.com/EM_Finance2014NumericApplication/JS.aspx?type=CT&sty=MCSS&st=z&js=((x))&token=883df69e21fd8fe57ebf53dd71aae25f&cmd=" + stockEnity.stockId
        $.ajax({
            url: _url,
            dataType: "jsonp",
            jsonp: "cb",
            success: function (json) {              
                if (typeof json !== "string") return;
                var data = json.split(",");
                if (data[4] == "深股通") {
                    $("#sgt_icon").show();
                    $("#hgt_icon").hide();
                } else if (data[4] == "沪股通"){
                    $("#sgt_icon").hide();
                    $("#hgt_icon").show();
                }
                if (data[5] == "True") {
                    $(".rongi").show();
                    $(".rongi a").attr("href", "http://data.eastmoney.com/rzrq/detail/" + data[1] + ".html");
                } else {
                    $(".rongi").hide();
                }

            }

        })
    }

    function NumbericFormat(string) {
        var context = Number(string);
        //var fushu = false;
        if (!isNaN(context)) {
            var item = parseInt(string);
            if ((item > 0 && item < 1e4) || (item < 0 && item > -1e4)) {
                return item;
            } else if ((item > 0 && item < 1e6) || (item < 0 && item > -1e6)) {
                item = item / 10000;
                return item.toFixed(2) + "万";
            } else if ((item > 0 && item < 1e7) || (item < 0 && item > -1e7)) {
                item = item / 10000;
                return item.toFixed(1) + "万";
            } else if ((item > 0 && item < 1e8) || (item < 0 && item > -1e8)) {
                item = item / 10000;
                return item.toFixed(0) + "万";
            } else if ((item > 0 && item < 1e10) || (item < 0 && item > -1e10)) {
                item = item / 1e8;
                return item.toFixed(2) + "亿";
            } else if ((item > 0 && item < 1e11) || (item < 0 && item > -1e11)) {
                item = item / 1e8;
                return item.toFixed(1) + "亿";
            } else if ((item > 0 && item < 1e12) || (item < 0 && item > -1e12)) {
                item = item / 1e8;
                return item.toFixed(0) + "亿";
            } else if ((item > 0 && item < 1e14) || (item < 0 && item > -1e14)) {
                item = item / 1e12;
                return item.toFixed(2) + "万亿";
            } else if ((item > 0 && item < 1e15) || (item < 0 && item > -1e15)) {
                item = item / 1e12;
                return item.toFixed(1) + "万亿";
            } else if ((item > 0 && item < 1e16) || (item < 0 && item > -1e16)) {
                item = item / 1e12;
                return item.toFixed(0) + "万亿";
            } else {
                return item;
            }
        }
        return context.toString();
    }

/***/ }),

/***/ "./src/modules/template/index.js":
/*!***************************************!*\
  !*** ./src/modules/template/index.js ***!
  \***************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

var __WEBPACK_AMD_DEFINE_RESULT__;/*!art-template - Template Engine | http://aui.github.com/artTemplate/*/
!function(){function a(a){return a.replace(t,"").replace(u,",").replace(v,"").replace(w,"").replace(x,"").split(y)}function b(a){return"'"+a.replace(/('|\\)/g,"\\$1").replace(/\r/g,"\\r").replace(/\n/g,"\\n")+"'"}function c(c,d){function e(a){return m+=a.split(/\n/).length-1,k&&(a=a.replace(/\s+/g," ").replace(/<!--[\w\W]*?-->/g,"")),a&&(a=s[1]+b(a)+s[2]+"\n"),a}function f(b){var c=m;if(j?b=j(b,d):g&&(b=b.replace(/\n/g,function(){return m++,"$line="+m+";"})),0===b.indexOf("=")){var e=l&&!/^=[=#]/.test(b);if(b=b.replace(/^=[=#]?|[\s;]*$/g,""),e){var f=b.replace(/\s*\([^\)]+\)/,"");n[f]||/^(include|print)$/.test(f)||(b="$escape("+b+")")}else b="$string("+b+")";b=s[1]+b+s[2]}return g&&(b="$line="+c+";"+b),r(a(b),function(a){if(a&&!p[a]){var b;b="print"===a?u:"include"===a?v:n[a]?"$utils."+a:o[a]?"$helpers."+a:"$data."+a,w+=a+"="+b+",",p[a]=!0}}),b+"\n"}var g=d.debug,h=d.openTag,i=d.closeTag,j=d.parser,k=d.compress,l=d.escape,m=1,p={$data:1,$filename:1,$utils:1,$helpers:1,$out:1,$line:1},q="".trim,s=q?["$out='';","$out+=",";","$out"]:["$out=[];","$out.push(",");","$out.join('')"],t=q?"$out+=text;return $out;":"$out.push(text);",u="function(){var text=''.concat.apply('',arguments);"+t+"}",v="function(filename,data){data=data||$data;var text=$utils.$include(filename,data,$filename);"+t+"}",w="'use strict';var $utils=this,$helpers=$utils.$helpers,"+(g?"$line=0,":""),x=s[0],y="return new String("+s[3]+");";r(c.split(h),function(a){a=a.split(i);var b=a[0],c=a[1];1===a.length?x+=e(b):(x+=f(b),c&&(x+=e(c)))});var z=w+x+y;g&&(z="try{"+z+"}catch(e){throw {filename:$filename,name:'Render Error',message:e.message,line:$line,source:"+b(c)+".split(/\\n/)[$line-1].replace(/^\\s+/,'')};}");try{var A=new Function("$data","$filename",z);return A.prototype=n,A}catch(B){throw B.temp="function anonymous($data,$filename) {"+z+"}",B}}var d=function(a,b){return"string"==typeof b?q(b,{filename:a}):g(a,b)};d.version="3.0.0",d.config=function(a,b){e[a]=b};var e=d.defaults={openTag:"<%",closeTag:"%>",escape:!0,cache:!0,compress:!1,parser:null},f=d.cache={};d.render=function(a,b){return q(a)(b)};var g=d.renderFile=function(a,b){var c=d.get(a)||p({filename:a,name:"Render Error",message:"Template not found"});return b?c(b):c};d.get=function(a){var b;if(f[a])b=f[a];else if("object"==typeof document){var c=document.getElementById(a);if(c){var d=(c.value||c.innerHTML).replace(/^\s*|\s*$/g,"");b=q(d,{filename:a})}}return b};var h=function(a,b){return"string"!=typeof a&&(b=typeof a,"number"===b?a+="":a="function"===b?h(a.call(a)):""),a},i={"<":"&#60;",">":"&#62;",'"':"&#34;","'":"&#39;","&":"&#38;"},j=function(a){return i[a]},k=function(a){return h(a).replace(/&(?![\w#]+;)|[<>"']/g,j)},l=Array.isArray||function(a){return"[object Array]"==={}.toString.call(a)},m=function(a,b){var c,d;if(l(a))for(c=0,d=a.length;d>c;c++)b.call(a,a[c],c,a);else for(c in a)b.call(a,a[c],c)},n=d.utils={$helpers:{},$include:g,$string:h,$escape:k,$each:m};d.helper=function(a,b){o[a]=b};var o=d.helpers=n.$helpers;d.onerror=function(a){var b="Template Error\n\n";for(var c in a)b+="<"+c+">\n"+a[c]+"\n\n";"object"==typeof console&&console.error(b)};var p=function(a){return d.onerror(a),function(){return"{Template Error}"}},q=d.compile=function(a,b){function d(c){try{return new i(c,h)+""}catch(d){return b.debug?p(d)():(b.debug=!0,q(a,b)(c))}}b=b||{};for(var g in e)void 0===b[g]&&(b[g]=e[g]);var h=b.filename;try{var i=c(a,b)}catch(j){return j.filename=h||"anonymous",j.name="Syntax Error",p(j)}return d.prototype=i.prototype,d.toString=function(){return i.toString()},h&&b.cache&&(f[h]=d),d},r=n.$each,s="break,case,catch,continue,debugger,default,delete,do,else,false,finally,for,function,if,in,instanceof,new,null,return,switch,this,throw,true,try,typeof,var,void,while,with,abstract,boolean,byte,char,class,const,double,enum,export,extends,final,float,goto,implements,import,int,interface,long,native,package,private,protected,public,short,static,super,synchronized,throws,transient,volatile,arguments,let,yield,undefined",t=/\/\*[\w\W]*?\*\/|\/\/[^\n]*\n|\/\/[^\n]*$|"(?:[^"\\]|\\[\w\W])*"|'(?:[^'\\]|\\[\w\W])*'|\s*\.\s*[$\w\.]+/g,u=/[^\w$]+/g,v=new RegExp(["\\b"+s.replace(/,/g,"\\b|\\b")+"\\b"].join("|"),"g"),w=/^\d[^,]*|,\d[^,]*/g,x=/^,+|,+$/g,y=/^$|,+/;e.openTag="{{",e.closeTag="}}";var z=function(a,b){var c=b.split(":"),d=c.shift(),e=c.join(":")||"";return e&&(e=", "+e),"$helpers."+d+"("+a+e+")"};e.parser=function(a){a=a.replace(/^\s/,"");var b=a.split(" "),c=b.shift(),e=b.join(" ");switch(c){case"if":a="if("+e+"){";break;case"else":b="if"===b.shift()?" if("+b.join(" ")+")":"",a="}else"+b+"{";break;case"/if":a="}";break;case"each":var f=b[0]||"$data",g=b[1]||"as",h=b[2]||"$value",i=b[3]||"$index",j=h+","+i;"as"!==g&&(f="[]"),a="$each("+f+",function("+j+"){";break;case"/each":a="});";break;case"echo":a="print("+e+");";break;case"print":case"include":a=c+"("+b.join(",")+");";break;default:if(/^\s*\|\s*[\w\$]/.test(e)){var k=!0;0===a.indexOf("#")&&(a=a.substr(1),k=!1);for(var l=0,m=a.split("|"),n=m.length,o=m[l++];n>l;l++)o=z(o,m[l]);a=(k?"=":"=#")+o}else a=d.helpers[c]?"=#"+c+"("+b.join(",")+");":"="+a}return a}, true?!(__WEBPACK_AMD_DEFINE_RESULT__ = (function(){return d}).call(exports, __webpack_require__, exports, module),
				__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__)):undefined}();

/***/ })

/******/ });
//# sourceMappingURL=timetrade.js.map'''

